proc temperature {} {

    #   dg_reg_read(MISC_REG_GENERIC_CR_0, &shmem2_base);
    set shmem2_base [reg read 0xa460]
    # OFFSETOF(shmem2_region_t,  temperature_in_half_celsius) == 0xd4
    # check for valid shmem2 and size includes temperature field
    if {$shmem2_base != 0 && [reg read $shmem2_base] > 0xd4 } {
    	puts "Current On-Card Temperature is [format %5.2f [expr [reg read [expr $shmem2_base + 0xd4]] / 2.0]]"
    } else {
    	puts "Current On-Card Temperature not supported in this version of MFW"
    }

    # Check for 84833 PHY.
    set port [_access_phy::lookup_port]
    set id [extphy $port 1 3]
    if {($id == 0x5cb0) || ($id == 0x5cb3) || ($id == 0x5cb4)} {
        # Found 84833, get PHY temperature.
        if {[reg read $shmem2_base] > 0x110 } {
            set temp [reg read [expr $shmem2_base + 0x110]]
            set temp [expr $temp & 0xffff]
    	    puts "84833 PHY Temperature is [format %d $temp]"
        } else {
            puts "84833 found, but this MFW doesn't support temperature reporting."
        }
    }
}

