##########################################################
# idle_chk_all.tcl                     	        	#
#							#
# Copyright(c) 2011-2014 Broadcom Corporation		#
# Copyright(c) 2014-2015 QLogic Corporation		#
# Proprietary and Confidential Information.      	#
#							#
# Module Description:					#
# The script runs idle_chk on all devices               #
#							#
#########################################################



# -----------------------------------------------------------------
# This procedure performs idle_chk on all functions/paths
# -----------------------------------------------------------------
proc idle_chk_all {args} {                     
               
        if {[info exists ::sys(NO_PCI)]} {
            set read_via_no_pci $::sys(NO_PCI)
        } else {
            set read_via_no_pci [regexp {NO_PCI} $::tcl_prompt1]
        }                                    
        
        
	if {!$read_via_no_pci} {
		set no_functions $::current(TOTAL_DEV)	
	
		for {set func 0} {$func < $no_functions} {incr func} {
                        puts " ----------------------------------------------"
			puts "Running idle_chk on device no. [expr {$func+1}]"
                        puts "-----------------------------------------------"
			device [expr {$func+1}]
			idle_chk 			
		}
		
		#return to first device
		device 1
	} else {
           puts "idle_chk_all is not supported in ediag NO_PCI mode. Please use edebug tool."           
        }
	
        return 0	
}

