proc tx_demp { {lane 0} {pre 0} {post 0} {main 0} } {
	
	if {![is_e3]} {
		puts "This utility runs over 578xx only!"
		return -1
	}
	
	set FIR_REG 0x82E2
		
	# Pause the uController 
	# e3_pause_wc_uc
	
	# write to the register
	# 3:0 -> Pre Cursor
	# 9:4 -> Main 
	# 14:10 -> Post Cursor
	# 15 -> Enable forcing of these values
	wc_phy $lane 3 $FIR_REG [expr ($pre << 0) | ($post << 10) | ($main << 4) | (1 << 15)]	
}

proc tx_amp { {lane 0} {idriver 9} } {

	if {![is_e3]} {
		puts "This utility runs over 578xx only!"
		return -1
	}
	
	switch $lane {
		0       { set TXD_REG 0x8067 }
		1       { set TXD_REG 0x8077 }
		2       { set TXD_REG 0x8087 }
		3       { set TXD_REG 0x8097 }
		4       { set TXD_REG 0x80A7 }
		default { set TXD_REG 0x80A7 }  
	}
	
	# Pause the uController 
	# e3_pause_wc_uc
	
	# write to the register
	# 11:8 -> Idriver
	# 7:4 -> Ipredriver

	switch $idriver {

		0 {set ipredriver 5}
		1 {set ipredriver 5}
		2 {set ipredriver 6}
		3 {set ipredriver 6}
		4 {set ipredriver 7}
		5 {set ipredriver 7}
		6 {set ipredriver 8}
		7 {set ipredriver 8}
		8 {set ipredriver 9}
		9 {set ipredriver 9}
		10 {set ipredriver 10}
		11 {set ipredriver 10}
		12 {set ipredriver 11}
		13 {set ipredriver 11}
		14 {set ipredriver 12}
		15 {set ipredriver 12}
                default { puts "iDriver must be 0 to 15" break }
        }
        set orig_val [wc_phy $lane 3 $TXD_REG]
	wc_phy 0 3 $TXD_REG [expr ($orig_val & 0xF00F) | ($idriver << 8) | ($ipredriver << 4)]	
}

proc pause_wc_uc {} {
	
	if {![is_e3]} {
		puts "This utility runs over 578xx only!"
		return -1
	}

	set FW_REG 0x820E
	
	# poll to see if the Ready for command (bit 7) is set
	set fw_data [wc_phy 0 3 $FW_REG]
	set rfc [expr (($fw_data & 0x80) >> 7) ]
	while {$rfc != 1} {
		set fw_data [wc_phy 0 3 $FW_REG]
		set rfc [expr (($fw_data & 0x80) >> 7) ]
	}
	
	# Gracefully stop the uController
	# Command code [3:0] = 1
	# supplement information [15:8] = 0
	# clear bits 7 and 6
	wc_phy 0 3 $FW_REG [expr (1 << 0)]
	
	# poll to see if the Ready for command (bit 7) is set
	set fw_data [wc_phy 0 3 $FW_REG]
	set rfc [expr (($fw_data & 0x80) >> 7) ]
	while {$rfc != 1} {
		set fw_data [wc_phy 0 3 $FW_REG]
		set rfc [expr (($fw_data & 0x80) >> 7) ]
		set err [expr (($fw_data & 0x40) >> 6) ]
		if {$err == 1} {
			puts "Error found during pausing the uController"
		}
		set rc [expr (($fw_data & 0xFF00) >> 8) ]
		if {$rc != 0} {
			puts "Unexpected return code $rc"
		}
	}
}

set help_info     "Changes XFI/SFI Tx Pre-emphasis settings\n"
append help_info  "Usage: tx_demp <post> <pre> <main>\n"    
add_help tx_demp  $help_info

set help_info     "Changes XFI/SFI Tx Pre-emphasis settings\n"
append help_info  "Usage: tx_ampl <idriver>\n"    
add_help tx_ampl $help_info

