/****************************************************************************
 * Copyright(c) 2001-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 * Name:        decode_dev_info.c
 *
 * Description: Decode structures in dev_info.h 
 *
 * Created:     File generated from ..\..\..\..\hsi\mcp\dev_info.h in 3/26/2010 dlau
 *     !!! Majority of the code is script generated. 
 *    Avoid modifying this file manually. Consult David Lau for help. 
 *
 ****************************************************************************/

#include  <stdio.h>
#include  <ctype.h>
#include  <stdlib.h>
#include  <string.h>
#include "tcl.h"
#include "bcmtype.h"
#include "dev_info.h"


u32_t indent_level;

#ifndef INDENT_STRUCT
#define INDENT_STRUCT(tab_cnt) \
{\
	u32_t tab_index;\
	for (tab_index = 0; tab_index < tab_cnt; tab_index++) SPECIAL_DBG_TAB; \
}

#define STRUCT_PRINT(x)      INDENT_STRUCT(indent_level); SPECIAL_DBG_PRINT(x);
#endif // INDENT_STRUCT

static char disp_str[1000];
#ifndef SPECIAL_DBG_PRINT
#define SPECIAL_DBG_PRINT(x)   \
{\
	sprintf x;\
	Tcl_AppendStringsToObj( rc_ptr, disp_str, NULL); \
}
#endif // SPECIAL_DBG_PRINT
#ifndef SPECIAL_DBG_TAB
#define SPECIAL_DBG_TAB  Tcl_AppendStringsToObj( rc_ptr, "\t", NULL) 
#endif // SPECIAL_DBG_TAB

/*****************************************************************************

FUNCTION:       DecodeSharedHwCfg

DESCRIPTION:    This routine decode the structure/union struct shared_hw_cfg

IN PARAMETERS:  pointer to struct shared_hw_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeSharedHwCfg(Tcl_Obj* rc_ptr, const struct shared_hw_cfg * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "part_num[0 .. %d] = ", (16) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->part_num)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->part_num)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "\t\""));
	for (index = 0; ((16) & 0x3) ==0 &&index < (16)/sizeof(u32_t); index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->part_num)[index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", (char)(temp>>24), (char)(temp>>16), (char)(temp>>8), (char)temp));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));
	STRUCT_PRINT((disp_str,  "config = 0x%x\n", (u32_t)(data->config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_MDIO_VOLTAGE  = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_MDIO_VOLTAGE_MASK)>>0));
	if ((data->config & SHARED_HW_CFG_MDIO_VOLTAGE_MASK) == SHARED_HW_CFG_MDIO_VOLTAGE_1_2V) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDIO_VOLTAGE_1_2V)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MDIO_VOLTAGE_MASK) == SHARED_HW_CFG_MDIO_VOLTAGE_2_5V) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDIO_VOLTAGE_2_5V)\n")); 
	}
	
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PORT_SWAP     = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_PORT_SWAP)>>2));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_BEACON_WOL_EN = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_BEACON_WOL_EN)>>3));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_MFW_SELECT    = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_MFW_SELECT_MASK)>>8));
	if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_DEFAULT)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_NC_SI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_NC_SI)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_UMP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_UMP)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_IPMI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_IPMI)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_SPIO4_NC_SI_IPMI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_SPIO4_NC_SI_IPMI)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_SPIO4_UMP_IPMI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_SPIO4_UMP_IPMI)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_MFW_SELECT_MASK) == SHARED_HW_CFG_MFW_SELECT_SPIO4_NC_SI_UMP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MFW_SELECT_SPIO4_NC_SI_UMP)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_LED_MODE      = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_LED_MODE_MASK)>>16));
	if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_MAC1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_MAC1)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY1)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY2) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY2)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY3) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY3)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_MAC2) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_MAC2)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY4) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY4)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY5) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY5)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY6) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY6)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_MAC3) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_MAC3)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY7) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY7)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY9) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY9)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY11) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY11)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_MAC4) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_MAC4)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_LED_MODE_MASK) == SHARED_HW_CFG_LED_PHY8) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LED_PHY8)\n")); 
	}
    STRUCT_PRINT((disp_str,  "\tHW_CFG_SRIOV         = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_SRIOV_MASK)>>30));
	if ((data->config & SHARED_HW_CFG_SRIOV_MASK) == SHARED_HW_CFG_SRIOV_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SRIOV_DISABLED)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_SRIOV_MASK) == SHARED_HW_CFG_SRIOV_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SRIOV_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_ATC           = 0x%x \n", (u32_t)(data->config & SHARED_HW_CFG_ATC_MASK)>>31));
	if ((data->config & SHARED_HW_CFG_ATC_MASK) == SHARED_HW_CFG_ATC_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ATC_DISABLED)\n")); 
	}
	else if ((data->config & SHARED_HW_CFG_ATC_MASK) == SHARED_HW_CFG_ATC_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ATC_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "config2 = 0x%x\n", (u32_t)(data->config2)));	
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCIE_GEN2_ENABLED = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_PCIE_GEN2_ENABLED)>>8));
	if ((data->config2 & SHARED_HW_CFG_PCIE_GEN2_ENABLED) == SHARED_HW_CFG_PCIE_GEN2_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PCIE_GEN2_DISABLED)\n")); 
	}
    STRUCT_PRINT((disp_str,  "\tHW_CFG_SMBUS_TIMING  = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_SMBUS_TIMING_MASK)>>12));
	if ((data->config2 & SHARED_HW_CFG_SMBUS_TIMING_MASK) == SHARED_HW_CFG_SMBUS_TIMING_100KHZ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SMBUS_TIMING_100KHZ)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_SMBUS_TIMING_MASK) == SHARED_HW_CFG_SMBUS_TIMING_400KHZ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SMBUS_TIMING_400KHZ)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_HIDE_PORT1    = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_HIDE_PORT1)>>13));
	
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SPIO4_FOLLOW_PERST = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_SPIO4_FOLLOW_PERST_MASK)>>15));
	if ((data->config2 & SHARED_HW_CFG_SPIO4_FOLLOW_PERST_MASK) == SHARED_HW_CFG_SPIO4_FOLLOW_PERST_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPIO4_FOLLOW_PERST_DISABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_SPIO4_FOLLOW_PERST_MASK) == SHARED_HW_CFG_SPIO4_FOLLOW_PERST_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPIO4_FOLLOW_PERST_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCIE_GEN2_PREEMPHASIS = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_MASK)>>16));
	if ((data->config2 & SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_MASK) == SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_HW) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PCIE_GEN2_PREEMPHASIS_HW)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_MASK) == SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_0DB) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PCIE_GEN2_PREEMPHASIS_0DB)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_MASK) == SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_3_5DB) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PCIE_GEN2_PREEMPHASIS_3_5DB)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_MASK) == SHARED_HW_CFG_PCIE_GEN2_PREEMPHASIS_6_0DB) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PCIE_GEN2_PREEMPHASIS_6_0DB)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_FAN_FAILURE   = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_FAN_FAILURE_MASK)>>19));
	if ((data->config2 & SHARED_HW_CFG_FAN_FAILURE_MASK) == SHARED_HW_CFG_FAN_FAILURE_PHY_TYPE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FAN_FAILURE_PHY_TYPE)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_FAN_FAILURE_MASK) == SHARED_HW_CFG_FAN_FAILURE_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FAN_FAILURE_DISABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_FAN_FAILURE_MASK) == SHARED_HW_CFG_FAN_FAILURE_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FAN_FAILURE_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_ASPM_SUPPORT  = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_ASPM_SUPPORT_MASK)>>21));
	if ((data->config2 & SHARED_HW_CFG_ASPM_SUPPORT_MASK) == SHARED_HW_CFG_ASPM_SUPPORT_L0S_L1_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ASPM_SUPPORT_L0S_L1_ENABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_ASPM_SUPPORT_MASK) == SHARED_HW_CFG_ASPM_SUPPORT_L0S_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ASPM_SUPPORT_L0S_DISABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_ASPM_SUPPORT_MASK) == SHARED_HW_CFG_ASPM_SUPPORT_L1_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ASPM_SUPPORT_L1_DISABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_ASPM_SUPPORT_MASK) == SHARED_HW_CFG_ASPM_SUPPORT_L0S_L1_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_ASPM_SUPPORT_L0S_L1_DISABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PREVENT_L1_ENTRY = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_PREVENT_L1_ENTRY_MASK)>>23));
	if ((data->config2 & SHARED_HW_CFG_PREVENT_L1_ENTRY_MASK) == SHARED_HW_CFG_PREVENT_L1_ENTRY_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PREVENT_L1_ENTRY_DISABLED)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_PREVENT_L1_ENTRY_MASK) == SHARED_HW_CFG_PREVENT_L1_ENTRY_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PREVENT_L1_ENTRY_ENABLED)\n")); 
	}
    	
	STRUCT_PRINT((disp_str,  "\tHW_CFG_MDC_MDIO_ACCESS1 = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK)>>26));
	if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS1_PHY_TYPE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS1_PHY_TYPE)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS1_EMAC0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS1_EMAC0)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS1_EMAC1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS1_EMAC1)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS1_BOTH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS1_BOTH)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS1_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS1_SWAPPED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS1_SWAPPED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_MDC_MDIO_ACCESS2 = 0x%x \n", (u32_t)(data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK)>>29));
	if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS2_PHY_TYPE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS2_PHY_TYPE)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS2_EMAC0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS2_EMAC0)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS2_EMAC1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS2_EMAC1)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS2_BOTH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS2_BOTH)\n")); 
	}
	else if ((data->config2 & SHARED_HW_CFG_MDC_MDIO_ACCESS2_MASK) == SHARED_HW_CFG_MDC_MDIO_ACCESS2_SWAPPED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_MDC_MDIO_ACCESS2_SWAPPED)\n")); 
	}
    STRUCT_PRINT((disp_str,  "ump_nc_si_config = 0x%x\n", (u32_t)(data->ump_nc_si_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_UMP_NC_SI_MII_MODE = 0x%x \n", (u32_t)(data->ump_nc_si_config & SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MASK)>>0));
	if ((data->ump_nc_si_config & SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MASK) == SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MAC) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_UMP_NC_SI_MII_MODE_MAC)\n")); 
	}
	else if ((data->ump_nc_si_config & SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MASK) == SHARED_HW_CFG_UMP_NC_SI_MII_MODE_PHY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_UMP_NC_SI_MII_MODE_PHY)\n")); 
	}
	else if ((data->ump_nc_si_config & SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MASK) == SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MII) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_UMP_NC_SI_MII_MODE_MII)\n")); 
	}
	else if ((data->ump_nc_si_config & SHARED_HW_CFG_UMP_NC_SI_MII_MODE_MASK) == SHARED_HW_CFG_UMP_NC_SI_MII_MODE_RMII) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_UMP_NC_SI_MII_MODE_RMII)\n")); 
	}   	
	STRUCT_PRINT((disp_str,  "board = 0x%x\n", (u32_t)(data->board)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_BOARD_REV     = 0x%x \n", (u32_t)(data->board & SHARED_HW_CFG_BOARD_REV_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_BOARD_MAJOR_VER = 0x%x \n", (u32_t)(data->board & SHARED_HW_CFG_BOARD_MAJOR_VER_MASK)>>24));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_BOARD_MINOR_VER = 0x%x \n", (u32_t)(data->board & SHARED_HW_CFG_BOARD_MINOR_VER_MASK)>>28));
	STRUCT_PRINT((disp_str,  "wc_lane_config = 0x%x\n", (u32_t)(data->wc_lane_config)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeSharedHwCfg

/*****************************************************************************

FUNCTION:       DecodePortHwCfg

DESCRIPTION:    This routine decode the structure/union struct port_hw_cfg

IN PARAMETERS:  pointer to struct port_hw_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodePortHwCfg(Tcl_Obj* rc_ptr, const struct port_hw_cfg * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "pci_id = 0x%x\n", (u32_t)(data->pci_id)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCI_VENDOR_ID = 0x%x \n", (u32_t)(data->pci_id & PORT_HW_CFG_PCI_VENDOR_ID_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCI_DEVICE_ID = 0x%x \n", (u32_t)(data->pci_id & PORT_HW_CFG_PCI_DEVICE_ID_MASK)>>0));
	STRUCT_PRINT((disp_str,  "pci_sub_id = 0x%x\n", (u32_t)(data->pci_sub_id)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCI_SUBSYS_DEVICE_ID = 0x%x \n", (u32_t)(data->pci_sub_id & PORT_HW_CFG_PCI_SUBSYS_DEVICE_ID_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PCI_SUBSYS_VENDOR_ID = 0x%x \n", (u32_t)(data->pci_sub_id & PORT_HW_CFG_PCI_SUBSYS_VENDOR_ID_MASK)>>0));
	STRUCT_PRINT((disp_str,  "power_dissipated = 0x%x\n", (u32_t)(data->power_dissipated)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_DIS_D0  = 0x%x \n", (u32_t)(data->power_dissipated & PORT_HW_CFG_POWER_DIS_D0_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_DIS_D1  = 0x%x \n", (u32_t)(data->power_dissipated & PORT_HW_CFG_POWER_DIS_D1_MASK)>>8));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_DIS_D2  = 0x%x \n", (u32_t)(data->power_dissipated & PORT_HW_CFG_POWER_DIS_D2_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_DIS_D3  = 0x%x \n", (u32_t)(data->power_dissipated & PORT_HW_CFG_POWER_DIS_D3_MASK)>>24));
	STRUCT_PRINT((disp_str,  "power_consumed = 0x%x\n", (u32_t)(data->power_consumed)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_CONS_D0 = 0x%x \n", (u32_t)(data->power_consumed & PORT_HW_CFG_POWER_CONS_D0_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_CONS_D1 = 0x%x \n", (u32_t)(data->power_consumed & PORT_HW_CFG_POWER_CONS_D1_MASK)>>8));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_CONS_D2 = 0x%x \n", (u32_t)(data->power_consumed & PORT_HW_CFG_POWER_CONS_D2_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_POWER_CONS_D3 = 0x%x \n", (u32_t)(data->power_consumed & PORT_HW_CFG_POWER_CONS_D3_MASK)>>24));
	STRUCT_PRINT((disp_str,  "mac_upper = 0x%x\n", (u32_t)(data->mac_upper)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_UPPERMAC      = 0x%x \n", (u32_t)(data->mac_upper & PORT_HW_CFG_UPPERMAC_MASK)>>0));
	STRUCT_PRINT((disp_str,  "mac_lower = 0x%x\n", (u32_t)(data->mac_lower)));
	STRUCT_PRINT((disp_str,  "iscsi_mac_upper = 0x%x\n", (u32_t)(data->iscsi_mac_upper)));
	STRUCT_PRINT((disp_str,  "iscsi_mac_lower = 0x%x\n", (u32_t)(data->iscsi_mac_lower)));
	STRUCT_PRINT((disp_str,  "rdma_mac_upper = 0x%x\n", (u32_t)(data->rdma_mac_upper)));
	STRUCT_PRINT((disp_str,  "rdma_mac_lower = 0x%x\n", (u32_t)(data->rdma_mac_lower)));
	STRUCT_PRINT((disp_str,  "serdes_config = 0x%x\n", (u32_t)(data->serdes_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SERDES_TX_DRV_PRE_EMPHASIS = 0x%x \n", (u32_t)(data->serdes_config & PORT_HW_CFG_SERDES_TX_DRV_PRE_EMPHASIS_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SERDES_RX_DRV_EQUALIZER = 0x%x \n", (u32_t)(data->serdes_config & PORT_HW_CFG_SERDES_RX_DRV_EQUALIZER_MASK)>>16));	
	STRUCT_PRINT((disp_str,  "vf_config = 0x%x\n", (u32_t)(data->vf_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_VF_PCI_DEVICE_ID = 0x%x \n", (u32_t)(data->vf_config & PORT_HW_CFG_VF_PCI_DEVICE_ID_MASK)>>16));
	STRUCT_PRINT((disp_str,  "reserved0[0 .. %d] = ", (14) - 1));
	for (index = 0; index < (14); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->reserved0)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "xgxs_config_rx[0 .. %d] = ", (4) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u16[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->xgxs_config_rx)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->xgxs_config_rx)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "xgxs_config_tx[0 .. %d] = ", (4) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u16[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->xgxs_config_tx)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->xgxs_config_tx)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "fcoe_fip_mac_upper = 0x%x\n", (u32_t)(data->fcoe_fip_mac_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_fip_mac_lower = 0x%x\n", (u32_t)(data->fcoe_fip_mac_lower)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_port_name_upper = 0x%x\n", (u32_t)(data->fcoe_wwn_port_name_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_port_name_lower = 0x%x\n", (u32_t)(data->fcoe_wwn_port_name_lower)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_node_name_upper = 0x%x\n", (u32_t)(data->fcoe_wwn_node_name_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_node_name_lower = 0x%x\n", (u32_t)(data->fcoe_wwn_node_name_lower)));
	STRUCT_PRINT((disp_str,  "Reserved1[0 .. %d] = ", (49) - 1));
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "xgbt_phy_cfg = 0x%x\n", (u32_t)(data->xgbt_phy_cfg)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_RJ45_PAIR_SWAP = 0x%x \n", (u32_t)(data->xgbt_phy_cfg & PORT_HW_CFG_RJ45_PAIR_SWAP_MASK)>>0));
	STRUCT_PRINT((disp_str,  "default_cfg = 0x%x\n", (u32_t)(data->default_cfg)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_GPIO0_CONFIG  = 0x%x \n", (u32_t)(data->default_cfg & PORT_HW_CFG_GPIO0_CONFIG_MASK)>>0));
	if ((data->default_cfg & PORT_HW_CFG_GPIO0_CONFIG_MASK) == PORT_HW_CFG_GPIO0_CONFIG_NA) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO0_CONFIG_NA)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO0_CONFIG_MASK) == PORT_HW_CFG_GPIO0_CONFIG_LOW) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO0_CONFIG_LOW)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO0_CONFIG_MASK) == PORT_HW_CFG_GPIO0_CONFIG_HIGH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO0_CONFIG_HIGH)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO0_CONFIG_MASK) == PORT_HW_CFG_GPIO0_CONFIG_INPUT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO0_CONFIG_INPUT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_GPIO1_CONFIG  = 0x%x \n", (u32_t)(data->default_cfg & PORT_HW_CFG_GPIO1_CONFIG_MASK)>>2));
	if ((data->default_cfg & PORT_HW_CFG_GPIO1_CONFIG_MASK) == PORT_HW_CFG_GPIO1_CONFIG_NA) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO1_CONFIG_NA)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO1_CONFIG_MASK) == PORT_HW_CFG_GPIO1_CONFIG_LOW) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO1_CONFIG_LOW)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO1_CONFIG_MASK) == PORT_HW_CFG_GPIO1_CONFIG_HIGH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO1_CONFIG_HIGH)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO1_CONFIG_MASK) == PORT_HW_CFG_GPIO1_CONFIG_INPUT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO1_CONFIG_INPUT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_GPIO2_CONFIG  = 0x%x \n", (u32_t)(data->default_cfg & PORT_HW_CFG_GPIO2_CONFIG_MASK)>>4));
	if ((data->default_cfg & PORT_HW_CFG_GPIO2_CONFIG_MASK) == PORT_HW_CFG_GPIO2_CONFIG_NA) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO2_CONFIG_NA)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO2_CONFIG_MASK) == PORT_HW_CFG_GPIO2_CONFIG_LOW) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO2_CONFIG_LOW)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO2_CONFIG_MASK) == PORT_HW_CFG_GPIO2_CONFIG_HIGH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO2_CONFIG_HIGH)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO2_CONFIG_MASK) == PORT_HW_CFG_GPIO2_CONFIG_INPUT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO2_CONFIG_INPUT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_GPIO3_CONFIG  = 0x%x \n", (u32_t)(data->default_cfg & PORT_HW_CFG_GPIO3_CONFIG_MASK)>>6));
	if ((data->default_cfg & PORT_HW_CFG_GPIO3_CONFIG_MASK) == PORT_HW_CFG_GPIO3_CONFIG_NA) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO3_CONFIG_NA)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO3_CONFIG_MASK) == PORT_HW_CFG_GPIO3_CONFIG_LOW) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO3_CONFIG_LOW)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO3_CONFIG_MASK) == PORT_HW_CFG_GPIO3_CONFIG_HIGH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO3_CONFIG_HIGH)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_GPIO3_CONFIG_MASK) == PORT_HW_CFG_GPIO3_CONFIG_INPUT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_GPIO3_CONFIG_INPUT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_FORCE_KR_ENABLER = 0x%x \n", (u32_t)(data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK)>>8));
	if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_NOT_FORCED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_NOT_FORCED)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO0_P0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO0_P0)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO1_P0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO1_P0)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO2_P0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO2_P0)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO3_P0) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO3_P0)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO0_P1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO0_P1)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO1_P1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO1_P1)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO2_P1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO2_P1)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_GPIO3_P1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_GPIO3_P1)\n")); 
	}
	else if ((data->default_cfg & PORT_HW_CFG_FORCE_KR_ENABLER_MASK) == PORT_HW_CFG_FORCE_KR_ENABLER_FORCED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_FORCE_KR_ENABLER_FORCED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "speed_capability_mask2 = 0x%x\n", (u32_t)(data->speed_capability_mask2)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SPEED_CAPABILITY2_D3 = 0x%x \n", (u32_t)(data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK)>>0));
	if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_10M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_10M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_10M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_100M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_100M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_1G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_2_DOT_5G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_10G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_10G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D3_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D3_20G)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SPEED_CAPABILITY2_D0 = 0x%x \n", (u32_t)(data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK)>>16));
	if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_10M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_10M_HALF ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_10M_HALF )\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_100M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_100M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_1G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_2_DOT_5G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_10G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_10G)\n")); 
	}
	else if ((data->speed_capability_mask2 & PORT_HW_CFG_SPEED_CAPABILITY2_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY2_D0_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY2_D0_20G)\n")); 
	}
	STRUCT_PRINT((disp_str,  "multi_phy_config = 0x%x\n", (u32_t)(data->multi_phy_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PHY_SELECTION = 0x%x \n", (u32_t)(data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK)>>0));
	if ((data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK) == PORT_HW_CFG_PHY_SELECTION_HARDWARE_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SELECTION_HARDWARE_DEFAULT)\n")); 
	}
	else if ((data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK) == PORT_HW_CFG_PHY_SELECTION_FIRST_PHY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SELECTION_FIRST_PHY)\n")); 
	}
	else if ((data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK) == PORT_HW_CFG_PHY_SELECTION_SECOND_PHY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SELECTION_SECOND_PHY)\n")); 
	}
	else if ((data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK) == PORT_HW_CFG_PHY_SELECTION_FIRST_PHY_PRIORITY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SELECTION_FIRST_PHY_PRIORITY)\n")); 
	}
	else if ((data->multi_phy_config & PORT_HW_CFG_PHY_SELECTION_MASK) == PORT_HW_CFG_PHY_SELECTION_SECOND_PHY_PRIORITY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SELECTION_SECOND_PHY_PRIORITY)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_PHY_SWAPPED   = 0x%x \n", (u32_t)(data->multi_phy_config & PORT_HW_CFG_PHY_SWAPPED_MASK)>>3));
	if ((data->multi_phy_config & PORT_HW_CFG_PHY_SWAPPED_MASK) == PORT_HW_CFG_PHY_SWAPPED_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SWAPPED_DISABLED)\n")); 
	}
	else if ((data->multi_phy_config & PORT_HW_CFG_PHY_SWAPPED_MASK) == PORT_HW_CFG_PHY_SWAPPED_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_PHY_SWAPPED_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "external_phy_config2 = 0x%x\n", (u32_t)(data->external_phy_config2)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_XGXS_EXT_PHY2_ADDR = 0x%x \n", (u32_t)(data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_ADDR_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_XGXS_EXT_PHY2_TYPE = 0x%x \n", (u32_t)(data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK)>>8));
	if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_DIRECT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_DIRECT)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8071) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8071)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8072) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8072)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8073) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8073)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8705) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8705)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8706) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8706)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8726) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8726)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8481) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8481)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_SFX7101) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_SFX7101)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8727) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8727)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8727_NOC) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM8727_NOC)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM84823) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM84823)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_BCM54640) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_BCM54640)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_FAILURE)\n")); 
	}
	else if ((data->external_phy_config2 & PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY2_TYPE_NOT_CONN) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY2_TYPE_NOT_CONN)\n")); 
	}
	STRUCT_PRINT((disp_str,  "xgxs_config2_rx[0 .. %d] = ", (4) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u16[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->xgxs_config2_rx)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->xgxs_config2_rx)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "xgxs_config2_tx[0 .. %d] = ", (4) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u16[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->xgxs_config2_tx)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->xgxs_config2_tx)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "lane_config = 0x%x\n", (u32_t)(data->lane_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_LANE_SWAP_CFG = 0x%x \n", (u32_t)(data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASK)>>0));
	if ((data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASK) == PORT_HW_CFG_LANE_SWAP_CFG_01230123) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LANE_SWAP_CFG_01230123)\n")); 
	}
	else if ((data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASK) == PORT_HW_CFG_LANE_SWAP_CFG_01233210) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LANE_SWAP_CFG_01233210)\n")); 
	}
	else if ((data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASK) == PORT_HW_CFG_LANE_SWAP_CFG_31203120) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LANE_SWAP_CFG_31203120)\n")); 
	}
	else if ((data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASK) == PORT_HW_CFG_LANE_SWAP_CFG_32103210) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_LANE_SWAP_CFG_32103210)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_LANE_SWAP_CFG_TX = 0x%x \n", (u32_t)(data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_TX_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_LANE_SWAP_CFG_RX = 0x%x \n", (u32_t)(data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_RX_MASK)>>8));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_LANE_SWAP_CFG_MASTER = 0x%x \n", (u32_t)(data->lane_config & PORT_HW_CFG_LANE_SWAP_CFG_MASTER_MASK)>>14));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SWAP_PHY_POLARITY = 0x%x \n", (u32_t)(data->lane_config & PORT_HW_CFG_SWAP_PHY_POLARITY_MASK)>>16));
	if ((data->lane_config & PORT_HW_CFG_SWAP_PHY_POLARITY_MASK) == PORT_HW_CFG_SWAP_PHY_POLARITY_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SWAP_PHY_POLARITY_DISABLED)\n")); 
	}
	else if ((data->lane_config & PORT_HW_CFG_SWAP_PHY_POLARITY_MASK) == PORT_HW_CFG_SWAP_PHY_POLARITY_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SWAP_PHY_POLARITY_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "external_phy_config = 0x%x\n", (u32_t)(data->external_phy_config)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_XGXS_EXT_PHY_ADDR = 0x%x \n", (u32_t)(data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_ADDR_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_XGXS_EXT_PHY_TYPE = 0x%x \n", (u32_t)(data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK)>>8));
	if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_DIRECT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_DIRECT)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8071) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8071)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8072) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8072)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8073) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8073)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8705) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8705)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8706) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8706)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8726) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8726)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8481) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8481)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_SFX7101) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_SFX7101)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8727) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8727)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM8727_NOC) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM8727_NOC)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM84823) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM84823)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_BCM54640) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_BCM54640)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_FAILURE)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_XGXS_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_XGXS_EXT_PHY_TYPE_NOT_CONN) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_XGXS_EXT_PHY_TYPE_NOT_CONN)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SERDES_EXT_PHY_ADDR = 0x%x \n", (u32_t)(data->external_phy_config & PORT_HW_CFG_SERDES_EXT_PHY_ADDR_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SERDES_EXT_PHY_TYPE = 0x%x \n", (u32_t)(data->external_phy_config & PORT_HW_CFG_SERDES_EXT_PHY_TYPE_MASK)>>24));
	if ((data->external_phy_config & PORT_HW_CFG_SERDES_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_SERDES_EXT_PHY_TYPE_DIRECT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SERDES_EXT_PHY_TYPE_DIRECT)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_SERDES_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_SERDES_EXT_PHY_TYPE_BCM5482) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SERDES_EXT_PHY_TYPE_BCM5482)\n")); 
	}
	else if ((data->external_phy_config & PORT_HW_CFG_SERDES_EXT_PHY_TYPE_MASK) == PORT_HW_CFG_SERDES_EXT_PHY_TYPE_NOT_CONN) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SERDES_EXT_PHY_TYPE_NOT_CONN)\n")); 
	}
	STRUCT_PRINT((disp_str,  "speed_capability_mask = 0x%x\n", (u32_t)(data->speed_capability_mask)));
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SPEED_CAPABILITY_D3 = 0x%x \n", (u32_t)(data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK)>>0));
	if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_10M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_10M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_10M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_100M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_100M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_1G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_2_5G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_10G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_10G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_20G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D3_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D3_RESERVED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D3_RESERVED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tHW_CFG_SPEED_CAPABILITY_D0 = 0x%x \n", (u32_t)(data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK)>>16));
	if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_10M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_10M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_10M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_100M_HALF)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_100M_FULL)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_1G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_2_5G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_10G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_10G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_20G)\n")); 
	}
	else if ((data->speed_capability_mask & PORT_HW_CFG_SPEED_CAPABILITY_D0_MASK) == PORT_HW_CFG_SPEED_CAPABILITY_D0_RESERVED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(HW_CFG_SPEED_CAPABILITY_D0_RESERVED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "backup_mac_upper = 0x%x\n", (u32_t)(data->backup_mac_upper)));
	STRUCT_PRINT((disp_str,  "backup_mac_lower = 0x%x\n", (u32_t)(data->backup_mac_lower)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodePortHwCfg

/*****************************************************************************

FUNCTION:       DecodeSharedFeatCfg

DESCRIPTION:    This routine decode the structure/union struct shared_feat_cfg

IN PARAMETERS:  pointer to struct shared_feat_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeSharedFeatCfg(Tcl_Obj* rc_ptr, const struct shared_feat_cfg * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "config = 0x%x\n", (u32_t)(data->config)));
	STRUCT_PRINT((disp_str,  "\tFEATURE_BMC_ECHO_MODE_EN = 0x%x \n", (u32_t)(data->config & SHARED_FEATURE_BMC_ECHO_MODE_EN)>>0));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_OVERRIDE_PREEMPHASIS_CFG = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_MASK)>>1));
	if ((data->config & SHARED_FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_MASK) == SHARED_FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_DISABLED)\n")); 
	}
	else if ((data->config & SHARED_FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_MASK) == SHARED_FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OVERRIDE_PREEMPHASIS_CFG_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_NCSI_ID_METHOD = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_NCSI_ID_METHOD_MASK)>>3));
	if ((data->config & SHARED_FEAT_CFG_NCSI_ID_METHOD_MASK) == SHARED_FEAT_CFG_NCSI_ID_METHOD_SPIO) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_NCSI_ID_METHOD_SPIO)\n")); 
	}
	else if ((data->config & SHARED_FEAT_CFG_NCSI_ID_METHOD_MASK) == SHARED_FEAT_CFG_NCSI_ID_METHOD_NVRAM) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_NCSI_ID_METHOD_NVRAM)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_NCSI_ID     = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_NCSI_ID_MASK)>>4));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_FORCE_SF_MODE = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_FORCE_SF_MODE_MASK)>>8));
	if ((data->config & SHARED_FEAT_CFG_FORCE_SF_MODE_MASK) == SHARED_FEAT_CFG_FORCE_SF_MODE_MF_ALLOWED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_SF_MODE_MF_ALLOWED)\n")); 
	}
	else if ((data->config & SHARED_FEAT_CFG_FORCE_SF_MODE_MASK) == SHARED_FEAT_CFG_FORCE_SF_MODE_FORCED_SF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_SF_MODE_FORCED_SF)\n")); 
	}
	else if ((data->config & SHARED_FEAT_CFG_FORCE_SF_MODE_MASK) == SHARED_FEAT_CFG_FORCE_SF_MODE_SPIO4) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_SF_MODE_SPIO4)\n")); 
	}
	else if ((data->config & SHARED_FEAT_CFG_FORCE_SF_MODE_MASK) == SHARED_FEAT_CFG_FORCE_SF_MODE_SWITCH_INDEPT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_SF_MODE_SWITCH_INDEPT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_LLDP_XMIT_INTERVAL = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_LLDP_XMIT_INTERVAL_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_LLDP_DEVICE_TYPE_ID = 0x%x \n", (u32_t)(data->config & SHARED_FEAT_CFG_LLDP_DEVICE_TYPE_ID_MASK)>>24));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeSharedFeatCfg

/*****************************************************************************

FUNCTION:       DecodePortFeatCfg

DESCRIPTION:    This routine decode the structure/union struct port_feat_cfg

IN PARAMETERS:  pointer to struct port_feat_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodePortFeatCfg(Tcl_Obj* rc_ptr, const struct port_feat_cfg * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "config = 0x%x\n", (u32_t)(data->config)));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_BAR1_SIZE    = 0x%x \n", (u32_t)(data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK)>>0));
	if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_DISABLED)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_64K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_64K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_128K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_128K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_256K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_256K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_512K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_512K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_1M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_1M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_2M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_2M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_4M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_4M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_8M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_8M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_16M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_16M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_32M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_32M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_64M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_64M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_128M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_128M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_256M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_256M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_512M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_512M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR1_SIZE_MASK) == PORT_FEAT_CFG_BAR1_SIZE_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR1_SIZE_1G)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_BAR2_SIZE    = 0x%x \n", (u32_t)(data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK)>>4));
	if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_DISABLED)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_64K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_64K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_128K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_128K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_256K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_256K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_512K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_512K)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_1M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_1M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_2M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_2M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_4M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_4M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_8M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_8M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_16M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_16M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_32M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_32M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_64M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_64M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_128M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_128M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_256M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_256M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_512M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_512M)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_BAR2_SIZE_MASK) == PORT_FEAT_CFG_BAR2_SIZE_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_BAR2_SIZE_1G)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_DCBX        = 0x%x \n", (u32_t)(data->config & PORT_FEAT_CFG_DCBX_MASK)>>8));
	if ((data->config & PORT_FEAT_CFG_DCBX_MASK) == PORT_FEAT_CFG_DCBX_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_DCBX_DISABLED)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_DCBX_MASK) == PORT_FEAT_CFG_DCBX_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_DCBX_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_EN_SIZE      = 0x%x \n", (u32_t)(data->config & PORT_FEATURE_EN_SIZE_MASK)>>24));
	STRUCT_PRINT((disp_str,  "\tFEATURE_WOL_ENABLED  = 0x%x \n", (u32_t)(data->config & PORT_FEATURE_WOL_ENABLED)>>24));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_ENABLED  = 0x%x \n", (u32_t)(data->config & PORT_FEATURE_MBA_ENABLED)>>25));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MFW_ENABLED  = 0x%x \n", (u32_t)(data->config & PORT_FEATURE_MFW_ENABLED)>>26));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_FORCE_EXP_ROM_ADV = 0x%x \n", (u32_t)(data->config & PORT_FEAT_CFG_FORCE_EXP_ROM_ADV_MASK)>>27));
	if ((data->config & PORT_FEAT_CFG_FORCE_EXP_ROM_ADV_MASK) == PORT_FEAT_CFG_FORCE_EXP_ROM_ADV_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_EXP_ROM_ADV_DISABLED)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_FORCE_EXP_ROM_ADV_MASK) == PORT_FEAT_CFG_FORCE_EXP_ROM_ADV_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_FORCE_EXP_ROM_ADV_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_OPT_MDL_ENFRCMNT = 0x%x \n", (u32_t)(data->config & PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_MASK)>>29));
	if ((data->config & PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_MASK) == PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_NO_ENFORCEMENT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OPT_MDL_ENFRCMNT_NO_ENFORCEMENT)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_MASK) == PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_DISABLE_TX_LASER) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OPT_MDL_ENFRCMNT_DISABLE_TX_LASER)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_MASK) == PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_WARNING_MSG) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OPT_MDL_ENFRCMNT_WARNING_MSG)\n")); 
	}
	else if ((data->config & PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_MASK) == PORT_FEAT_CFG_OPT_MDL_ENFRCMNT_POWER_DOWN) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_OPT_MDL_ENFRCMNT_POWER_DOWN)\n")); 
	}
	STRUCT_PRINT((disp_str,  "wol_config = 0x%x\n", (u32_t)(data->wol_config)));
    STRUCT_PRINT((disp_str,  "\tFEATURE_WOL_ACPI_UPON_MGMT = 0x%x \n", (u32_t)(data->wol_config & PORT_FEATURE_WOL_ACPI_UPON_MGMT)>>4));
	STRUCT_PRINT((disp_str,  "mba_config = 0x%x\n", (u32_t)(data->mba_config)));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_BOOT_AGENT_TYPE = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK)>>0));
	if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_PXE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_PXE)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_RPL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_RPL)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_BOOTP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_BOOTP)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_ISCSIB) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_ISCSIB)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_FCOE_BOOT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_FCOE_BOOT)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BOOT_AGENT_TYPE_MASK) == PORT_FEATURE_MBA_BOOT_AGENT_TYPE_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BOOT_AGENT_TYPE_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_BOOT_RETRY = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_BOOT_RETRY_MASK)>>3));	
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_SETUP_PROMPT_ENABLE = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_SETUP_PROMPT_ENABLE)>>10));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_HOTKEY   = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_HOTKEY_MASK)>>11));
	if ((data->mba_config & PORT_FEATURE_MBA_HOTKEY_MASK) == PORT_FEATURE_MBA_HOTKEY_CTRL_S) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_HOTKEY_CTRL_S)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_HOTKEY_MASK) == PORT_FEATURE_MBA_HOTKEY_CTRL_B) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_HOTKEY_CTRL_B)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_EXP_ROM_SIZE = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK)>>12));
	if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_DISABLED)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_2K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_2K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_4K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_4K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_8K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_8K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_16K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_16K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_32K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_32K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_64K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_64K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_128K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_128K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_256K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_256K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_512K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_512K)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_1M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_1M)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_2M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_2M)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_4M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_4M)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_8M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_8M)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_16M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_16M)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_EXP_ROM_SIZE_MASK) == PORT_FEATURE_MBA_EXP_ROM_SIZE_32M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_EXP_ROM_SIZE_32M)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_MSG_TIMEOUT = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_MSG_TIMEOUT_MASK)>>20));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_BIOS_BOOTSTRAP = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_BIOS_BOOTSTRAP_MASK)>>24));
	if ((data->mba_config & PORT_FEATURE_MBA_BIOS_BOOTSTRAP_MASK) == PORT_FEATURE_MBA_BIOS_BOOTSTRAP_AUTO) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BIOS_BOOTSTRAP_AUTO)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BIOS_BOOTSTRAP_MASK) == PORT_FEATURE_MBA_BIOS_BOOTSTRAP_BBS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BIOS_BOOTSTRAP_BBS)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BIOS_BOOTSTRAP_MASK) == PORT_FEATURE_MBA_BIOS_BOOTSTRAP_INT18H) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BIOS_BOOTSTRAP_INT18H)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_BIOS_BOOTSTRAP_MASK) == PORT_FEATURE_MBA_BIOS_BOOTSTRAP_INT19H) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_BIOS_BOOTSTRAP_INT19H)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_LINK_SPEED = 0x%x \n", (u32_t)(data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK)>>26));
	if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_AUTO) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_AUTO)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_10M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_10M_HALF\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_10M_FULL)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_100M_HALF)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_100M_FULL)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_1G)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_2_5G)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_10G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_10G)\n")); 
	}
	else if ((data->mba_config & PORT_FEATURE_MBA_LINK_SPEED_MASK) == PORT_FEATURE_MBA_LINK_SPEED_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_MBA_LINK_SPEED_20G)\n")); 
	}
	
	STRUCT_PRINT((disp_str,  "mba_vlan_cfg = 0x%x\n", (u32_t)(data->mba_vlan_cfg)));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_VLAN_TAG = 0x%x \n", (u32_t)(data->mba_vlan_cfg & PORT_FEATURE_MBA_VLAN_TAG_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tFEATURE_MBA_VLAN_EN  = 0x%x \n", (u32_t)(data->mba_vlan_cfg & PORT_FEATURE_MBA_VLAN_EN)>>16));	
	STRUCT_PRINT((disp_str,  "smbus_config = 0x%x\n", (u32_t)(data->smbus_config)));
	STRUCT_PRINT((disp_str,  "\tFEATURE_SMBUS_ADDR   = 0x%x \n", (u32_t)(data->smbus_config & PORT_FEATURE_SMBUS_ADDR_MASK)>>1));
	STRUCT_PRINT((disp_str,  "vf_config = 0x%x\n", (u32_t)(data->vf_config)));
	STRUCT_PRINT((disp_str,  "\tFEAT_CFG_VF_BAR2_SIZE = 0x%x \n", (u32_t)(data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK)>>0));
	if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_DISABLED)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_4K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_4K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_8K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_8K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_16K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_16K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_32K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_32K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_64K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_64K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_128K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_128K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_256K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_256K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_512K) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_512K)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_1M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_1M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_2M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_2M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_4M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_4M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_8M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_8M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_16M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_16M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_32M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_32M)\n")); 
	}
	else if ((data->vf_config & PORT_FEAT_CFG_VF_BAR2_SIZE_MASK) == PORT_FEAT_CFG_VF_BAR2_SIZE_64M) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEAT_CFG_VF_BAR2_SIZE_64M)\n")); 
	}
	STRUCT_PRINT((disp_str,  "link_config = 0x%x\n", (u32_t)(data->link_config)));
	STRUCT_PRINT((disp_str,  "\tFEATURE_CONNECTED_SWITCH = 0x%x \n", (u32_t)(data->link_config & PORT_FEATURE_CONNECTED_SWITCH_MASK)>>24));
	if ((data->link_config & PORT_FEATURE_CONNECTED_SWITCH_MASK) == PORT_FEATURE_CON_SWITCH_1G_SWITCH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_CON_SWITCH_1G_SWITCH)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_CONNECTED_SWITCH_MASK) == PORT_FEATURE_CON_SWITCH_10G_SWITCH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_CON_SWITCH_10G_SWITCH)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_CONNECTED_SWITCH_MASK) == PORT_FEATURE_CON_SWITCH_AUTO_DETECT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_CON_SWITCH_AUTO_DETECT)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_CONNECTED_SWITCH_MASK) == PORT_FEATURE_CON_SWITCH_ONE_TIME_DETECT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_CON_SWITCH_ONE_TIME_DETECT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_LINK_SPEED   = 0x%x \n", (u32_t)(data->link_config & PORT_FEATURE_LINK_SPEED_MASK)>>16));
	if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_AUTO) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_AUTO)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_10M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_10M_FULL)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_10M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_10M_HALF)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_100M_HALF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_100M_HALF)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_100M_FULL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_100M_FULL)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_1G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_1G)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_2_5G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_2_5G)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_10G_CX4) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_10G_CX4)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_LINK_SPEED_MASK) == PORT_FEATURE_LINK_SPEED_20G) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_LINK_SPEED_20G)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tFEATURE_FLOW_CONTROL = 0x%x \n", (u32_t)(data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK)>>8));
	if ((data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK) == PORT_FEATURE_FLOW_CONTROL_AUTO) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_FLOW_CONTROL_AUTO)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK) == PORT_FEATURE_FLOW_CONTROL_TX) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_FLOW_CONTROL_TX)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK) == PORT_FEATURE_FLOW_CONTROL_RX) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_FLOW_CONTROL_RX)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK) == PORT_FEATURE_FLOW_CONTROL_BOTH) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_FLOW_CONTROL_BOTH)\n")); 
	}
	else if ((data->link_config & PORT_FEATURE_FLOW_CONTROL_MASK) == PORT_FEATURE_FLOW_CONTROL_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FEATURE_FLOW_CONTROL_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "mfw_wol_link_cfg = 0x%x\n", (u32_t)(data->mfw_wol_link_cfg)));
	STRUCT_PRINT((disp_str,  "link_config2 = 0x%x\n", (u32_t)(data->link_config2)));
	STRUCT_PRINT((disp_str,  "mfw_wol_link_cfg2 = 0x%x\n", (u32_t)(data->mfw_wol_link_cfg2)));
	STRUCT_PRINT((disp_str,  "Reserved2[0 .. %d] = ", (17) - 1));
	for (index = 0; index < (17); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->Reserved2)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodePortFeatCfg

/*****************************************************************************

FUNCTION:       DecodeShmDevInfo

DESCRIPTION:    This routine decode the structure/union struct shm_dev_info

IN PARAMETERS:  pointer to struct shm_dev_info

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeShmDevInfo(Tcl_Obj* rc_ptr, const struct shm_dev_info * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "bc_rev = 0x%x\n", (u32_t)(data->bc_rev)));
	STRUCT_PRINT((disp_str,  "shared_hw_config->\n"));
	DecodeSharedHwCfg( rc_ptr, &data->shared_hw_config);

	for (index = 0; index < (PORT_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "port_hw_config[%d]->\n", index));
		DecodePortHwCfg(rc_ptr, &data->port_hw_config[index]);

	}

	STRUCT_PRINT((disp_str,  "shared_feature_config->\n"));
	DecodeSharedFeatCfg( rc_ptr, &data->shared_feature_config);

	for (index = 0; index < (PORT_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "port_feature_config[%d]->\n", index));
		DecodePortFeatCfg(rc_ptr, &data->port_feature_config[index]);

	}

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeShmDevInfo




// ??????? move following declaration to header file
extern void DecodeSharedHwCfg(Tcl_Obj* rc_ptr, const struct shared_hw_cfg * data);
extern void DecodePortHwCfg(Tcl_Obj* rc_ptr, const struct port_hw_cfg * data);
extern void DecodeSharedFeatCfg(Tcl_Obj* rc_ptr, const struct shared_feat_cfg * data);
extern void DecodePortFeatCfg(Tcl_Obj* rc_ptr, const struct port_feat_cfg * data);
extern void DecodeShmDevInfo(Tcl_Obj* rc_ptr, const struct shm_dev_info * data);
