/****************************************************************************
 * Copyright(c) 2001-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 * Name:        decode_ncsi_cmds.c
 *
 * Description: Decode structures in ncsi_cmds.h 
 *
 * Created:     File generated from c:\ediag_build\nx2\577xx\hsi\mcp\ncsi_cmds.h in 5/11/2010 dlau
 *     !!! Majority of the code is script generated. 
 *    Avoid modifying this file manually. Consult David Lau for help. 
 *
 ****************************************************************************/

#include  <stdio.h>
#include  <ctype.h>
#include  <stdlib.h>
#include  <string.h>
#include "tcl.h"
#include "bcmtype.h"
#include "ncsi_cmds.h"


u32_t indent_level;

#ifndef INDENT_STRUCT
#define INDENT_STRUCT(tab_cnt) \
{\
	u32_t tab_index;\
	for (tab_index = 0; tab_index < tab_cnt; tab_index++) SPECIAL_DBG_TAB; \
}

#define STRUCT_PRINT(x)      {INDENT_STRUCT(indent_level); SPECIAL_DBG_PRINT(x);}
#endif // INDENT_STRUCT
// return printable ASCII character (return blank otherwise) 

#define CHK_ASCII(x)      (((x) > 31 && (x) < 127) ? (x) : ' ') 

static u32_t loop_index;

static char disp_str[200];
#ifndef SPECIAL_DBG_PRINT
#define SPECIAL_DBG_PRINT(x)   \
{\
	sprintf x;\
	Tcl_AppendStringsToObj( rc_ptr, disp_str, NULL); \
}
#endif // SPECIAL_DBG_PRINT
#ifndef SPECIAL_DBG_TAB
#define SPECIAL_DBG_TAB  Tcl_AppendStringsToObj( rc_ptr, "\t", NULL) 
#endif // SPECIAL_DBG_TAB


static const char * EtherProtocol(u32_t ether_type)
{
    switch (ether_type)
    {
        case 0x0800 :  return "Internet Protocol, Version 4 (IPv4)";             
        case 0x0806 :  return "Address Resolution Protocol (ARP)";               
        case 0x8035 :  return "Reverse Address Resolution Protocol (RARP)";      
        case 0x809b :  return "AppleTalk (Ethertalk)";                           
        case 0x80f3 :  return "AppleTalk Address Resolution Protocol (AARP)";    
        case 0x8100 :  return "IEEE 802.1Q-tagged frame";                        
        case 0x8137 :  return "Novell IPX (alt)";                                
        case 0x8138 :  return "Novell";                                          
        case 0x86DD :  return "Internet Protocol, Version 6 (IPv6)";             
        case 0x8847 :  return "MPLS unicast";                                    
        case 0x8848 :  return "MPLS multicast";                                  
        case 0x8863 :  return "PPPoE Discovery Stage";                           
        case 0x8864 :  return "PPPoE Session Stage";                             
        case 0x888E :  return "EAP over LAN (IEEE 802.1X)";                      
        case 0x889A :  return "HyperSCSI (SCSI over Ethernet)";                  
        case 0x88A2 :  return "ATA over Ethernet";                               
        case 0x88A4 :  return "EtherCAT Protocol";                               
        case 0x88E5 :  return "MAC security (IEEE 802.1AE)";                     
        case 0xCAFE :  return "Veritas Low Latency Transport (LLT)";             
        default:       return "Unknown Protocol";
    }
}

/*****************************************************************************

FUNCTION:       DecodeNcsiControlPktHeader

DESCRIPTION:    This routine decode the structure/union NcsiRmiiControlPktHeader_t

IN PARAMETERS:  pointer to NcsiRmiiControlPktHeader_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiControlPktHeader(Tcl_Obj* rc_ptr, const NcsiRmiiControlPktHeader_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

//	STRUCT_PRINT((disp_str,  "PlusTwoPadding = 0x%x\n", (u32_t)(data->PlusTwoPadding)));
	STRUCT_PRINT((disp_str,  "DestAddr[0 .. %d] = ", (SIZEOF_MAC_ADDRESS) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->DestAddr)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->DestAddr)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));

	STRUCT_PRINT((disp_str,  "\tBig Endian: \""));
	for (loop_index = 0; ((SIZEOF_MAC_ADDRESS) & 0x3) ==0 &&loop_index < (SIZEOF_MAC_ADDRESS)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->DestAddr)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)(temp>>24)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)temp)));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));


	STRUCT_PRINT((disp_str,  "\tLittle Endian: \""));
	for (loop_index = 0; ((SIZEOF_MAC_ADDRESS) & 0x3) ==0 &&loop_index < (SIZEOF_MAC_ADDRESS)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->DestAddr)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)temp), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>24))));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));

	STRUCT_PRINT((disp_str,  "SrcAddr[0 .. %d] = ", (SIZEOF_MAC_ADDRESS) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->SrcAddr)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->SrcAddr)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));

	STRUCT_PRINT((disp_str,  "\tBig Endian: \""));
	for (loop_index = 0; ((SIZEOF_MAC_ADDRESS) & 0x3) ==0 &&loop_index < (SIZEOF_MAC_ADDRESS)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->SrcAddr)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)(temp>>24)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)temp)));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));


	STRUCT_PRINT((disp_str,  "\tLittle Endian: \""));
	for (loop_index = 0; ((SIZEOF_MAC_ADDRESS) & 0x3) ==0 &&loop_index < (SIZEOF_MAC_ADDRESS)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->SrcAddr)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)temp), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>24))));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));

	STRUCT_PRINT((disp_str,  "EtherType = 0x%x\n", (u32_t)(data->EtherType)));
	if ((data->EtherType & 0xFFFFFFFF) == NCSI_ETHER_TYPE_ID) 
	{
		STRUCT_PRINT((disp_str,  "\t   (NCSI ETHER_TYPE_ID)\n")); 
	}
    else
    {
		STRUCT_PRINT((disp_str,  "\t   %s\n", EtherProtocol((u32_t)(data->EtherType)))); 
    }
	STRUCT_PRINT((disp_str,  "McId = 0x%x\n", (u32_t)(data->McId)));
	STRUCT_PRINT((disp_str,  "HeaderRevNum = 0x%x\n", (u32_t)(data->HeaderRevNum)));
	if (data->Reserved0 != 0)
	STRUCT_PRINT((disp_str,  "Reserved0 = 0x%x\n", (u32_t)(data->Reserved0)));
	STRUCT_PRINT((disp_str,  "InstanceId = 0x%x\n", (u32_t)(data->InstanceId)));
	STRUCT_PRINT((disp_str,  "TypeCode = 0x%x\n", (u32_t)(data->TypeCode)));
	if ((data->TypeCode & 0xFFFFFFFF) == NCSI_CMD_TYPE_AEN) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_AEN)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tCMD_TYPE              = %s 0x%x\n", (u32_t)(data->TypeCode & NCSI_CMD_TYPE_MASK) == (0x7F) ? "(0x7F)" : "", (u32_t)(data->TypeCode & NCSI_CMD_TYPE_MASK)));
	if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_CLEAR_INITIAL_STATE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_CLEAR_INITIAL_STATE)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_PACKAGE_SELECT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_PACKAGE_SELECT)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_PACKAGE_DESELECT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_PACKAGE_DESELECT)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_CHANNEL) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_CHANNEL)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_DISABLE_CHANNEL) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_DISABLE_CHANNEL)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_RESET_CHANNEL) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_RESET_CHANNEL)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_CHANNEL_EGRESS_TX) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_CHANNEL_EGRESS_TX)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_DISABLE_CHANNEL_EGRESS_TX) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_DISABLE_CHANNEL_EGRESS_TX)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_AEN) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_AEN)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_SET_LINK) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_SET_LINK)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_LINK_STATUS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_LINK_STATUS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_SET_VLAN_FILTERS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_SET_VLAN_FILTERS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_VLAN) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_VLAN)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_DISABLE_VLAN) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_DISABLE_VLAN)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_SET_MAC_ADDRESS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_SET_MAC_ADDRESS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_BROADCAST_PKT_FILTER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_BROADCAST_PKT_FILTER)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_DISABLE_BROADCAST_PKT_FILTER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_DISABLE_BROADCAST_PKT_FILTER)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_ENABLE_MULTICAST_PKT_FILTER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_ENABLE_MULTICAST_PKT_FILTER)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_DISABLE_MULTICAST_PKT_FILTER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_DISABLE_MULTICAST_PKT_FILTER)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_SET_NCSI_FLOW_CONTROL) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_SET_NCSI_FLOW_CONTROL)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_VERSION_ID) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_VERSION_ID)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_CAPABILITIES) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_CAPABILITIES)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_PARAMETERS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_PARAMETERS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_IF_STATISTICS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_IF_STATISTICS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_NCSI_STATISTICS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_NCSI_STATISTICS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_GET_NCSI_PASS_THROUGH_STATISTICS) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_GET_NCSI_PASS_THROUGH_STATISTICS)\n")); 
	}
	else if ((data->TypeCode & NCSI_CMD_TYPE_MASK) == NCSI_CMD_TYPE_OEM) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_TYPE_OEM)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tCMD_RESPONSE_BIT      = %s 0x%x\n", (u32_t)(data->TypeCode & NCSI_CMD_RESPONSE_BIT) == (0x80) ? "(0x80)" : "", (u32_t)(data->TypeCode & NCSI_CMD_RESPONSE_BIT)));
	STRUCT_PRINT((disp_str,  "ChannelId = 0x%x\n", (u32_t)(data->ChannelId)));
	STRUCT_PRINT((disp_str,  "\tCMD_CHANNEL_ID       = 0x%x \n", (u32_t)(data->ChannelId & NCSI_CMD_CHANNEL_ID_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tCMD_PACKAGE_ID       = 0x%x \n", (u32_t)(data->ChannelId & NCSI_CMD_PACKAGE_ID_MASK)>>5));
	STRUCT_PRINT((disp_str,  "PayloadSize = 0x%x\n", (u32_t)(data->PayloadSize)));
	STRUCT_PRINT((disp_str,  "Reserved1[0 .. %d] = ", (2) - 1));
	for (loop_index = 0; loop_index < (2); loop_index++)  // u32 array 
	{
		if (((u32_t *)data->Reserved1)[loop_index] == 0) continue;
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->Reserved1)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiControlPktHeader

/*****************************************************************************

FUNCTION:       DecodeFwTestCmdPayload

DESCRIPTION:    This routine decode the structure/union FwTestCmdPayload_t

IN PARAMETERS:  pointer to FwTestCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeFwTestCmdPayload(Tcl_Obj* rc_ptr, const FwTestCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "OperationType = 0x%x\n", (u32_t)(data->OperationType)));
	if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_READ) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_READ)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_WRITE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_WRITE)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_READ_FW_STATE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_READ_FW_STATE)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_SAVE_SET_OS_PRES_FLAG) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_SAVE_SET_OS_PRES_FLAG)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_RESTORE_OS_PRES_FLAG) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_RESTORE_OS_PRES_FLAG)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_SAVE_SET_EXCEED_LOW_POWER_FLAG) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_SAVE_SET_EXCEED_LOW_POWER_FLAG)\n")); 
	}
	else if ((data->OperationType & 0xFFFFFFFF) == NCSI_TEST_RESTORE_EXCEED_LOW_POWER_FLAG) 
	{
		STRUCT_PRINT((disp_str,  "\t   (TEST_RESTORE_EXCEED_LOW_POWER_FLAG)\n")); 
	}
	STRUCT_PRINT((disp_str,  "Read/Write Address = %x\n", (u32_t)(data->OperationParameters.Read.Address)));
	STRUCT_PRINT((disp_str,  "Read/Write WordCount = %x\n", (u32_t)(data->OperationParameters.Read.WordCount)));
	STRUCT_PRINT((disp_str,  "Write Value = %x\n", (u32_t)(data->OperationParameters.Write.Value)));

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeFwTestCmdPayload

/*****************************************************************************

FUNCTION:       DecodeBrcmOemCmdRspHeader

DESCRIPTION:    This routine decode the structure/union BrcmOemCmdRspHeader_t

IN PARAMETERS:  pointer to BrcmOemCmdRspHeader_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeBrcmOemCmdRspHeader(Tcl_Obj* rc_ptr, const BrcmOemCmdRspHeader_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "PayloadVersion = 0x%x\n", (u32_t)(data->PayloadVersion)));
	STRUCT_PRINT((disp_str,  "CommandType = 0x%x\n", (u32_t)(data->CommandType)));
	if ((data->CommandType & 0xFFFFFFFF) == BRCM_OEM_SET_ALT_HOST_MAC_ADDRESS_CMD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OEM_SET_ALT_HOST_MAC_ADDRESS_CMD)\n")); 
	}
	else if ((data->CommandType & 0xFFFFFFFF) == BRCM_OEM_GET_NCSI_PARAMETERS_CMD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OEM_GET_NCSI_PARAMETERS_CMD)\n")); 
	}
	else if ((data->CommandType & 0xFFFFFFFF) == BRCM_OEM_NCSI_TEST_CMD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OEM_NCSI_TEST_CMD)\n")); 
	}
	STRUCT_PRINT((disp_str,  "PayloadLength = 0x%x\n", (u32_t)(data->PayloadLength)));
	if (data->Reserved != 0)
	STRUCT_PRINT((disp_str,  "Reserved = 0x%x\n", (u32_t)(data->Reserved)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeBrcmOemCmdRspHeader

/*****************************************************************************

FUNCTION:       DecodeModifyHostMacAddrCmdPayload

DESCRIPTION:    This routine decode the structure/union ModifyHostMacAddrCmdPayload_t

IN PARAMETERS:  pointer to ModifyHostMacAddrCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeModifyHostMacAddrCmdPayload(Tcl_Obj* rc_ptr, const ModifyHostMacAddrCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Res = 0x%x\n", (u32_t)(data->Res)));
	STRUCT_PRINT((disp_str,  "Flags = 0x%x\n", (u32_t)(data->Flags)));
	if ((data->Flags & 0xFFFFFFFF) == NCSI_OEM_CMD_SET_ALT_HOST_MAC_ADDR_FLAG_FIELD_ENABLE_MAC_ADDR) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OEM_CMD_SET_ALT_HOST_MAC_ADDR_FLAG_FIELD_ENABLE_MAC_ADDR)\n")); 
	}
	else if ((data->Flags & 0xFFFFFFFF) == NCSI_OEM_CMD_SET_ALT_HOST_MAC_ADDR_FLAG_FIELD_ISCSI_MAC_ADDR_SELECT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OEM_CMD_SET_ALT_HOST_MAC_ADDR_FLAG_FIELD_ISCSI_MAC_ADDR_SELECT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "MacHigh = 0x%x\n", (u32_t)(data->MacHigh)));
	STRUCT_PRINT((disp_str,  "MacMiddle = 0x%x\n", (u32_t)(data->MacMiddle)));
	STRUCT_PRINT((disp_str,  "MacLow = 0x%x\n", (u32_t)(data->MacLow)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeModifyHostMacAddrCmdPayload


/*****************************************************************************

FUNCTION:       DecodeBrcmOemCmdPayload

DESCRIPTION:    This routine decode the structure/union BrcmOemCmdPayload_t

IN PARAMETERS:  pointer to BrcmOemCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeBrcmOemCmdPayload(Tcl_Obj* rc_ptr, u32_t choice, const BrcmOemCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
	switch(choice)
	{
        case BRCM_OEM_SET_ALT_HOST_MAC_ADDRESS_CMD:
	        STRUCT_PRINT((disp_str,  "ModifyHostMacAddrCmd->\n"));
	        DecodeModifyHostMacAddrCmdPayload( rc_ptr, &data->ModifyHostMacAddrCmd);
            break;
        case BRCM_OEM_NCSI_TEST_CMD:
	        STRUCT_PRINT((disp_str,  "NsciTestCmd->\n"));
	        DecodeFwTestCmdPayload( rc_ptr, &data->NsciTestCmd);
            break;

        case BRCM_OEM_GET_NCSI_PARAMETERS_CMD:
	        STRUCT_PRINT((disp_str,  "No payload\n"));
            break;
        default:
	        STRUCT_PRINT((disp_str,  "Unknown OEM Command (%x)!!!!\n", choice));
            break;
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeBrcmOemCmdPayload

/*****************************************************************************

FUNCTION:       DecodeOemVendorData

DESCRIPTION:    This routine decode the structure/union BrcmOemVendorData_t

IN PARAMETERS:  pointer to BrcmOemVendorData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeOemVendorData(Tcl_Obj* rc_ptr, void * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "BrcmOemCmdRspHeader->\n"));
	// DecodeBrcmOemCmdRspHeader( rc_ptr, &data->BrcmOemCmdRspHeader);

	STRUCT_PRINT((disp_str,  "OemPayload->\n"));
	// DecodeBrcmOemCmdPayload( rc_ptr, data->BrcmOemCmdRspHeader.CommandType, &data->OemPayload);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeOemVendorData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdOemCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdOemCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdOemCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdOemCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdOemCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ManufacturerId = 0x%x\n", (u32_t)(data->ManufacturerId)));
	if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_BROADCOM_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (BROADCOM_IANA)\n")); 
	}
	else if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_DELL_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (DELL_IANA)\n")); 
	}
	STRUCT_PRINT((disp_str,  "VendorData->\n"));
	DecodeOemVendorData( rc_ptr, (void *)&data->VendorData);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdOemCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdSelectPackageCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdSelectPackageCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdSelectPackageCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdSelectPackageCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSelectPackageCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "DisableHwArbitration = 0x%x\n", (u32_t)(data->DisableHwArbitration)));
	if ((data->DisableHwArbitration & 0xFFFFFFFF) == HW_ARBITRATION_ENABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (ARBITRATION_ENABLE)\n")); 
	}
	else if ((data->DisableHwArbitration & 0xFFFFFFFF) == HW_ARBITRATION_DISABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (ARBITRATION_DISABLE)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdSelectPackageCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdEnableMulticastPacketFilteringCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdEnableMulticastPacketFilteringCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdEnableMulticastPacketFilteringCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdEnableMulticastPacketFilteringCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableMulticastPacketFilteringCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Setting = 0x%x\n", (u32_t)(data->Setting)));
	STRUCT_PRINT((disp_str,  "\tCMD_MULTICAST_PACKET_PASSTHRU_SETTING = 0x%x \n", (u32_t)(data->Setting & NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_MASK)>>0));
	if ((data->Setting & NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_MASK) == NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_IPV6_NEIGHBOR_ADV) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_MULTICAST_PACKET_PASSTHRU_SETTING_IPV6_NEIGHBOR_ADV)\n")); 
	}
	else if ((data->Setting & NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_MASK) == NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_IPV6_ROUTER_ADV) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_MULTICAST_PACKET_PASSTHRU_SETTING_IPV6_ROUTER_ADV)\n")); 
	}
	else if ((data->Setting & NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_MASK) == NCSI_CMD_MULTICAST_PACKET_PASSTHRU_SETTING_DHCPV6) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_MULTICAST_PACKET_PASSTHRU_SETTING_DHCPV6)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdEnableMulticastPacketFilteringCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdSetNcsiFlowControlCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdSetNcsiFlowControlCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdSetNcsiFlowControlCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdSetNcsiFlowControlCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetNcsiFlowControlCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Setting = 0x%x\n", (u32_t)(data->Setting)));
	if ((data->Setting & 0xFFFFFFFF) == NCSI_CMD_NCSI_FLOW_CONTROL_SETTING_ENABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_NCSI_FLOW_CONTROL_SETTING_ENABLE)\n")); 
	}
	else if ((data->Setting & 0xFFFFFFFF) == NCSI_CMD_NCSI_FLOW_CONTROL_SETTING_DISABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_NCSI_FLOW_CONTROL_SETTING_DISABLE)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdSetNcsiFlowControlCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdEnableVlanCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdEnableVlanCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdEnableVlanCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdEnableVlanCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableVlanCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Setting = 0x%x\n", (u32_t)(data->Setting)));
	if ((data->Setting & 0xFFFFFFFF) == NCSI_CMD_ENABLE_VLAN_SETTING_VLAN_TAG_MODE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_ENABLE_VLAN_SETTING_VLAN_TAG_MODE)\n")); 
	}
	else if ((data->Setting & 0xFFFFFFFF) == NCSI_CMD_ENABLE_VLAN_SETTING_MIXED_MODE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_ENABLE_VLAN_SETTING_MIXED_MODE)\n")); 
	}
	else if ((data->Setting & 0xFFFFFFFF) == NCSI_CMD_ENABLE_VLAN_SETTING_PROM_VLAN_MODE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_ENABLE_VLAN_SETTING_PROM_VLAN_MODE)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdEnableVlanCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdSetVlanCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdSetVlanCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdSetVlanCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdSetVlanCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetVlanCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	if (data->Reserved0 != 0)
	STRUCT_PRINT((disp_str,  "Reserved0 = 0x%x\n", (u32_t)(data->Reserved0)));
	STRUCT_PRINT((disp_str,  "VlanTag = 0x%x\n", (u32_t)(data->VlanTag)));
	if (data->Reserved1 != 0)
	STRUCT_PRINT((disp_str,  "Reserved1 = 0x%x\n", (u32_t)(data->Reserved1)));
	STRUCT_PRINT((disp_str,  "FilterSelector = 0x%x\n", (u32_t)(data->FilterSelector)));
	STRUCT_PRINT((disp_str,  "Enable = 0x%x\n", (u32_t)(data->Enable)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdSetVlanCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdEnableAenCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdEnableAenCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdEnableAenCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdEnableAenCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableAenCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Reserved[0 .. %d] = ", (3) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->Reserved)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if (((u32_t *)data->Reserved)[loop_index] == 0) continue;
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->Reserved)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));

	STRUCT_PRINT((disp_str,  "AenMcId = 0x%x\n", (u32_t)(data->AenMcId)));
	STRUCT_PRINT((disp_str,  "AenControl = 0x%x\n", (u32_t)(data->AenControl)));
	STRUCT_PRINT((disp_str,  "\tCMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_LINK_CHANGED_AEN = 0x%x \n", (u32_t)(data->AenControl & NCSI_CMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_LINK_CHANGED_AEN)>>0));
	STRUCT_PRINT((disp_str,  "\tCMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_RESET_OCCURRED_AEN = 0x%x \n", (u32_t)(data->AenControl & NCSI_CMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_RESET_OCCURRED_AEN)>>1));
	STRUCT_PRINT((disp_str,  "\tCMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_OS_CHANGED_AEN = 0x%x \n", (u32_t)(data->AenControl & NCSI_CMD_ENABLE_AEN_CMD_PAYLOAD_ENABLE_OS_CHANGED_AEN)>>2));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdEnableAenCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdSetMacAddrCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdSetMacAddrCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdSetMacAddrCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdSetMacAddrCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetMacAddrCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "MacAddrHigh = 0x%x\n", (u32_t)(data->MacAddrHigh)));
	STRUCT_PRINT((disp_str,  "MacAddrLowHigh = 0x%x\n", (u32_t)(data->MacAddrLowHigh)));
	STRUCT_PRINT((disp_str,  "MacAddrLowLow = 0x%x\n", (u32_t)(data->MacAddrLowLow)));
	STRUCT_PRINT((disp_str,  "MacAddrNum = 0x%x\n", (u32_t)(data->MacAddrNum)));
	STRUCT_PRINT((disp_str,  "AddrTypeEnable = 0x%x\n", (u32_t)(data->AddrTypeEnable)));
	STRUCT_PRINT((disp_str,  "\tCMD_SET_MAC_ADDR_CMD_ADDR_ENABLE = 0x%x \n", (u32_t)(data->AddrTypeEnable & NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_ENABLE)>>0));
	STRUCT_PRINT((disp_str,  "\tCMD_SET_MAC_ADDR_CMD_ADDR_TYPE = 0x%x \n", (u32_t)(data->AddrTypeEnable & NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_MASK)>>5));
	if ((data->AddrTypeEnable & NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_MASK) == NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_UNICAST) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_UNICAST)\n")); 
	}
	else if ((data->AddrTypeEnable & NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_MASK) == NCSI_CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_MULTICAST) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_SET_MAC_ADDR_CMD_ADDR_TYPE_MULTICAST)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdSetMacAddrCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdSetLinkCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdSetLinkCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdSetLinkCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdSetLinkCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetLinkCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "LinkSettings = 0x%x\n", (u32_t)(data->LinkSettings)));
	STRUCT_PRINT((disp_str,  "OemLinkSettings = 0x%x\n", (u32_t)(data->OemLinkSettings)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdSetLinkCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdDisableResetChannelCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdDisableResetChannelCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdDisableResetChannelCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdDisableResetChannelCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdDisableResetChannelCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	if (data->Reserved != 0)
	STRUCT_PRINT((disp_str,  "Reserved = 0x%x\n", (u32_t)(data->Reserved)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdDisableResetChannelCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdEnableBroadcastPacketFilteringCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdEnableBroadcastPacketFilteringCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdEnableBroadcastPacketFilteringCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdEnableBroadcastPacketFilteringCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableBroadcastPacketFilteringCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "FilterSettings = 0x%x\n", (u32_t)(data->FilterSettings)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdEnableBroadcastPacketFilteringCmdPayload


/*****************************************************************************

FUNCTION:       DecodeNcsiCmdPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdPayload_t

IN PARAMETERS:  pointer to NcsiCmdPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdPayload(Tcl_Obj* rc_ptr, u32_t choice, const NcsiCmdPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
	switch(choice)
	{
        case NCSI_CMD_TYPE_RESET_CHANNEL:           
            STRUCT_PRINT((disp_str,  "ResetChannelCmdPayload->\n"));
            DecodeNcsiCmdDisableResetChannelCmdPayload( rc_ptr, &data->ResetChannelCmdPayload);
            break;                 
        case NCSI_CMD_TYPE_DISABLE_CHANNEL:                 
            STRUCT_PRINT((disp_str,  "DisableChannelCmdPayload->\n"));
	        DecodeNcsiCmdDisableResetChannelCmdPayload( rc_ptr, &data->DisableChannelCmdPayload);
            break;                 
        case NCSI_CMD_TYPE_SET_MAC_ADDRESS:                         
            STRUCT_PRINT((disp_str,  "SetMacAddrPayload->\n"));
	        DecodeNcsiCmdSetMacAddrCmdPayload( rc_ptr, &data->SetMacAddrPayload);
            break;                 
        case NCSI_CMD_TYPE_SET_VLAN_FILTERS:                
            STRUCT_PRINT((disp_str,  "SetVlanPayload->\n"));
	        DecodeNcsiCmdSetVlanCmdPayload( rc_ptr, &data->SetVlanPayload);
            break;                 
        case NCSI_CMD_TYPE_SET_LINK:            
            STRUCT_PRINT((disp_str,  "SetLinkPayload->\n"));
	        DecodeNcsiCmdSetLinkCmdPayload( rc_ptr, &data->SetLinkPayload);
            break;                 
        case NCSI_CMD_TYPE_ENABLE_AEN:              
            STRUCT_PRINT((disp_str,  "EnableAenPayload->\n"));
	        DecodeNcsiCmdEnableAenCmdPayload( rc_ptr, &data->EnableAenPayload);
            break;                 
        case NCSI_CMD_TYPE_ENABLE_BROADCAST_PKT_FILTER:             
            STRUCT_PRINT((disp_str,  "EnableBroadcastFilterPayload->\n"));
	        DecodeNcsiCmdEnableBroadcastPacketFilteringCmdPayload( rc_ptr, &data->EnableBroadcastFilterPayload);
            break;                 
        case NCSI_CMD_TYPE_PACKAGE_SELECT:          
            STRUCT_PRINT((disp_str,  "SelectPackagePayload->\n"));
	        DecodeNcsiCmdSelectPackageCmdPayload( rc_ptr, &data->SelectPackagePayload);
            break;                 
        case NCSI_CMD_TYPE_SET_NCSI_FLOW_CONTROL:             
            STRUCT_PRINT((disp_str,  "SetFlowControlPayload->\n"));
	        DecodeNcsiCmdSetNcsiFlowControlCmdPayload( rc_ptr, &data->SetFlowControlPayload);
            break;                 
        case NCSI_CMD_TYPE_ENABLE_VLAN:   
            STRUCT_PRINT((disp_str,  "EnableVlanPayload->\n"));
	        DecodeNcsiCmdEnableVlanCmdPayload( rc_ptr, &data->EnableVlanPayload);
            break;                 
        case NCSI_CMD_TYPE_ENABLE_MULTICAST_PKT_FILTER:             
            STRUCT_PRINT((disp_str,  "EnableMulticastFilterPayload->\n"));
	        DecodeNcsiCmdEnableMulticastPacketFilteringCmdPayload( rc_ptr, &data->EnableMulticastFilterPayload);
            break;                 
        case NCSI_CMD_TYPE_OEM:  
            STRUCT_PRINT((disp_str,  "OemCmdPayload->\n"));
	        DecodeNcsiCmdOemCmdPayload( rc_ptr, &data->OemCmdPayload);
            break;                 

        case NCSI_CMD_TYPE_CLEAR_INITIAL_STATE:    
        case NCSI_CMD_TYPE_PACKAGE_DESELECT:                        
        case NCSI_CMD_TYPE_ENABLE_CHANNEL:                
        case NCSI_CMD_TYPE_ENABLE_CHANNEL_EGRESS_TX:                
        case NCSI_CMD_TYPE_DISABLE_CHANNEL_EGRESS_TX:               
        case NCSI_CMD_TYPE_GET_LINK_STATUS:                         
        case NCSI_CMD_TYPE_DISABLE_VLAN:                            
        case NCSI_CMD_TYPE_DISABLE_BROADCAST_PKT_FILTER:            
        case NCSI_CMD_TYPE_DISABLE_MULTICAST_PKT_FILTER:            
        case NCSI_CMD_TYPE_GET_VERSION_ID:                          
        case NCSI_CMD_TYPE_GET_CAPABILITIES:                        
        case NCSI_CMD_TYPE_GET_PARAMETERS:                          
        case NCSI_CMD_TYPE_GET_IF_STATISTICS:                       
        case NCSI_CMD_TYPE_GET_NCSI_STATISTICS:                     
        case NCSI_CMD_TYPE_GET_NCSI_PASS_THROUGH_STATISTICS:        
	        STRUCT_PRINT((disp_str, "\tNo Payload for valid NCSI Type Code = %x\n", choice));
            break; 
        default:
	        STRUCT_PRINT((disp_str, "\tInvalid NCSI Type Code = %x\n", choice));
            break;   
    }             
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdPkt

DESCRIPTION:    This routine decode the structure/union NcsiRmiiCmdPkt_t

IN PARAMETERS:  pointer to NcsiRmiiCmdPkt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdPkt(Tcl_Obj* rc_ptr, const NcsiRmiiCmdPkt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Header->\n"));
	DecodeNcsiControlPktHeader( rc_ptr, &data->Header);

    if (data->Header.EtherType != NCSI_ETHER_TYPE_ID)
    {
    	STRUCT_PRINT((disp_str,  "Non NCSI Command!!\n"));
    }
    else
    {
    	STRUCT_PRINT((disp_str,  "Payload->\n"));
	    DecodeNcsiCmdPayload( rc_ptr, data->Header.TypeCode, &data->Payload);
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdPkt

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdRspStatus

DESCRIPTION:    This routine decode the structure/union NcsiCmdRspStatus_t

IN PARAMETERS:  pointer to NcsiCmdRspStatus_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdRspStatus(Tcl_Obj* rc_ptr, const NcsiCmdRspStatus_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	if ((data->ResponseCode & 0xFFFFFFFF) == NCSI_CMD_RSP_CODE_CMD_COMPLETED_OK) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSP_CODE_CMD_COMPLETED_OK)\n")); 
	}
	else if ((data->ResponseCode & 0xFFFFFFFF) == NCSI_CMD_RSP_CODE_CMD_FAILED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSP_CODE_CMD_FAILED)\n")); 
	}
	else if ((data->ResponseCode & 0xFFFFFFFF) == NCSI_CMD_RSP_CODE_CMD_UNAVAILABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSP_CODE_CMD_UNAVAILABLE)\n")); 
	}
	else if ((data->ResponseCode & 0xFFFFFFFF) == NCSI_CMD_RSP_CODE_CMD_UNSUPPORTED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSP_CODE_CMD_UNSUPPORTED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_NO_ERROR) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_NO_ERROR)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_INTERFACE_INIT_REQUIRED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_INTERFACE_INIT_REQUIRED)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_PARAMETER_INVALID_OUT_OF_RANGE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_PARAMETER_INVALID_OUT_OF_RANGE)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_CHANNEL_NOT_READY) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_CHANNEL_NOT_READY)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_PACKAGE_NOT_READY) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_PACKAGE_NOT_READY)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_INVALID_PAYLOAD_LENGTH) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_INVALID_PAYLOAD_LENGTH)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_VLAN_TAG_OF_0_IS_INVALID) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_VLAN_TAG_OF_0_IS_INVALID)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_MAC_ADDR_OF_0_IS_INVALID) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_MAC_ADDR_OF_0_IS_INVALID)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_ASYNCH_FC_NOT_SUPPORTED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_ASYNCH_FC_NOT_SUPPORTED)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_OEM_GENERIC_RSN_CODE_OS_CONFLICT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_OEM_GENERIC_RSN_CODE_OS_CONFLICT)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_OEM_GENERIC_RSN_CODE_OEM_PAYLOAD_VER_ERR) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_OEM_GENERIC_RSN_CODE_OEM_PAYLOAD_VER_ERR)\n")); 
	}
	else if ((data->ReasonCode & 0xFFFFFFFF) == NCSI_CMD_RSN_CODE_UNK_CMD_TYPE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_RSN_CODE_UNK_CMD_TYPE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tCMD_OEM_SPECIFIC_RSN_CODE_TYPE = 0x%x \n", (u32_t)(data->ReasonCode & NCSI_CMD_OEM_SPECIFIC_RSN_CODE_TYPE_MASK)>>8));
	STRUCT_PRINT((disp_str,  "\tCMD_OEM_SPECIFIC_RSN_CODE_ERR = 0x%x \n", (u32_t)(data->ReasonCode & NCSI_CMD_OEM_SPECIFIC_RSN_CODE_ERR_MASK)>>0));
	if ((data->ReasonCode & NCSI_CMD_OEM_SPECIFIC_RSN_CODE_ERR_MASK) == NCSI_CMD_OEM_SPECIFIC_RSN_CODE_MAC_ADDR_INIT_ERR) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_OEM_SPECIFIC_RSN_CODE_MAC_ADDR_INIT_ERR)\n")); 
	}
	else if ((data->ReasonCode & NCSI_CMD_OEM_SPECIFIC_RSN_CODE_ERR_MASK) == NCSI_CMD_OEM_SPECIFIC_RSN_CODE_VLAN_TAG_INIT_ERR) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_OEM_SPECIFIC_RSN_CODE_VLAN_TAG_INIT_ERR)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdRspStatus


/*****************************************************************************

FUNCTION:       DecodeOemDefaultReturnData

DESCRIPTION:    This routine decode the structure/union OemDefaultReturnData_t

IN PARAMETERS:  pointer to OemDefaultReturnData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeOemDefaultReturnData(Tcl_Obj* rc_ptr, const OemDefaultReturnData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "BrcmOemCmdRspHeader->\n"));
	DecodeBrcmOemCmdRspHeader( rc_ptr, &data->BrcmOemCmdRspHeader);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeOemDefaultReturnData

/*****************************************************************************

FUNCTION:       DecodeNcsiDefaultOemCmdRspData

DESCRIPTION:    This routine decode the structure/union NcsiDefaultOemCmdRspData_t

IN PARAMETERS:  pointer to NcsiDefaultOemCmdRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiDefaultOemCmdRspData(Tcl_Obj* rc_ptr, const NcsiDefaultOemCmdRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ManufacturerId = 0x%x\n", (u32_t)(data->ManufacturerId)));
	if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_BROADCOM_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (BROADCOM_IANA)\n")); 
	}
	else if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_DELL_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (DELL_IANA)\n")); 
	}
	STRUCT_PRINT((disp_str,  "ReturnData->\n"));
	DecodeOemDefaultReturnData( rc_ptr, &data->ReturnData);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiDefaultOemCmdRspData

/*****************************************************************************

FUNCTION:       DecodeOemTestReturnData

DESCRIPTION:    This routine decode the structure/union OemTestReturnData_t

IN PARAMETERS:  pointer to OemTestReturnData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeOemTestReturnData(Tcl_Obj* rc_ptr, const OemTestReturnData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "BrcmOemCmdRspHeader->\n"));
	DecodeBrcmOemCmdRspHeader( rc_ptr, &data->BrcmOemCmdRspHeader);

	STRUCT_PRINT((disp_str,  "OemPayload[0 .. %d] = ", (33) - 1));
	for (loop_index = 0; loop_index < (33); loop_index++)  // u32 array 
	{
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->OemPayload)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeOemTestReturnData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdNcsiTestReadCmdRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdNcsiTestReadCmdRspData_t

IN PARAMETERS:  pointer to NcsiCmdNcsiTestReadCmdRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdNcsiTestReadCmdRspData(Tcl_Obj* rc_ptr, const NcsiCmdNcsiTestReadCmdRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ManufacturerId = 0x%x\n", (u32_t)(data->ManufacturerId)));
	if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_BROADCOM_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (BROADCOM_IANA)\n")); 
	}
	else if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_DELL_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (DELL_IANA)\n")); 
	}
	STRUCT_PRINT((disp_str,  "ReturnData->\n"));
	DecodeOemTestReturnData( rc_ptr, &data->ReturnData);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdNcsiTestReadCmdRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiOemGetNcsiParametersPayload

DESCRIPTION:    This routine decode the structure/union NcsiOemGetNcsiParametersPayload_t

IN PARAMETERS:  pointer to NcsiOemGetNcsiParametersPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiOemGetNcsiParametersPayload(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "NcsiFwVersionNumber = 0x%x\n", (u32_t)(data->NcsiFwVersionNumber)));
	STRUCT_PRINT((disp_str,  "BootcodeVersionNumber = 0x%x\n", (u32_t)(data->BootcodeVersionNumber)));
	STRUCT_PRINT((disp_str,  "PxeBootVersionNumber = 0x%x\n", (u32_t)(data->PxeBootVersionNumber)));
	STRUCT_PRINT((disp_str,  "IScsiBootVersionNumber = 0x%x\n", (u32_t)(data->IScsiBootVersionNumber)));
	STRUCT_PRINT((disp_str,  "OemLinkSettings = 0x%x\n", (u32_t)(data->OemLinkSettings)));
	STRUCT_PRINT((disp_str,  "HostMacAddrHigh = 0x%x\n", (u32_t)(data->HostMacAddrHigh)));
	STRUCT_PRINT((disp_str,  "HostMacAddrMiddle = 0x%x\n", (u32_t)(data->HostMacAddrMiddle)));
	STRUCT_PRINT((disp_str,  "HostMacAddrLow = 0x%x\n", (u32_t)(data->HostMacAddrLow)));
	STRUCT_PRINT((disp_str,  "HostVirtualL2MacAddrHigh = 0x%x\n", (u32_t)(data->HostVirtualL2MacAddrHigh)));
	STRUCT_PRINT((disp_str,  "HostVirtualL2MacAddrMiddle = 0x%x\n", (u32_t)(data->HostVirtualL2MacAddrMiddle)));
	STRUCT_PRINT((disp_str,  "HostVirtualL2MacAddrLow = 0x%x\n", (u32_t)(data->HostVirtualL2MacAddrLow)));
	STRUCT_PRINT((disp_str,  "HostIscsiMacAddrHigh = 0x%x\n", (u32_t)(data->HostIscsiMacAddrHigh)));
	STRUCT_PRINT((disp_str,  "HostIscsiMacAddrMiddle = 0x%x\n", (u32_t)(data->HostIscsiMacAddrMiddle)));
	STRUCT_PRINT((disp_str,  "HostIscsiMacAddrLow = 0x%x\n", (u32_t)(data->HostIscsiMacAddrLow)));
	STRUCT_PRINT((disp_str,  "HostVirtualIscsiMacAddrHigh = 0x%x\n", (u32_t)(data->HostVirtualIscsiMacAddrHigh)));
	STRUCT_PRINT((disp_str,  "HostVirtualIscsiMacAddrMiddle = 0x%x\n", (u32_t)(data->HostVirtualIscsiMacAddrMiddle)));
	STRUCT_PRINT((disp_str,  "HostVirtualIscsiMacAddrLow = 0x%x\n", (u32_t)(data->HostVirtualIscsiMacAddrLow)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiOemGetNcsiParametersPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiOemGetNcsiParametersReturnData

DESCRIPTION:    This routine decode the structure/union NcsiOemGetNcsiParametersReturnData_t

IN PARAMETERS:  pointer to NcsiOemGetNcsiParametersReturnData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiOemGetNcsiParametersReturnData(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersReturnData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "BrcmOemCmdRspHeader->\n"));
	DecodeBrcmOemCmdRspHeader( rc_ptr, &data->BrcmOemCmdRspHeader);

	STRUCT_PRINT((disp_str,  "OemPayload->\n"));
	DecodeNcsiOemGetNcsiParametersPayload( rc_ptr, &data->OemPayload);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiOemGetNcsiParametersReturnData

/*****************************************************************************

FUNCTION:       DecodeNcsiOemGetNcsiParametersRspData

DESCRIPTION:    This routine decode the structure/union NcsiOemGetNcsiParametersRspData_t

IN PARAMETERS:  pointer to NcsiOemGetNcsiParametersRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiOemGetNcsiParametersRspData(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ManufacturerId = 0x%x\n", (u32_t)(data->ManufacturerId)));
	if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_BROADCOM_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (BROADCOM_IANA)\n")); 
	}
	else if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_DELL_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (DELL_IANA)\n")); 
	}
	STRUCT_PRINT((disp_str,  "ReturnData->\n"));
	DecodeNcsiOemGetNcsiParametersReturnData( rc_ptr, &data->ReturnData);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiOemGetNcsiParametersRspData



/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetParametersRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetParametersRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetParametersRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetParametersRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetParametersRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "MacAddrCount = 0x%x\n", (u32_t)(data->MacAddrCount)));
	STRUCT_PRINT((disp_str,  "Reserved0[0 .. %d] = ", (2) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->Reserved0)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if (((u32_t *)data->Reserved0)[loop_index] == 0) continue;
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->Reserved0)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));


	STRUCT_PRINT((disp_str,  "MacAddrFlags = 0x%x\n", (u32_t)(data->MacAddrFlags)));
	STRUCT_PRINT((disp_str,  "VlanTagCount = 0x%x\n", (u32_t)(data->VlanTagCount)));
	if (data->Reserved1 != 0)
	STRUCT_PRINT((disp_str,  "Reserved1 = 0x%x\n", (u32_t)(data->Reserved1)));
	STRUCT_PRINT((disp_str,  "VlanTagFlags = 0x%x\n", (u32_t)(data->VlanTagFlags)));
	STRUCT_PRINT((disp_str,  "LinkSettings = 0x%x\n", (u32_t)(data->LinkSettings)));
	STRUCT_PRINT((disp_str,  "BroadcastFilterSettings = 0x%x\n", (u32_t)(data->BroadcastFilterSettings)));
	STRUCT_PRINT((disp_str,  "ConfigurationFlags = 0x%x\n", (u32_t)(data->ConfigurationFlags)));
	STRUCT_PRINT((disp_str,  "VlanMode = 0x%x\n", (u32_t)(data->VlanMode)));
	STRUCT_PRINT((disp_str,  "FcEnable = 0x%x\n", (u32_t)(data->FcEnable)));
	if (data->Reserved2 != 0)
	STRUCT_PRINT((disp_str,  "Reserved2 = 0x%x\n", (u32_t)(data->Reserved2)));
	STRUCT_PRINT((disp_str,  "AenControl = 0x%x\n", (u32_t)(data->AenControl)));
	for (loop_index = 0; loop_index < (NCSI_MAC_ADDRESS_MAX); loop_index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "Mac[%d]->\n", loop_index));

		{u32_t j;
		for (j = 0; j < sizeof(NcsiMacAddr_t)/sizeof(u32_t); j++)  // array 
		{
			if ((j & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
			SPECIAL_DBG_PRINT((disp_str,  " 0x%08x",  ((u32_t *)data->Mac)[loop_index * (sizeof(NcsiMacAddr_t)/sizeof(u32_t)) +j]));
		}}// Unknown type !!!
	
		SPECIAL_DBG_PRINT((disp_str,  "\n"));
		//		DecodeNcsiMacAddr(rc_ptr, &data->Mac[loop_index]);

	}

	STRUCT_PRINT((disp_str,  "VlanTag[0 .. %d] = ", (NCSI_VLAN_TAG_COUNT) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u16[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->VlanTag)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->VlanTag)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetParametersRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetCapabilitiesRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetCapabilitiesRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetCapabilitiesRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetCapabilitiesRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetCapabilitiesRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "Flags = 0x%x\n", (u32_t)(data->Flags)));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_HW_ARBITRATION = 0x%x \n", (u32_t)(data->Flags & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_HW_ARBITRATION)>>0));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_OS_AWARENESS = 0x%x \n", (u32_t)(data->Flags & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_OS_AWARENESS)>>1));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_TX_FLOWCONTROL = 0x%x \n", (u32_t)(data->Flags & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_TX_FLOWCONTROL)>>2));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_RX_FLOWCONTROL = 0x%x \n", (u32_t)(data->Flags & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_RX_FLOWCONTROL)>>3));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_MULTICAST_SUPPORT = 0x%x \n", (u32_t)(data->Flags & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_CAPABILITY_FLAG_MULTICAST_SUPPORT)>>4));
	STRUCT_PRINT((disp_str,  "BroadcastFiltering = 0x%x\n", (u32_t)(data->BroadcastFiltering)));
	STRUCT_PRINT((disp_str,  "MulticastFiltering = 0x%x\n", (u32_t)(data->MulticastFiltering)));
	STRUCT_PRINT((disp_str,  "IngressBuffering = 0x%x\n", (u32_t)(data->IngressBuffering)));
	STRUCT_PRINT((disp_str,  "AenControl = 0x%x\n", (u32_t)(data->AenControl)));
	STRUCT_PRINT((disp_str,  "VlanFilterCount = 0x%x\n", (u32_t)(data->VlanFilterCount)));
	STRUCT_PRINT((disp_str,  "MixedMacFilterCount = 0x%x\n", (u32_t)(data->MixedMacFilterCount)));
	STRUCT_PRINT((disp_str,  "MulticastFilterCount = 0x%x\n", (u32_t)(data->MulticastFilterCount)));
	STRUCT_PRINT((disp_str,  "UnicastFilterCount = 0x%x\n", (u32_t)(data->UnicastFilterCount)));
	if (data->Reserved0 != 0)
	STRUCT_PRINT((disp_str,  "Reserved0 = 0x%x\n", (u32_t)(data->Reserved0)));
	STRUCT_PRINT((disp_str,  "VlanModes = 0x%x\n", (u32_t)(data->VlanModes)));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_VLAN_ONLY = 0x%x \n", (u32_t)(data->VlanModes & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_VLAN_ONLY)>>0));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_VLAN_NON_VLAN = 0x%x \n", (u32_t)(data->VlanModes & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_VLAN_NON_VLAN)>>1));
	STRUCT_PRINT((disp_str,  "\tCMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_PROMISCUOUS_VLAN = 0x%x \n", (u32_t)(data->VlanModes & NCSI_CMD_GET_CAPABILITY_RSP_PAYLOAD_VLAN_MODE_PROMISCUOUS_VLAN)>>2));
	STRUCT_PRINT((disp_str,  "ChannelCount = 0x%x\n", (u32_t)(data->ChannelCount)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetCapabilitiesRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetLinkStatusRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetLinkStatusRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetLinkStatusRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetLinkStatusRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetLinkStatusRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "LinkState = 0x%x\n", (u32_t)(data->LinkState)));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK          = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_MASK)>>0));
	if ((data->LinkState & LINK_STATUS_LINK_MASK) == LINK_STATUS_LINK_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_ENABLED)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_NO_HCD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_NO_HCD)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_SPEED_AND_DUPLEX = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK)>>1));
	if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_10BASE_T_HD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_10BASE_T_HD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_10BASE_T_FD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_10BASE_T_FD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_100BASE_TX_HD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_100BASE_TX_HD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_100BASE_TX_FD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_100BASE_TX_FD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_1000BASE_T_FD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_1000BASE_T_FD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_UMP_2_5GB_HD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_UMP_2_5GB_HD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_UMP_2_5GB_FD) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_UMP_2_5GB_FD)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_UMP_10GBASE_T) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_UMP_10GBASE_T)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_LINK_SPEED_DUPLEX_NCSI_10GBASE_T) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_SPEED_DUPLEX_NCSI_10GBASE_T)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_AUTO_NEG_ENABLED = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_AUTO_NEG_ENABLED)>>5));
	STRUCT_PRINT((disp_str,  "\tSTATUS_AUTO_NEG_COMPLETE = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_AUTO_NEG_COMPLETE)>>6));
	STRUCT_PRINT((disp_str,  "\tSTATUS_PARALLEL_DETECTION = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_PARALLEL_DETECTION)>>7));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_PAUSE_FC_CAPABLE = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_PAUSE_FC_CAPABLE)>>8));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_1000BASE_T_FD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_1000BASE_T_FD)>>9));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_1000BASE_T_HD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_1000BASE_T_HD)>>10));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_100BASE_TX_FD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_100BASE_TX_FD)>>12));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_100BASE_TX_HD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_100BASE_TX_HD)>>13));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_10BASE_T_FD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_10BASE_T_FD)>>14));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_10BASE_T_HD = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_SPEED_DUPLEX_10BASE_T_HD)>>15));
	STRUCT_PRINT((disp_str,  "\tSTATUS_TX_FC_ENABLED = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_TX_FC_ENABLED)>>16));
	STRUCT_PRINT((disp_str,  "\tSTATUS_RX_FC_ENABLED = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_RX_FC_ENABLED)>>17));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_ADVERTIZED_FC_1000X = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_MASK)>>18));
	if ((data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_MASK) == LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_NO_PAUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_NO_PAUSE)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_MASK) == LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_SYM_PAUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_SYM_PAUSE)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_MASK) == LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_ASYM_PAUSE_TO_PARTNER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_ASYM_PAUSE_TO_PARTNER)\n")); 
	}
	else if ((data->LinkState & LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_MASK) == LINK_STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_SYM_ASYM_PAUSE_TO_PARTNER) 
	{
		STRUCT_PRINT((disp_str,  "\t   (STATUS_LINK_PARTNER_ADVERTIZED_FC_1000X_SYM_ASYM_PAUSE_TO_PARTNER)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_SERDES_FLAG   = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_SERDES_FLAG)>>20));
	STRUCT_PRINT((disp_str,  "\tSTATUS_OEM_LINK_SPEED_VALID_FLAG = 0x%x \n", (u32_t)(data->LinkState & LINK_STATUS_OEM_LINK_SPEED_VALID_FLAG)>>21));
	STRUCT_PRINT((disp_str,  "OtherIndications = 0x%x\n", (u32_t)(data->OtherIndications)));
	STRUCT_PRINT((disp_str,  "OemLinkSpeed = 0x%x\n", (u32_t)(data->OemLinkSpeed)));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_SPEED_DUPLEX_NCSI_2_5GB_HD = 0x%x \n", (u32_t)(data->OemLinkSpeed & LINK_STATUS_LINK_SPEED_DUPLEX_NCSI_2_5GB_HD)>>0));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_SPEED_DUPLEX_NCSI_2_5GB_FD = 0x%x \n", (u32_t)(data->OemLinkSpeed & LINK_STATUS_LINK_SPEED_DUPLEX_NCSI_2_5GB_FD)>>1));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetLinkStatusRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetNcsiStatisticsRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetNcsiStatisticsRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetNcsiStatisticsRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetNcsiStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiStatisticsRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "CommandPktsRx = 0x%x\n", (u32_t)(data->CommandPktsRx)));
	STRUCT_PRINT((disp_str,  "TotalCommandPktsDropped = 0x%x\n", (u32_t)(data->TotalCommandPktsDropped)));
	STRUCT_PRINT((disp_str,  "CommandPktsDroppedTypeError = 0x%x\n", (u32_t)(data->CommandPktsDroppedTypeError)));
	STRUCT_PRINT((disp_str,  "CommandPktsDroppedCsError = 0x%x\n", (u32_t)(data->CommandPktsDroppedCsError)));
	STRUCT_PRINT((disp_str,  "TotalControlPktsRx = 0x%x\n", (u32_t)(data->TotalControlPktsRx)));
	STRUCT_PRINT((disp_str,  "TotalControlPktsTx = 0x%x\n", (u32_t)(data->TotalControlPktsTx)));
	STRUCT_PRINT((disp_str,  "TotalAensSent = 0x%x\n", (u32_t)(data->TotalAensSent)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetNcsiStatisticsRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetNcsiPassThruStatisticsRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetNcsiPassThruStatisticsRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetNcsiPassThruStatisticsRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetNcsiPassThruStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiPassThruStatisticsRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "TotalEgressPktsHigh = 0x%x\n", (u32_t)(data->TotalEgressPktsHigh)));
	STRUCT_PRINT((disp_str,  "TotalEgressPktsLow = 0x%x\n", (u32_t)(data->TotalEgressPktsLow)));
	STRUCT_PRINT((disp_str,  "TotalEgressPktsDropped = 0x%x\n", (u32_t)(data->TotalEgressPktsDropped)));
	STRUCT_PRINT((disp_str,  "EgressPktsDroppedChannelStateError = 0x%x\n", (u32_t)(data->EgressPktsDroppedChannelStateError)));
	STRUCT_PRINT((disp_str,  "EgressPktsDroppedUndersizedError = 0x%x\n", (u32_t)(data->EgressPktsDroppedUndersizedError)));
	STRUCT_PRINT((disp_str,  "EgressPktsDroppedOversizedError = 0x%x\n", (u32_t)(data->EgressPktsDroppedOversizedError)));
	STRUCT_PRINT((disp_str,  "TotalIngressPkts = 0x%x\n", (u32_t)(data->TotalIngressPkts)));
	STRUCT_PRINT((disp_str,  "TotalIngressPktsDropped = 0x%x\n", (u32_t)(data->TotalIngressPktsDropped)));
	STRUCT_PRINT((disp_str,  "IngressPktsDroppedChannelStateError = 0x%x\n", (u32_t)(data->IngressPktsDroppedChannelStateError)));
	STRUCT_PRINT((disp_str,  "IngressPktsDroppedUndersizedError = 0x%x\n", (u32_t)(data->IngressPktsDroppedUndersizedError)));
	STRUCT_PRINT((disp_str,  "IngressPktsDroppedOversizedError = 0x%x\n", (u32_t)(data->IngressPktsDroppedOversizedError)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetNcsiPassThruStatisticsRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiNicEmacStats

DESCRIPTION:    This routine decode the structure/union NcsiNicEmacStats_t

IN PARAMETERS:  pointer to NcsiNicEmacStats_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiNicEmacStats(Tcl_Obj* rc_ptr, const NcsiNicEmacStats_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "TotalBytesRx_High = 0x%x\n", (u32_t)(data->TotalBytesRx_High)));
	STRUCT_PRINT((disp_str,  "TotalBytesRx_Low = 0x%x\n", (u32_t)(data->TotalBytesRx_Low)));
	STRUCT_PRINT((disp_str,  "TotalBytesTx_High = 0x%x\n", (u32_t)(data->TotalBytesTx_High)));
	STRUCT_PRINT((disp_str,  "TotalBytesTx_Low = 0x%x\n", (u32_t)(data->TotalBytesTx_Low)));
	STRUCT_PRINT((disp_str,  "TotalUnicastPktsRx_High = 0x%x\n", (u32_t)(data->TotalUnicastPktsRx_High)));
	STRUCT_PRINT((disp_str,  "TotalUnicastPktsRx_Low = 0x%x\n", (u32_t)(data->TotalUnicastPktsRx_Low)));
	STRUCT_PRINT((disp_str,  "TotalMulticastPktsRx_High = 0x%x\n", (u32_t)(data->TotalMulticastPktsRx_High)));
	STRUCT_PRINT((disp_str,  "TotalMulticastPktsRx_Low = 0x%x\n", (u32_t)(data->TotalMulticastPktsRx_Low)));
	STRUCT_PRINT((disp_str,  "TotalBroadcastPktsRx_High = 0x%x\n", (u32_t)(data->TotalBroadcastPktsRx_High)));
	STRUCT_PRINT((disp_str,  "TotalBroadcastPktsRx_Low = 0x%x\n", (u32_t)(data->TotalBroadcastPktsRx_Low)));
	STRUCT_PRINT((disp_str,  "TotalUnicastPktsTx_High = 0x%x\n", (u32_t)(data->TotalUnicastPktsTx_High)));
	STRUCT_PRINT((disp_str,  "TotalUnicastPktsTx_Low = 0x%x\n", (u32_t)(data->TotalUnicastPktsTx_Low)));
	STRUCT_PRINT((disp_str,  "TotalMulticastPktsTx_High = 0x%x\n", (u32_t)(data->TotalMulticastPktsTx_High)));
	STRUCT_PRINT((disp_str,  "TotalMulticastPktsTx_Low = 0x%x\n", (u32_t)(data->TotalMulticastPktsTx_Low)));
	STRUCT_PRINT((disp_str,  "TotalBroadcastPktsTx_High = 0x%x\n", (u32_t)(data->TotalBroadcastPktsTx_High)));
	STRUCT_PRINT((disp_str,  "TotalBroadcastPktsTx_Low = 0x%x\n", (u32_t)(data->TotalBroadcastPktsTx_Low)));
	STRUCT_PRINT((disp_str,  "CrcRxErrors = 0x%x\n", (u32_t)(data->CrcRxErrors)));
	STRUCT_PRINT((disp_str,  "AlignmentErrors = 0x%x\n", (u32_t)(data->AlignmentErrors)));
	STRUCT_PRINT((disp_str,  "FalseCarrierDetects = 0x%x\n", (u32_t)(data->FalseCarrierDetects)));
	STRUCT_PRINT((disp_str,  "RuntPktsRx = 0x%x\n", (u32_t)(data->RuntPktsRx)));
	STRUCT_PRINT((disp_str,  "JabberPktsRx = 0x%x\n", (u32_t)(data->JabberPktsRx)));
	STRUCT_PRINT((disp_str,  "PauseXonFramesRx = 0x%x\n", (u32_t)(data->PauseXonFramesRx)));
	STRUCT_PRINT((disp_str,  "PauseXoffFramesRx = 0x%x\n", (u32_t)(data->PauseXoffFramesRx)));
	STRUCT_PRINT((disp_str,  "PauseXonFramesTx = 0x%x\n", (u32_t)(data->PauseXonFramesTx)));
	STRUCT_PRINT((disp_str,  "PauseXoffFramesTx = 0x%x\n", (u32_t)(data->PauseXoffFramesTx)));
	STRUCT_PRINT((disp_str,  "SingleCollisionTxFrames = 0x%x\n", (u32_t)(data->SingleCollisionTxFrames)));
	STRUCT_PRINT((disp_str,  "MultipleCollisionTxFrames = 0x%x\n", (u32_t)(data->MultipleCollisionTxFrames)));
	STRUCT_PRINT((disp_str,  "LateCollisionFrames = 0x%x\n", (u32_t)(data->LateCollisionFrames)));
	STRUCT_PRINT((disp_str,  "ExcessiveCollisionFrames = 0x%x\n", (u32_t)(data->ExcessiveCollisionFrames)));
	STRUCT_PRINT((disp_str,  "ControlFramesRx = 0x%x\n", (u32_t)(data->ControlFramesRx)));
	STRUCT_PRINT((disp_str,  "FramesRx64Byte = 0x%x\n", (u32_t)(data->FramesRx64Byte)));
	STRUCT_PRINT((disp_str,  "FramesRx65_127Bytes = 0x%x\n", (u32_t)(data->FramesRx65_127Bytes)));
	STRUCT_PRINT((disp_str,  "FramesRx128_255Bytes = 0x%x\n", (u32_t)(data->FramesRx128_255Bytes)));
	STRUCT_PRINT((disp_str,  "FramesRx256_511Bytes = 0x%x\n", (u32_t)(data->FramesRx256_511Bytes)));
	STRUCT_PRINT((disp_str,  "FramesRx512_1023Bytes = 0x%x\n", (u32_t)(data->FramesRx512_1023Bytes)));
	STRUCT_PRINT((disp_str,  "FramesRx1024_1522Bytes = 0x%x\n", (u32_t)(data->FramesRx1024_1522Bytes)));
	STRUCT_PRINT((disp_str,  "FramesRx1523_9022Bytes = 0x%x\n", (u32_t)(data->FramesRx1523_9022Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx64Byte = 0x%x\n", (u32_t)(data->FramesTx64Byte)));
	STRUCT_PRINT((disp_str,  "FramesTx65_127Bytes = 0x%x\n", (u32_t)(data->FramesTx65_127Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx128_255Bytes = 0x%x\n", (u32_t)(data->FramesTx128_255Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx256_511Bytes = 0x%x\n", (u32_t)(data->FramesTx256_511Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx512_1023Bytes = 0x%x\n", (u32_t)(data->FramesTx512_1023Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx1024_1522Bytes = 0x%x\n", (u32_t)(data->FramesTx1024_1522Bytes)));
	STRUCT_PRINT((disp_str,  "FramesTx1523_9022Bytes = 0x%x\n", (u32_t)(data->FramesTx1523_9022Bytes)));
	STRUCT_PRINT((disp_str,  "ValidBytesRx_High = 0x%x\n", (u32_t)(data->ValidBytesRx_High)));
	STRUCT_PRINT((disp_str,  "ValidBytesRx_Low = 0x%x\n", (u32_t)(data->ValidBytesRx_Low)));
	STRUCT_PRINT((disp_str,  "ErrorRuntPktsRx = 0x%x\n", (u32_t)(data->ErrorRuntPktsRx)));
	STRUCT_PRINT((disp_str,  "ErrorJabberPktsRx = 0x%x\n", (u32_t)(data->ErrorJabberPktsRx)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiNicEmacStats

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetPortStatisticsRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetPortStatisticsRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetPortStatisticsRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetPortStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetPortStatisticsRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "CountersClearedHigh = 0x%x\n", (u32_t)(data->CountersClearedHigh)));
	STRUCT_PRINT((disp_str,  "CountersClearedLow = 0x%x\n", (u32_t)(data->CountersClearedLow)));
	STRUCT_PRINT((disp_str,  "Stats->\n"));
	DecodeNcsiNicEmacStats( rc_ptr, &data->Stats);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetPortStatisticsRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetControllerVerIdRspData

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetControllerVerIdRspData_t

IN PARAMETERS:  pointer to NcsiCmdGetControllerVerIdRspData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetControllerVerIdRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetControllerVerIdRspData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ResponseCode = 0x%x\n", (u32_t)(data->ResponseCode)));
	STRUCT_PRINT((disp_str,  "ReasonCode = 0x%x\n", (u32_t)(data->ReasonCode)));
	STRUCT_PRINT((disp_str,  "NcsiVersion->\n"));

	for (loop_index = 0; loop_index < sizeof(NcsiVersion_t)/sizeof(u32_t); loop_index++)  // array 
	{
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)&data->NcsiVersion)[loop_index]));
	}// Unknown type !!!
	
	//	DecodeNcsiVersion( rc_ptr, &data->NcsiVersion);

	STRUCT_PRINT((disp_str,  "FirmwareName[0 .. %d] = ", (12) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (loop_index = 0; loop_index < (sizeof(data->FirmwareName)+sizeof(u32_t)-1)/sizeof(u32_t); loop_index++)  // array (round to word) 
	{
		if ((loop_index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->FirmwareName)[loop_index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));

	STRUCT_PRINT((disp_str,  "\tBig Endian: \""));
	for (loop_index = 0; ((12) & 0x3) ==0 &&loop_index < (12)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->FirmwareName)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)(temp>>24)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)temp)));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));


	STRUCT_PRINT((disp_str,  "\tLittle Endian: \""));
	for (loop_index = 0; ((12) & 0x3) ==0 &&loop_index < (12)/sizeof(u32_t); loop_index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->FirmwareName)[loop_index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", CHK_ASCII((char)temp), CHK_ASCII((char)(temp>>8)), CHK_ASCII((char)(temp>>16)), CHK_ASCII((char)(temp>>24))));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));

	STRUCT_PRINT((disp_str,  "FirmwareRev = 0x%x\n", (u32_t)(data->FirmwareRev)));
	STRUCT_PRINT((disp_str,  "PciDeviceId = 0x%x\n", (u32_t)(data->PciDeviceId)));
	STRUCT_PRINT((disp_str,  "PciVendorId = 0x%x\n", (u32_t)(data->PciVendorId)));
	STRUCT_PRINT((disp_str,  "PciSubsystemId = 0x%x\n", (u32_t)(data->PciSubsystemId)));
	STRUCT_PRINT((disp_str,  "PciSubsystemVendorId = 0x%x\n", (u32_t)(data->PciSubsystemVendorId)));
	STRUCT_PRINT((disp_str,  "ManufacturerId = 0x%x\n", (u32_t)(data->ManufacturerId)));
	if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_BROADCOM_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (BROADCOM_IANA)\n")); 
	}
	else if ((data->ManufacturerId & 0xFFFFFFFF) == NCSI_DELL_IANA) 
	{
		STRUCT_PRINT((disp_str,  "\t   (DELL_IANA)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetControllerVerIdRspData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdDefaultRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdDefaultRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdDefaultRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdDefaultRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdDefaultRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdRspStatus( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdDefaultRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiDefaultOemCmdRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiDefaultOemCmdRspPayload_t

IN PARAMETERS:  pointer to NcsiDefaultOemCmdRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiDefaultOemCmdRspPayload(Tcl_Obj* rc_ptr, const NcsiDefaultOemCmdRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiDefaultOemCmdRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiDefaultOemCmdRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiOemGetNcsiParametersRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiOemGetNcsiParametersRspPayload_t

IN PARAMETERS:  pointer to NcsiOemGetNcsiParametersRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiOemGetNcsiParametersRspPayload(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiOemGetNcsiParametersRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiOemGetNcsiParametersRspPayload


/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetParametersRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetParametersRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetParametersRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetParametersRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetParametersRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetParametersRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetParametersRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdNcsiTestReadRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdNcsiTestReadRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdNcsiTestReadRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdNcsiTestReadRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdNcsiTestReadRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdNcsiTestReadCmdRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdNcsiTestReadRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetLinkStatusRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetLinkStatusRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetLinkStatusRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetLinkStatusRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetLinkStatusRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetLinkStatusRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetLinkStatusRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetCapabilitiesRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetCapabilitiesRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetCapabilitiesRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetCapabilitiesRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetCapabilitiesRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetCapabilitiesRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetCapabilitiesRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetPortStatisticsRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetPortStatisticsRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetPortStatisticsRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetPortStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetPortStatisticsRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetPortStatisticsRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetPortStatisticsRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetNcsiStatisticsRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetNcsiStatisticsRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetNcsiStatisticsRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetNcsiStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiStatisticsRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetNcsiStatisticsRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetNcsiStatisticsRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetNcsiPassThruStatisticsRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetNcsiPassThruStatisticsRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetNcsiPassThruStatisticsRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetNcsiPassThruStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiPassThruStatisticsRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetNcsiPassThruStatisticsRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetNcsiPassThruStatisticsRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdGetControllerVerIdRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdGetControllerVerIdRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdGetControllerVerIdRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdGetControllerVerIdRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetControllerVerIdRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdGetControllerVerIdRspData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdGetControllerVerIdRspPayload


/*****************************************************************************

FUNCTION:       DecodeNcsiCmdRspPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdRspPayload_t

IN PARAMETERS:  pointer to NcsiCmdRspPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdRspPayload(Tcl_Obj* rc_ptr, u32_t choice, const NcsiCmdRspPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
	switch(choice)
	{
        case NCSI_CMD_TYPE_OEM:  
            if (data->DefaultOemCmdPayload.Data.ReturnData.BrcmOemCmdRspHeader.CommandType == BRCM_OEM_GET_NCSI_PARAMETERS_CMD)
            {
            	STRUCT_PRINT((disp_str,  "GetNcsiParametersPayload->\n"));
            	DecodeNcsiOemGetNcsiParametersRspPayload( rc_ptr, &data->GetNcsiParametersPayload);
                break;
            }
            else if (data->DefaultOemCmdPayload.Data.ReturnData.BrcmOemCmdRspHeader.CommandType == BRCM_OEM_NCSI_TEST_CMD)
            {
            	STRUCT_PRINT((disp_str,  "NcsiTestReadPayload->\n"));
            	DecodeNcsiCmdNcsiTestReadRspPayload( rc_ptr, &data->NcsiTestReadPayload);
            }
            else if (data->DefaultOemCmdPayload.Data.ReturnData.BrcmOemCmdRspHeader.CommandType == BRCM_OEM_SET_ALT_HOST_MAC_ADDRESS_CMD)
            {
            	STRUCT_PRINT((disp_str,  "DefaultOemCmdPayload->\n"));
            	DecodeNcsiDefaultOemCmdRspPayload( rc_ptr, &data->DefaultOemCmdPayload);
            }
            else
            {
            	STRUCT_PRINT((disp_str, "\tUnrecognized OEM Command Type = %x\n", 
                	data->DefaultOemCmdPayload.Data.ReturnData.BrcmOemCmdRspHeader.CommandType));
                //for (loop_index = 0; loop_index < 10; loop_index++)
                //{
                //    STRUCT_PRINT((disp_str,  "debug[%d] = %x\n",loop_index, ((u32_t *)(&data->GetPartitionMacAddrCmdRspPayload))[loop_index]));
                //}
            }
            break; 
        case NCSI_CMD_TYPE_GET_PARAMETERS:                          
	        STRUCT_PRINT((disp_str,  "GetParametersPayload->\n"));
	        DecodeNcsiCmdGetParametersRspPayload( rc_ptr, &data->GetParametersPayload);
            break;
        case NCSI_CMD_TYPE_GET_LINK_STATUS:                         
	        STRUCT_PRINT((disp_str,  "GetLinkStatusPayload->\n"));
	        DecodeNcsiCmdGetLinkStatusRspPayload( rc_ptr, &data->GetLinkStatusPayload);
            break; 
        case NCSI_CMD_TYPE_GET_IF_STATISTICS:                       
	        STRUCT_PRINT((disp_str,  "GetStatisticsPayload->\n"));
	        DecodeNcsiCmdGetPortStatisticsRspPayload( rc_ptr, &data->GetStatisticsPayload);
            break;
        case NCSI_CMD_TYPE_GET_VERSION_ID:                          
	        STRUCT_PRINT((disp_str,  "GetCntlrVerIdPayload->\n"));
	        DecodeNcsiCmdGetControllerVerIdRspPayload( rc_ptr, &data->GetCntlrVerIdPayload);
            break; 
        case NCSI_CMD_TYPE_GET_NCSI_STATISTICS:                     
	        STRUCT_PRINT((disp_str,  "GetNcsiStatsPayload->\n"));
	        DecodeNcsiCmdGetNcsiStatisticsRspPayload( rc_ptr, &data->GetNcsiStatsPayload);
            break; 
        case NCSI_CMD_TYPE_GET_NCSI_PASS_THROUGH_STATISTICS:      
	        STRUCT_PRINT((disp_str,  "GetNcsiPassThruStatsPayload->\n"));
	        DecodeNcsiCmdGetNcsiPassThruStatisticsRspPayload( rc_ptr, &data->GetNcsiPassThruStatsPayload);
            break; 
        case NCSI_CMD_TYPE_GET_CAPABILITIES:                        
 	        STRUCT_PRINT((disp_str,  "GetCapabilitiesPayload->\n"));
	        DecodeNcsiCmdGetCapabilitiesRspPayload( rc_ptr, &data->GetCapabilitiesPayload);
            break; 

        case NCSI_CMD_TYPE_RESET_CHANNEL:           
        case NCSI_CMD_TYPE_ENABLE_CHANNEL:                 
        case NCSI_CMD_TYPE_DISABLE_CHANNEL:                 
        case NCSI_CMD_TYPE_SET_MAC_ADDRESS:                         
        case NCSI_CMD_TYPE_SET_VLAN_FILTERS:                
        case NCSI_CMD_TYPE_SET_LINK:            
        case NCSI_CMD_TYPE_ENABLE_AEN:              
        case NCSI_CMD_TYPE_ENABLE_BROADCAST_PKT_FILTER:             
        case NCSI_CMD_TYPE_PACKAGE_SELECT:          
        case NCSI_CMD_TYPE_SET_NCSI_FLOW_CONTROL:             
        case NCSI_CMD_TYPE_ENABLE_VLAN:   
        case NCSI_CMD_TYPE_ENABLE_MULTICAST_PKT_FILTER:             
        case NCSI_CMD_TYPE_CLEAR_INITIAL_STATE:    
        case NCSI_CMD_TYPE_PACKAGE_DESELECT:                        
        case NCSI_CMD_TYPE_ENABLE_CHANNEL_EGRESS_TX:                
        case NCSI_CMD_TYPE_DISABLE_CHANNEL_EGRESS_TX:               
        case NCSI_CMD_TYPE_DISABLE_VLAN:                            
        case NCSI_CMD_TYPE_DISABLE_BROADCAST_PKT_FILTER:            
        case NCSI_CMD_TYPE_DISABLE_MULTICAST_PKT_FILTER:            
        	STRUCT_PRINT((disp_str,  "DefaultPayload->\n"));
        	DecodeNcsiCmdDefaultRspPayload( rc_ptr, &data->DefaultPayload);
            break;
        default:
        	STRUCT_PRINT((disp_str, "\tInvalid NCSI Response Type Code = %x\n", choice ));
            break;                
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdRspPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiRmiiCmdRspPkt

DESCRIPTION:    This routine decode the structure/union NcsiRmiiCmdRspPkt_t

IN PARAMETERS:  pointer to NcsiRmiiCmdRspPkt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiRmiiCmdRspPkt(Tcl_Obj* rc_ptr, const NcsiRmiiCmdRspPkt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Header->\n"));
	DecodeNcsiControlPktHeader( rc_ptr, &data->Header);

    if (data->Header.EtherType != NCSI_ETHER_TYPE_ID)
    {
    	STRUCT_PRINT((disp_str,  "Non NCSI Response!!\n"));
    }
    else
    {
    	STRUCT_PRINT((disp_str,  "Payload->\n"));
	    DecodeNcsiCmdRspPayload( rc_ptr, data->Header.TypeCode & ~NCSI_CMD_RESPONSE_BIT, &data->Payload);
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiRmiiCmdRspPkt

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdDefaultAenData

DESCRIPTION:    This routine decode the structure/union NcsiCmdDefaultAenData_t

IN PARAMETERS:  pointer to NcsiCmdDefaultAenData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdDefaultAenData(Tcl_Obj* rc_ptr, const NcsiCmdDefaultAenData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "AenType = 0x%x\n", (u32_t)(data->AenType)));
	if ((data->AenType & 0xFFFFFFFF) == NCSI_CMD_AEN_TYPE_LINK_CHANGED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_AEN_TYPE_LINK_CHANGED)\n")); 
	}
	else if ((data->AenType & 0xFFFFFFFF) == NCSI_CMD_AEN_TYPE_SOFT_RESET) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_AEN_TYPE_SOFT_RESET)\n")); 
	}
	else if ((data->AenType & 0xFFFFFFFF) == NCSI_CMD_AEN_TYPE_OS_CHANGED) 
	{
		STRUCT_PRINT((disp_str,  "\t   (CMD_AEN_TYPE_OS_CHANGED)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdDefaultAenData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdLinkChangedAenData

DESCRIPTION:    This routine decode the structure/union NcsiCmdLinkChangedAenData_t

IN PARAMETERS:  pointer to NcsiCmdLinkChangedAenData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdLinkChangedAenData(Tcl_Obj* rc_ptr, const NcsiCmdLinkChangedAenData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "AenType = 0x%x\n", (u32_t)(data->AenType)));
	STRUCT_PRINT((disp_str,  "LinkState = 0x%x\n", (u32_t)(data->LinkState)));
	STRUCT_PRINT((disp_str,  "OemLinkSpeed = 0x%x\n", (u32_t)(data->OemLinkSpeed)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdLinkChangedAenData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdOsChangedAenData

DESCRIPTION:    This routine decode the structure/union NcsiCmdOsChangedAenData_t

IN PARAMETERS:  pointer to NcsiCmdOsChangedAenData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdOsChangedAenData(Tcl_Obj* rc_ptr, const NcsiCmdOsChangedAenData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "AenType = 0x%x\n", (u32_t)(data->AenType)));
	STRUCT_PRINT((disp_str,  "OsState = 0x%x\n", (u32_t)(data->OsState)));
	if ((data->OsState & 0xFFFFFFFF) == UMPCMDPUB_OS_STATE_CHANGED_AEN_OS_PRESENT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OS_STATE_CHANGED_AEN_OS_PRESENT)\n")); 
	}
	else if ((data->OsState & 0xFFFFFFFF) == UMPCMDPUB_OS_STATE_CHANGED_AEN_OS_ABSENT) 
	{
		STRUCT_PRINT((disp_str,  "\t   (OS_STATE_CHANGED_AEN_OS_ABSENT)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdOsChangedAenData

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdDefaultAenPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdDefaultAenPayload_t

IN PARAMETERS:  pointer to NcsiCmdDefaultAenPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdDefaultAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdDefaultAenPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdDefaultAenData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdDefaultAenPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdLinkChangedAenPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdLinkChangedAenPayload_t

IN PARAMETERS:  pointer to NcsiCmdLinkChangedAenPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdLinkChangedAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdLinkChangedAenPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdLinkChangedAenData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdLinkChangedAenPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdOsChangedAenPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdOsChangedAenPayload_t

IN PARAMETERS:  pointer to NcsiCmdOsChangedAenPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdOsChangedAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdOsChangedAenPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Data->\n"));
	DecodeNcsiCmdOsChangedAenData( rc_ptr, &data->Data);

	STRUCT_PRINT((disp_str,  "ChecksumCompensation = 0x%x\n", (u32_t)(data->ChecksumCompensation)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdOsChangedAenPayload


/*****************************************************************************

FUNCTION:       DecodeNcsiCmdAenPayload

DESCRIPTION:    This routine decode the structure/union NcsiCmdAenPayload_t

IN PARAMETERS:  pointer to NcsiCmdAenPayload_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdAenPayload_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
	switch(data->DefaultPayload.Data.AenType)
	{
        case NCSI_CMD_AEN_TYPE_SOFT_RESET:
	        STRUCT_PRINT((disp_str,  "DefaultPayload->\n"));
	        DecodeNcsiCmdDefaultAenPayload( rc_ptr, &data->DefaultPayload);
            break;
        case NCSI_CMD_AEN_TYPE_LINK_CHANGED:
	        STRUCT_PRINT((disp_str,  "LinkChangedPayload->\n"));
	        DecodeNcsiCmdLinkChangedAenPayload( rc_ptr, &data->LinkChangedPayload);
            break;
        case NCSI_CMD_AEN_TYPE_OS_CHANGED:
	        STRUCT_PRINT((disp_str,  "OsChangedPayload->\n"));
	        DecodeNcsiCmdOsChangedAenPayload( rc_ptr, &data->OsChangedPayload);
            break;
        default :
        	STRUCT_PRINT((disp_str,  "Unrecognized AEN Type = 0x%x\n", (u32_t)(data->DefaultPayload.Data.AenType)));
            break;
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdAenPayload

/*****************************************************************************

FUNCTION:       DecodeNcsiCmdAenPacket

DESCRIPTION:    This routine decode the structure/union NcsiCmdAenPacket_t

IN PARAMETERS:  pointer to NcsiCmdAenPacket_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiCmdAenPacket(Tcl_Obj* rc_ptr, const NcsiCmdAenPacket_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Header->\n"));
	DecodeNcsiControlPktHeader( rc_ptr, &data->Header);

    if (data->Header.EtherType != NCSI_ETHER_TYPE_ID)
    {
    	STRUCT_PRINT((disp_str,  "Non NCSI AEN Command!!\n"));
    }
    else
    {
    	STRUCT_PRINT((disp_str,  "Payload->\n"));
	    DecodeNcsiCmdAenPayload( rc_ptr, &data->Payload);
    }

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiCmdAenPacket



// ??????? move following declaration to header file
extern void DecodeNcsiControlPktHeader(Tcl_Obj* rc_ptr, const NcsiRmiiControlPktHeader_t * data);
extern void DecodeFwTestCmdPayload(Tcl_Obj* rc_ptr, const FwTestCmdPayload_t * data);
extern void DecodeBrcmOemCmdRspHeader(Tcl_Obj* rc_ptr, const BrcmOemCmdRspHeader_t * data);
extern void DecodeModifyHostMacAddrCmdPayload(Tcl_Obj* rc_ptr, const ModifyHostMacAddrCmdPayload_t * data);
extern void DecodeBrcmOemCmdPayload(Tcl_Obj* rc_ptr, u32_t choice, const BrcmOemCmdPayload_t * data);
extern void DecodeOemVendorData(Tcl_Obj* rc_ptr, void * data);
extern void DecodeNcsiCmdOemCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdOemCmdPayload_t * data);
extern void DecodeNcsiCmdSelectPackageCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSelectPackageCmdPayload_t * data);
extern void DecodeNcsiCmdEnableMulticastPacketFilteringCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableMulticastPacketFilteringCmdPayload_t * data);
extern void DecodeNcsiCmdSetNcsiFlowControlCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetNcsiFlowControlCmdPayload_t * data);
extern void DecodeNcsiCmdEnableVlanCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableVlanCmdPayload_t * data);
extern void DecodeNcsiCmdSetVlanCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetVlanCmdPayload_t * data);
extern void DecodeNcsiCmdEnableAenCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableAenCmdPayload_t * data);
extern void DecodeNcsiCmdSetMacAddrCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetMacAddrCmdPayload_t * data);
extern void DecodeNcsiCmdSetLinkCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdSetLinkCmdPayload_t * data);
extern void DecodeNcsiCmdDisableResetChannelCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdDisableResetChannelCmdPayload_t * data);
extern void DecodeNcsiCmdEnableBroadcastPacketFilteringCmdPayload(Tcl_Obj* rc_ptr, const NcsiCmdEnableBroadcastPacketFilteringCmdPayload_t * data);
extern void DecodeNcsiCmdPayload(Tcl_Obj* rc_ptr, u32_t choice, const NcsiCmdPayload_t * data);
extern void DecodeNcsiCmdPkt(Tcl_Obj* rc_ptr, const NcsiRmiiCmdPkt_t * data);
extern void DecodeNcsiCmdRspStatus(Tcl_Obj* rc_ptr, const NcsiCmdRspStatus_t * data);
extern void DecodeOemDefaultReturnData(Tcl_Obj* rc_ptr, const OemDefaultReturnData_t * data);
extern void DecodeNcsiDefaultOemCmdRspData(Tcl_Obj* rc_ptr, const NcsiDefaultOemCmdRspData_t * data);
extern void DecodeOemTestReturnData(Tcl_Obj* rc_ptr, const OemTestReturnData_t * data);
extern void DecodeNcsiCmdNcsiTestReadCmdRspData(Tcl_Obj* rc_ptr, const NcsiCmdNcsiTestReadCmdRspData_t * data);
extern void DecodeNcsiOemGetNcsiParametersPayload(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersPayload_t * data);
extern void DecodeNcsiOemGetNcsiParametersReturnData(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersReturnData_t * data);
extern void DecodeNcsiOemGetNcsiParametersRspData(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersRspData_t * data);
extern void DecodeNcsiCmdGetParametersRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetParametersRspData_t * data);
extern void DecodeNcsiCmdGetCapabilitiesRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetCapabilitiesRspData_t * data);
extern void DecodeNcsiCmdGetLinkStatusRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetLinkStatusRspData_t * data);
extern void DecodeNcsiCmdGetNcsiStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiStatisticsRspData_t * data);
extern void DecodeNcsiCmdGetNcsiPassThruStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiPassThruStatisticsRspData_t * data);
extern void DecodeNcsiNicEmacStats(Tcl_Obj* rc_ptr, const NcsiNicEmacStats_t * data);
extern void DecodeNcsiCmdGetPortStatisticsRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetPortStatisticsRspData_t * data);
extern void DecodeNcsiCmdGetControllerVerIdRspData(Tcl_Obj* rc_ptr, const NcsiCmdGetControllerVerIdRspData_t * data);
extern void DecodeNcsiCmdDefaultRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdDefaultRspPayload_t * data);
extern void DecodeNcsiDefaultOemCmdRspPayload(Tcl_Obj* rc_ptr, const NcsiDefaultOemCmdRspPayload_t * data);
extern void DecodeNcsiOemGetNcsiParametersRspPayload(Tcl_Obj* rc_ptr, const NcsiOemGetNcsiParametersRspPayload_t * data);
extern void DecodeNcsiCmdGetParametersRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetParametersRspPayload_t * data);
extern void DecodeNcsiCmdNcsiTestReadRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdNcsiTestReadRspPayload_t * data);
extern void DecodeNcsiCmdGetLinkStatusRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetLinkStatusRspPayload_t * data);
extern void DecodeNcsiCmdGetCapabilitiesRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetCapabilitiesRspPayload_t * data);
extern void DecodeNcsiCmdGetPortStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetPortStatisticsRspPayload_t * data);
extern void DecodeNcsiCmdGetNcsiStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiStatisticsRspPayload_t * data);
extern void DecodeNcsiCmdGetNcsiPassThruStatisticsRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetNcsiPassThruStatisticsRspPayload_t * data);
extern void DecodeNcsiCmdGetControllerVerIdRspPayload(Tcl_Obj* rc_ptr, const NcsiCmdGetControllerVerIdRspPayload_t * data);
extern void DecodeNcsiCmdRspPayload(Tcl_Obj* rc_ptr, u32_t choice, const NcsiCmdRspPayload_t * data);
extern void DecodeNcsiRmiiCmdRspPkt(Tcl_Obj* rc_ptr, const NcsiRmiiCmdRspPkt_t * data);
extern void DecodeNcsiCmdDefaultAenData(Tcl_Obj* rc_ptr, const NcsiCmdDefaultAenData_t * data);
extern void DecodeNcsiCmdLinkChangedAenData(Tcl_Obj* rc_ptr, const NcsiCmdLinkChangedAenData_t * data);
extern void DecodeNcsiCmdOsChangedAenData(Tcl_Obj* rc_ptr, const NcsiCmdOsChangedAenData_t * data);
extern void DecodeNcsiCmdDefaultAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdDefaultAenPayload_t * data);
extern void DecodeNcsiCmdLinkChangedAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdLinkChangedAenPayload_t * data);
extern void DecodeNcsiCmdOsChangedAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdOsChangedAenPayload_t * data);
extern void DecodeNcsiCmdAenPayload(Tcl_Obj* rc_ptr, const NcsiCmdAenPayload_t * data);
extern void DecodeNcsiCmdAenPacket(Tcl_Obj* rc_ptr, const NcsiCmdAenPacket_t * data);
