/****************************************************************************
 * Copyright(c) 2001-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 * Name:        decode_ncsi_basic_types.c
 *
 * Description: Decode structures in ncsi_basic_types.h 
 *
 * Created:     File generated from ..\..\..\..\hsi\mcp\ncsi_basic_types.h in 4/1/2010 dlau
 *     !!! Majority of the code is script generated. 
 *    Avoid modifying this file manually. Consult David Lau for help. 
 *
 ****************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "tcl.h"
#include "bcmtype.h"
#include "ncsi_basic_types.h"

#if defined(IA64) || defined(X86_64) || defined(LP64) || defined (PPC64)
    #define U32_CAST(x)  (u32_t)((u64_t)(uintptr_t)(x))
#else
    #define U32_CAST(x)  (u32_t)((uintptr_t)(x))
#endif


u32_t indent_level;

#ifndef INDENT_STRUCT
#define INDENT_STRUCT(tab_cnt) \
{\
	u32_t tab_index;\
	for (tab_index = 0; tab_index < tab_cnt; tab_index++) SPECIAL_DBG_TAB; \
}

#define STRUCT_PRINT(x)      {INDENT_STRUCT(indent_level); SPECIAL_DBG_PRINT(x);}
#endif // INDENT_STRUCT

// return printable ASCII character (return blank otherwise) 
#define CHK_ASCII(x)      (((x) > 31 && (x) < 127) ? (x) : ' ')

static u32_t loop_index;

static char disp_str[200];
#ifndef SPECIAL_DBG_PRINT
#define SPECIAL_DBG_PRINT(x)   \
{\
	sprintf x;\
	Tcl_AppendStringsToObj( rc_ptr, disp_str, NULL); \
}
#endif // SPECIAL_DBG_PRINT
#ifndef SPECIAL_DBG_TAB
#define SPECIAL_DBG_TAB  Tcl_AppendStringsToObj( rc_ptr, "\t", NULL) 
#endif // SPECIAL_DBG_TAB

/*****************************************************************************

FUNCTION:       DecodeNcsiVersion

DESCRIPTION:    This routine decode the structure/union NcsiVersion_t

IN PARAMETERS:  pointer to NcsiVersion_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiVersion(Tcl_Obj* rc_ptr, const NcsiVersion_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Major = 0x%x\n", (u32_t)(data->Major)));
	STRUCT_PRINT((disp_str,  "Minor = 0x%x\n", (u32_t)(data->Minor)));
	STRUCT_PRINT((disp_str,  "Update = 0x%x\n", (u32_t)(data->Update)));
	STRUCT_PRINT((disp_str,  "Alpha1 = 0x%x\n", (u32_t)(data->Alpha1)));
	if (data->Reserved0 != 0)
	STRUCT_PRINT((disp_str,  "Reserved0 = 0x%x\n", (u32_t)(data->Reserved0)));
	if (data->Reserved1 != 0)
	STRUCT_PRINT((disp_str,  "Reserved1 = 0x%x\n", (u32_t)(data->Reserved1)));
	if (data->Reserved2 != 0)
	STRUCT_PRINT((disp_str,  "Reserved2 = 0x%x\n", (u32_t)(data->Reserved2)));
	STRUCT_PRINT((disp_str,  "Alpha2 = 0x%x\n", (u32_t)(data->Alpha2)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiVersion

/*****************************************************************************

FUNCTION:       DecodeNcsiMacAddr

DESCRIPTION:    This routine decode the structure/union NcsiMacAddr_t

IN PARAMETERS:  pointer to NcsiMacAddr_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiMacAddr(Tcl_Obj* rc_ptr, const NcsiMacAddr_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "High = 0x%x\n", (u32_t)(data->High)));
	STRUCT_PRINT((disp_str,  "LowHigh = 0x%x\n", (u32_t)(data->LowHigh)));
	STRUCT_PRINT((disp_str,  "LowLow = 0x%x\n", (u32_t)(data->LowLow)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiMacAddr

/*****************************************************************************

FUNCTION:       DecodeUmpMacAddr

DESCRIPTION:    This routine decode the structure/union UmpMacAddr_t

IN PARAMETERS:  pointer to UmpMacAddr_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpMacAddr(Tcl_Obj* rc_ptr, const UmpMacAddr_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

    STRUCT_PRINT((disp_str,  "High = 0x%x\n", (u32_t)(data->High)));
	STRUCT_PRINT((disp_str,  "Low = 0x%x\n", (u32_t)(data->Low)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpMacAddr

/*****************************************************************************

FUNCTION:       DecodeMacAddrConfig

DESCRIPTION:    This routine decode the structure/union MacAddrConfig_t

IN PARAMETERS:  pointer to MacAddrConfig_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeMacAddrConfig(Tcl_Obj* rc_ptr, const MacAddrConfig_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "IsEnabled = 0x%x\n", (u32_t)(data->IsEnabled)));
	STRUCT_PRINT((disp_str,  "Addr->\n"));
	DecodeUmpMacAddr( rc_ptr, &data->Addr);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeMacAddrConfig

/*****************************************************************************

FUNCTION:       DecodeUmpVlan

DESCRIPTION:    This routine decode the structure/union UmpVlan_t

IN PARAMETERS:  pointer to UmpVlan_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpVlan(Tcl_Obj* rc_ptr, const UmpVlan_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "IsEnabled = 0x%x\n", (u32_t)(data->IsEnabled)));
	STRUCT_PRINT((disp_str,  "TagControlInfo = 0x%x\n", (u32_t)(data->TagControlInfo)));
	STRUCT_PRINT((disp_str,  "\tVLAN_TAG_VID_FIELD = 0x%x \n", (u32_t)(data->TagControlInfo & VLAN_TAG_VID_FIELD_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tVLAN_TAG_PRI_FIELD = 0x%x \n", (u32_t)(data->TagControlInfo & VLAN_TAG_PRI_FIELD_MASK)>>13));
	STRUCT_PRINT((disp_str,  "\tVLAN_TAG_CFI_FIELD = 0x%x \n", (u32_t)(data->TagControlInfo & VLAN_TAG_CFI_FIELD_MASK)>>12));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpVlan


/*****************************************************************************

FUNCTION:       DecodePktErrorStat

DESCRIPTION:    This routine decode the structure/union PktErrorStat_t

IN PARAMETERS:  pointer to PktErrorStat_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodePktErrorStat(Tcl_Obj* rc_ptr, const PktErrorStat_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "EgressPktsDroppedNoSaMatch = 0x%x\n", (u32_t)(data->EgressPktsDroppedNoSaMatch)));
	STRUCT_PRINT((disp_str,  "IngressPktsDroppedVlanMis = 0x%x\n", (u32_t)(data->IngressPktsDroppedVlanMis)));
	STRUCT_PRINT((disp_str,  "CmdsDroppedSizeErr = 0x%x\n", (u32_t)(data->CmdsDroppedSizeErr)));
	STRUCT_PRINT((disp_str,  "CmdsDroppedChanPkgIdErr = 0x%x\n", (u32_t)(data->CmdsDroppedChanPkgIdErr)));
	STRUCT_PRINT((disp_str,  "CmdsDroppedNcsiHdrRevErr = 0x%x\n", (u32_t)(data->CmdsDroppedNcsiHdrRevErr)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodePktErrorStat

/*****************************************************************************

FUNCTION:       DecodeUmpDebugData

DESCRIPTION:    This routine decode the structure/union UmpDebugData_t

IN PARAMETERS:  pointer to UmpDebugData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpDebugData(Tcl_Obj* rc_ptr, const UmpDebugData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "LandMark = 0x%x\n", (u32_t)(data->LandMark)));
	STRUCT_PRINT((disp_str,  "GlobalResetCount = 0x%x\n", (u32_t)(data->GlobalResetCount)));
	STRUCT_PRINT((disp_str,  "NcsiCmdDataAddr = 0x%x\n", (u32_t)(data->NcsiCmdDataAddr)));
	STRUCT_PRINT((disp_str,  "UmpRxDataAddr = 0x%x\n", (u32_t)(data->UmpRxDataAddr)));
	STRUCT_PRINT((disp_str,  "UmpTxDataAddr = 0x%x\n", (u32_t)(data->UmpTxDataAddr)));
	STRUCT_PRINT((disp_str,  "LoopBackPktCount = 0x%x\n", (u32_t)(data->LoopBackPktCount)));
	STRUCT_PRINT((disp_str,  "TxDescErrCount = 0x%x\n", (u32_t)(data->TxDescErrCount)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpDebugData

/*****************************************************************************

FUNCTION:       DecodeCmdPktCnt

DESCRIPTION:    This routine decode the structure/union CmdPktCnt_t

IN PARAMETERS:  pointer to CmdPktCnt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeCmdPktCnt(Tcl_Obj* rc_ptr, const CmdPktCnt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Rx = 0x%x\n", (u32_t)(data->Rx)));
	STRUCT_PRINT((disp_str,  "Dropped = 0x%x\n", (u32_t)(data->Dropped)));
	STRUCT_PRINT((disp_str,  "CmdTypeErrs = 0x%x\n", (u32_t)(data->CmdTypeErrs)));
	STRUCT_PRINT((disp_str,  "ChkSumErrs = 0x%x\n", (u32_t)(data->ChkSumErrs)));
	STRUCT_PRINT((disp_str,  "TotalRxPkts = 0x%x\n", (u32_t)(data->TotalRxPkts >> 32)));
	STRUCT_PRINT((disp_str,  "TotalTxPkts = 0x%x\n", (u32_t)(data->TotalTxPkts >> 32)));
	STRUCT_PRINT((disp_str,  "TotalRxBytes = 0x%x\n", (u32_t)(data->TotalRxBytes >> 32)));
	STRUCT_PRINT((disp_str,  "TotalTxBytes = 0x%x\n", (u32_t)(data->TotalTxBytes >> 32)));
	STRUCT_PRINT((disp_str,  "AensSent = 0x%x\n", (u32_t)(data->AensSent)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeCmdPktCnt

/*****************************************************************************

FUNCTION:       DecodeEgressPktCnt

DESCRIPTION:    This routine decode the structure/union EgressPktCnt_t

IN PARAMETERS:  pointer to EgressPktCnt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeEgressPktCnt(Tcl_Obj* rc_ptr, const EgressPktCnt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "TotalPktHigh = 0x%x\n", (u32_t)(data->TotalPktHigh)));
	STRUCT_PRINT((disp_str,  "TotalPktLow = 0x%x\n", (u32_t)(data->TotalPktLow)));
	STRUCT_PRINT((disp_str,  "TotalDropped = 0x%x\n", (u32_t)(data->TotalDropped)));
	STRUCT_PRINT((disp_str,  "ChannelStateErr = 0x%x\n", (u32_t)(data->ChannelStateErr)));
	STRUCT_PRINT((disp_str,  "UnderSized = 0x%x\n", (u32_t)(data->UnderSized)));
	STRUCT_PRINT((disp_str,  "OverSized = 0x%x\n", (u32_t)(data->OverSized)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeEgressPktCnt

/*****************************************************************************

FUNCTION:       DecodeIngressPktCnt

DESCRIPTION:    This routine decode the structure/union IngressPktCnt_t

IN PARAMETERS:  pointer to IngressPktCnt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeIngressPktCnt(Tcl_Obj* rc_ptr, const IngressPktCnt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "TotalPkt = 0x%x\n", (u32_t)(data->TotalPkt)));
	STRUCT_PRINT((disp_str,  "TotalDropped = 0x%x\n", (u32_t)(data->TotalDropped)));
	STRUCT_PRINT((disp_str,  "OverSizedErr = 0x%x\n", (u32_t)(data->OverSizedErr)));
	STRUCT_PRINT((disp_str,  "UnderSizedErr = 0x%x\n", (u32_t)(data->UnderSizedErr)));
	STRUCT_PRINT((disp_str,  "ChannelStateErr = 0x%x\n", (u32_t)(data->ChannelStateErr)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeIngressPktCnt

/*****************************************************************************

FUNCTION:       DecodeSmbusErrCnt

DESCRIPTION:    This routine decode the structure/union SmbusErrCnt_t

IN PARAMETERS:  pointer to SmbusErrCnt_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeSmbusErrCnt(Tcl_Obj* rc_ptr, const SmbusErrCnt_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "slave_rd_event          = 0x%x\n", (u32_t)(data->slave_rd_event         )));
	STRUCT_PRINT((disp_str,  "slave_start_busy        = 0x%x\n", (u32_t)(data->slave_start_busy       )));
	STRUCT_PRINT((disp_str,  "slave_arp_event         = 0x%x\n", (u32_t)(data->slave_arp_event        )));
	STRUCT_PRINT((disp_str,  "master_rx_event         = 0x%x\n", (u32_t)(data->master_rx_event        )));
	STRUCT_PRINT((disp_str,  "slave_tx_underrun       = 0x%x\n", (u32_t)(data->slave_tx_underrun      )));
	STRUCT_PRINT((disp_str,  "slave_rx_threshold_hit  = 0x%x\n", (u32_t)(data->slave_rx_threshold_hit )));
	STRUCT_PRINT((disp_str,  "slave_rx_fifo_full      = 0x%x\n", (u32_t)(data->slave_rx_fifo_full     )));
	STRUCT_PRINT((disp_str,  "master_tx_underrun      = 0x%x\n", (u32_t)(data->master_tx_underrun     )));
	STRUCT_PRINT((disp_str,  "master_rx_threshold_hit = 0x%x\n", (u32_t)(data->master_rx_threshold_hit)));
	STRUCT_PRINT((disp_str,  "master_rx_fifo_full     = 0x%x\n", (u32_t)(data->master_rx_fifo_full    )));
	STRUCT_PRINT((disp_str,  "fifo_overflow           = 0x%x\n", (u32_t)(data->fifo_overflow          )));
	STRUCT_PRINT((disp_str,  "transaction_error       = 0x%x\n", (u32_t)(data->transaction_error      )));
	STRUCT_PRINT((disp_str,  "pec_error               = 0x%x\n", (u32_t)(data->pec_error              )));
	STRUCT_PRINT((disp_str,  "illegal_pkt_len         = 0x%x\n", (u32_t)(data->illegal_pkt_len        )));
	STRUCT_PRINT((disp_str,  "lost_arbitration        = 0x%x\n", (u32_t)(data->lost_arbitration       )));
	STRUCT_PRINT((disp_str,  "slave_off_line          = 0x%x\n", (u32_t)(data->slave_off_line         )));
	STRUCT_PRINT((disp_str,  "slave_busy              = 0x%x\n", (u32_t)(data->slave_busy             )));
	STRUCT_PRINT((disp_str,  "slave_bus_timeout       = 0x%x\n", (u32_t)(data->slave_bus_timeout      )));
	STRUCT_PRINT((disp_str,  "master_busy_timeout     = 0x%x\n", (u32_t)(data->master_busy_timeout    )));
	STRUCT_PRINT((disp_str,  "unused                  = 0x%x\n", (u32_t)(data->unused                 )));
    
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeSmbusErrCnt


/*****************************************************************************

FUNCTION:       DecodeUmpStatistics

DESCRIPTION:    This routine decode the structure/union UmpStatistics_t

IN PARAMETERS:  pointer to UmpStatistics_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpStatistics(Tcl_Obj* rc_ptr, const UmpStatistics_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "NcsiCmdPktCnts->\n"));
	DecodeCmdPktCnt( rc_ptr, &data->NcsiCmdPktCnts);

	STRUCT_PRINT((disp_str,  "(RMII only)BMC2MCP->\n"));
	DecodeEgressPktCnt( rc_ptr, &data->BMC2MCP);

	STRUCT_PRINT((disp_str,  "(RMII only)MCP2BMC->\n"));
	DecodeIngressPktCnt( rc_ptr, &data->MCP2BMC);

	STRUCT_PRINT((disp_str,  "(SMBUS only)smbus_err->\n"));
	DecodeSmbusErrCnt( rc_ptr, &data->smbus_err_cnts);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpStatistics

/*****************************************************************************

FUNCTION:       DecodeChannelState

DESCRIPTION:    This routine decode the structure/union ChannelState_t

IN PARAMETERS:  pointer to ChannelState_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeChannelState(Tcl_Obj* rc_ptr, const ChannelState_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Ready = 0x%x\n", (u32_t)(data->Ready)));
	STRUCT_PRINT((disp_str,  "InitialState = 0x%x\n", (u32_t)(data->InitialState)));
	STRUCT_PRINT((disp_str,  "TxPtEnabled = 0x%x\n", (u32_t)(data->TxPtEnabled)));
	STRUCT_PRINT((disp_str,  "RxPtEnabled = 0x%x\n", (u32_t)(data->RxPtEnabled)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeChannelState

/*****************************************************************************

FUNCTION:       DecodeUmpPortConfigFlag

DESCRIPTION:    This routine decode the structure/union UmpPortConfigFlag_t

IN PARAMETERS:  pointer to UmpPortConfigFlag_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpPortConfigFlag(Tcl_Obj* rc_ptr, const UmpPortConfigFlag_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
	STRUCT_PRINT((disp_str,  "NetwBmcPassthruDisabled = 0x%x\n", (u32_t)(data->NetwBmcPassthruDisabled)));
	STRUCT_PRINT((disp_str,  "InvalidHiGigLen = 0x%x\n", (u32_t)(data->InvalidHiGigLen)));
	STRUCT_PRINT((disp_str,  "PerformReset = 0x%x\n", (u32_t)(data->PerformReset)));
	STRUCT_PRINT((disp_str,  "LinkStateChange = 0x%x\n", (u32_t)(data->LinkStateChange)));
	STRUCT_PRINT((disp_str,  "DriverStateChange = 0x%x\n", (u32_t)(data->DriverStateChange)));
	STRUCT_PRINT((disp_str,  "DriverPresent = 0x%x\n", (u32_t)(data->DriverPresent)));
	STRUCT_PRINT((disp_str,  "ChannelSpecificReset = 0x%x\n", (u32_t)(data->ChannelSpecificReset)));
	STRUCT_PRINT((disp_str,  "Exceed375MaFlag = 0x%x\n", (u32_t)(data->Exceed375MaFlag)));
	STRUCT_PRINT((disp_str,  "OsPresentFlag = 0x%x\n", (u32_t)(data->OsPresentFlag)));
	STRUCT_PRINT((disp_str,  "HostBmcPassthruEnabled = 0x%x\n", (u32_t)(data->HostBmcPassthruEnabled)));
	STRUCT_PRINT((disp_str,  "ResetPending = 0x%x\n", (u32_t)(data->ResetPending)));
	STRUCT_PRINT((disp_str,  "VlanEnabled = 0x%x\n", (u32_t)(data->VlanEnabled)));
	STRUCT_PRINT((disp_str,  "LinkForcedByBmc = 0x%x\n", (u32_t)(data->LinkForcedByBmc)));
	STRUCT_PRINT((disp_str,  "HiGigMode = 0x%x\n", (u32_t)(data->HiGigMode)));
	STRUCT_PRINT((disp_str,  "BroadcastFilterEnabled = 0x%x\n", (u32_t)(data->BroadcastFilterEnabled)));
	STRUCT_PRINT((disp_str,  "MulticastFilterEnabled = 0x%x\n", (u32_t)(data->MulticastFilterEnabled)));
	STRUCT_PRINT((disp_str,  "InitialState = 0x%x\n", (u32_t)(data->InitialState)));
	STRUCT_PRINT((disp_str,  "Ready = 0x%x\n", (u32_t)(data->Ready)));
	STRUCT_PRINT((disp_str,  "EgressPassThruEnabled = 0x%x\n", (u32_t)(data->EgressPassThruEnabled)));
	STRUCT_PRINT((disp_str,  "ChannelEnabled = 0x%x\n", (u32_t)(data->ChannelEnabled)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpPortConfigFlag

/*****************************************************************************

FUNCTION:       DecodeUmpPortConfig

DESCRIPTION:    This routine decode the structure/union UmpPortConfig_t

IN PARAMETERS:  pointer to UmpPortConfig_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeUmpPortConfig(Tcl_Obj* rc_ptr, const UmpPortConfig_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Flags->\n"));
	DecodeUmpPortConfigFlag( rc_ptr, &data->Flags);

	STRUCT_PRINT((disp_str,  "ResetCount = 0x%x\n", (u32_t)(data->ResetCount)));
	STRUCT_PRINT((disp_str,  "McId = 0x%x\n", (u32_t)(data->McId)));
	STRUCT_PRINT((disp_str,  "AenConfig = 0x%x\n", (u32_t)(data->AenConfig)));
	STRUCT_PRINT((disp_str,  "BroadcastFilter = 0x%x\n", (u32_t)(data->BroadcastFilter)));
	STRUCT_PRINT((disp_str,  "MulticastFilter = 0x%x\n", (u32_t)(data->MulticastFilter)));
	STRUCT_PRINT((disp_str,  "VlanConfiguration = 0x%x\n", (u32_t)(data->VlanConfiguration)));
	STRUCT_PRINT((disp_str,  "LinkSettingsFromBmc = 0x%x\n", (u32_t)(data->LinkSettingsFromBmc)));
	STRUCT_PRINT((disp_str,  "OemLinkSettingsFromBmc = 0x%x\n", (u32_t)(data->OemLinkSettingsFromBmc)));
	for (loop_index = 0; loop_index < (NCSI_MAC_ADDRESS_MAX); loop_index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "MacAddr[%d]->\n", loop_index));
		DecodeMacAddrConfig(rc_ptr, &data->MacAddr[loop_index]);

	}

	for (loop_index = 0; loop_index < (NCSI_VLAN_TAG_COUNT); loop_index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "VlanTag[%d]->\n", loop_index));
		DecodeUmpVlan(rc_ptr, &data->VlanTag[loop_index]);

	}

	STRUCT_PRINT((disp_str,  "LinkStatus = 0x%x\n", (u32_t)(data->LinkStatus)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeUmpPortConfig

/*****************************************************************************

FUNCTION:       DecodeNcsiChannelData

DESCRIPTION:    This routine decode the structure/union NcsiChannelData_t

IN PARAMETERS:  pointer to NcsiChannelData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiChannelData(Tcl_Obj* rc_ptr, const NcsiChannelData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Statistics->\n"));
	DecodeUmpStatistics( rc_ptr, &data->Statistics);

	STRUCT_PRINT((disp_str,  "Config->\n"));
	DecodeUmpPortConfig( rc_ptr, &data->Config);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiChannelData

/*****************************************************************************

FUNCTION:       DecodePackageState

DESCRIPTION:    This routine decode the structure/union PackageState_t

IN PARAMETERS:  pointer to PackageState_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodePackageState(Tcl_Obj* rc_ptr, const PackageState_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding
                         
	STRUCT_PRINT((disp_str,  "DellOemCmdSupport = 0x%x\n", (u32_t)(data->DellOemCmdSupport)));
	STRUCT_PRINT((disp_str,  "PrevResetType = 0x%x\n", (u32_t)(data->PrevResetType)));
	if ((data->PrevResetType & 0xFFFFFFFF) == NCSI_RESET_TYPE_CHANNEL0_RESET) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RESET_TYPE_CHANNEL0_RESET)\n")); 
	}
	else if ((data->PrevResetType & 0xFFFFFFFF) == NCSI_RESET_TYPE_CHANNEL1_RESET) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RESET_TYPE_CHANNEL1_RESET)\n")); 
	}
	else if ((data->PrevResetType & 0xFFFFFFFF) == NCSI_RESET_TYPE_COLD_START) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RESET_TYPE_COLD_START)\n")); 
	}
	else if ((data->PrevResetType & 0xFFFFFFFF) == NCSI_RESET_TYPE_WARM_START) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RESET_TYPE_WARM_START)\n")); 
	}
	STRUCT_PRINT((disp_str,  "ControlPacketSeen = 0x%x\n", (u32_t)(data->ControlPacketSeen)));
	STRUCT_PRINT((disp_str,  "LoopBackPktActive = 0x%x\n", (u32_t)(data->LoopBackPktActive)));
	STRUCT_PRINT((disp_str,  "LoopBackEnabled = 0x%x\n", (u32_t)(data->LoopBackEnabled)));
	STRUCT_PRINT((disp_str,  "SmbusMode = 0x%x\n", (u32_t)(data->SmbusMode)));
	STRUCT_PRINT((disp_str,  "SmbusFix = 0x%x\n", (u32_t)(data->SmbusFix)));
	STRUCT_PRINT((disp_str,  "Ready = 0x%x\n", (u32_t)(data->Ready)));
	STRUCT_PRINT((disp_str,  "Selected = 0x%x\n", (u32_t)(data->Selected)));
	STRUCT_PRINT((disp_str,  "DeselectPending = 0x%x\n", (u32_t)(data->DeselectPending)));
	STRUCT_PRINT((disp_str,  "HwArbEnabled = 0x%x\n", (u32_t)(data->HwArbEnabled)));
	STRUCT_PRINT((disp_str,  "FcDisabled = 0x%x\n", (u32_t)(data->FcDisabled)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodePackageState

/*****************************************************************************

FUNCTION:       DecodeNcsiPersistentData

DESCRIPTION:    This routine decode the structure/union NcsiPersistentData_t

IN PARAMETERS:  pointer to NcsiPersistentData_t

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeNcsiPersistentData(Tcl_Obj* rc_ptr, const NcsiPersistentData_t * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "Debug->\n"));
	DecodeUmpDebugData( rc_ptr, &data->Debug);

	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "PackageId = 0x%x\n", (u32_t)(data->PackageId)));
	for (loop_index = 0; loop_index < (PATH_SUPPORTED * PORT_MAX); loop_index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "pChannelSpecific[%d]->\n", loop_index));

		{u32_t j;
		for (j = 0; j < sizeof(pNcsiChannelData_t)/sizeof(u32_t); j++)  // array 
		{
            u32_t * buf;
			if ((j & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
            buf = (u32_t *)data->pChannelSpecific;
			SPECIAL_DBG_PRINT((disp_str,  " 0x%08x",  buf[loop_index * (sizeof(pNcsiChannelData_t)/sizeof(u32_t)) +j]));
		}}// Unknown type !!!
	
		SPECIAL_DBG_PRINT((disp_str,  "\n"));
		//		DecodePNcsiChannelData(rc_ptr, &data->pChannelSpecific[loop_index]);

	}



	STRUCT_PRINT((disp_str,  "PackageState->\n"));
	DecodePackageState( rc_ptr, &data->PackageState);

	STRUCT_PRINT((disp_str,  "pHostSrcBuff = 0x%x\n", U32_CAST(data->pHostSrcBuff)));

	for (loop_index = 0; loop_index < (PATH_SUPPORTED * PORT_MAX); loop_index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "ChannelData[%d]->  0x%x\n", loop_index, U32_CAST(data->pChannelSpecific[loop_index])));
//		DecodeNcsiChannelData(rc_ptr, &data->ChannelData[loop_index]);

	}

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeNcsiPersistentData




// ??????? move following declaration to header file
extern void DecodeNcsiVersion(Tcl_Obj* rc_ptr, const NcsiVersion_t * data);
extern void DecodeNcsiMacAddr(Tcl_Obj* rc_ptr, const NcsiMacAddr_t * data);
extern void DecodeUmpMacAddr(Tcl_Obj* rc_ptr, const UmpMacAddr_t * data);
extern void DecodeMacAddrConfig(Tcl_Obj* rc_ptr, const MacAddrConfig_t * data);
extern void DecodeUmpVlan(Tcl_Obj* rc_ptr, const UmpVlan_t * data);
extern void DecodePktErrorStat(Tcl_Obj* rc_ptr, const PktErrorStat_t * data);
extern void DecodeUmpDebugData(Tcl_Obj* rc_ptr, const UmpDebugData_t * data);
extern void DecodeCmdPktCnt(Tcl_Obj* rc_ptr, const CmdPktCnt_t * data);
extern void DecodeEgressPktCnt(Tcl_Obj* rc_ptr, const EgressPktCnt_t * data);
extern void DecodeIngressPktCnt(Tcl_Obj* rc_ptr, const IngressPktCnt_t * data);
extern void DecodeSmbusErrCnt(Tcl_Obj* rc_ptr, const SmbusErrCnt_t * data);
extern void DecodeUmpStatistics(Tcl_Obj* rc_ptr, const UmpStatistics_t * data);
extern void DecodeChannelState(Tcl_Obj* rc_ptr, const ChannelState_t * data);
extern void DecodeUmpPortConfigFlag(Tcl_Obj* rc_ptr, const UmpPortConfigFlag_t * data);
extern void DecodeUmpPortConfig(Tcl_Obj* rc_ptr, const UmpPortConfig_t * data);
extern void DecodeNcsiChannelData(Tcl_Obj* rc_ptr, const NcsiChannelData_t * data);
extern void DecodePackageState(Tcl_Obj* rc_ptr, const PackageState_t * data);
extern void DecodeNcsiPersistentData(Tcl_Obj* rc_ptr, const NcsiPersistentData_t * data);
