/****************************************************************************
 * Copyright(c) 2001-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 * Name:        decode_shmem.c
 *
 * Description: Decode structures in shmem.h 
 *
 * Created:     File generated from ..\..\..\..\hsi\mcp\shmem.h in 3/26/2010 dlau
 *     !!! Majority of the code is script generated. 
 *    Avoid modifying this file manually. Consult David Lau for help. 
 *
 ****************************************************************************/

#include  <stdio.h>
#include  <ctype.h>
#include  <stdlib.h>
#include  <string.h>
#include "tcl.h"
#include "bcmtype.h"
#include "license.h"
#include "dev_info.h"
#include "shmem.h"
#ifdef EDEBUG
#include "util.h"
#else
#include "lm5710.h"
#endif
#include "multi_thread_def.h"
#include "code_swap_def.h"
extern void DecodeShmDevInfo(Tcl_Obj* rc_ptr, const struct shm_dev_info * data);
extern void DecodeLicenseKey(Tcl_Obj* rc_ptr, const license_key_t * data);

u32_t indent_level;

#ifndef INDENT_STRUCT
#define INDENT_STRUCT(tab_cnt) \
{\
	u32_t tab_index;\
	for (tab_index = 0; tab_index < tab_cnt; tab_index++) SPECIAL_DBG_TAB; \
}

#define STRUCT_PRINT(x)      INDENT_STRUCT(indent_level); SPECIAL_DBG_PRINT(x);
#endif // INDENT_STRUCT

static char disp_str[1000];
#ifndef SPECIAL_DBG_PRINT
#define SPECIAL_DBG_PRINT(x)   \
{\
	sprintf x;\
	Tcl_AppendStringsToObj( rc_ptr, disp_str, NULL); \
}
#endif // SPECIAL_DBG_PRINT
#ifndef SPECIAL_DBG_TAB
#define SPECIAL_DBG_TAB  Tcl_AppendStringsToObj( rc_ptr, "\t", NULL) 
#endif // SPECIAL_DBG_TAB

/*****************************************************************************

FUNCTION:       DecodeDrvPortMb

DESCRIPTION:    This routine decode the structure/union struct drv_port_mb

IN PARAMETERS:  pointer to struct drv_port_mb

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDrvPortMb(Tcl_Obj* rc_ptr, const struct drv_port_mb * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "link_status = 0x%x\n", (u32_t)(data->link_status)));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_FLAG     = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_FLAG_MASK)>>0));
	if ((data->link_status & LINK_STATUS_LINK_FLAG_MASK) == LINK_STATUS_LINK_UP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_LINK_UP)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_SPEED_AND_DUPLEX = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK)>>1));
	if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_AN_NOT_COMPLETE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_AN_NOT_COMPLETE)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_10THD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_10THD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_10TFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_10TFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_100TXHD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_100TXHD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_100T4) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_100T4)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_100TXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_100TXFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_1000THD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_1000THD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_1000TFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_1000TFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_1000XFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_1000XFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_2500THD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_2500THD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_2500TFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_2500TFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_2500XFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_2500XFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_10GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_10GTFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_10GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_10GXFD)\n")); 
	}
    /* Since there is a confclict in shmem.c, do not integrate these lines yet */
    /*
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_12GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_12GTFD)\n")); 
	}
    
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_12GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_12GXFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_12_5GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_12_5GTFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_12_5GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_12_5GXFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_13GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_13GTFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_13GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_13GXFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_15GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_15GTFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_15GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_15GXFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_16GTFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_16GTFD)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_SPEED_AND_DUPLEX_MASK) == LINK_STATUS_SPEED_AND_DUPLEX_16GXFD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_SPEED_AND_DUPLEX_16GXFD)\n")); 
	}
    */
	STRUCT_PRINT((disp_str,  "\tSTATUS_AUTO_NEGOTIATE_FLAG = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_AUTO_NEGOTIATE_FLAG_MASK)>>5));
	if ((data->link_status & LINK_STATUS_AUTO_NEGOTIATE_FLAG_MASK) == LINK_STATUS_AUTO_NEGOTIATE_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_AUTO_NEGOTIATE_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_AUTO_NEGOTIATE_COMPLETE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_AUTO_NEGOTIATE_COMPLETE)>>6));
	STRUCT_PRINT((disp_str,  "\tSTATUS_PARALLEL_DETECTION_FLAG = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_PARALLEL_DETECTION_FLAG_MASK)>>7));
	if ((data->link_status & LINK_STATUS_PARALLEL_DETECTION_FLAG_MASK) == LINK_STATUS_PARALLEL_DETECTION_USED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_PARALLEL_DETECTION_USED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_1000TFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_1000TFD_CAPABLE)>>9));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_1000THD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_1000THD_CAPABLE)>>10));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_100T4_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_100T4_CAPABLE)>>11));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_100TXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_100TXFD_CAPABLE)>>12));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_100TXHD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_100TXHD_CAPABLE)>>13));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_10TFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_10TFD_CAPABLE)>>14));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_10THD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_10THD_CAPABLE)>>15));
	STRUCT_PRINT((disp_str,  "\tSTATUS_TX_FLOW_CONTROL_FLAG = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_TX_FLOW_CONTROL_FLAG_MASK)>>16));
	if ((data->link_status & LINK_STATUS_TX_FLOW_CONTROL_FLAG_MASK) == LINK_STATUS_TX_FLOW_CONTROL_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_TX_FLOW_CONTROL_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_RX_FLOW_CONTROL_FLAG = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_RX_FLOW_CONTROL_FLAG_MASK)>>17));
	if ((data->link_status & LINK_STATUS_RX_FLOW_CONTROL_FLAG_MASK) == LINK_STATUS_RX_FLOW_CONTROL_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_RX_FLOW_CONTROL_ENABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_FLOW_CONTROL = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_FLOW_CONTROL_MASK)>>18));
	if ((data->link_status & LINK_STATUS_LINK_PARTNER_FLOW_CONTROL_MASK) == LINK_STATUS_LINK_PARTNER_NOT_PAUSE_CAPABLE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_LINK_PARTNER_NOT_PAUSE_CAPABLE)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_LINK_PARTNER_FLOW_CONTROL_MASK) == LINK_STATUS_LINK_PARTNER_SYMMETRIC_PAUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_LINK_PARTNER_SYMMETRIC_PAUSE)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_LINK_PARTNER_FLOW_CONTROL_MASK) == LINK_STATUS_LINK_PARTNER_ASYMMETRIC_PAUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_LINK_PARTNER_ASYMMETRIC_PAUSE)\n")); 
	}
	else if ((data->link_status & LINK_STATUS_LINK_PARTNER_FLOW_CONTROL_MASK) == LINK_STATUS_LINK_PARTNER_BOTH_PAUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_LINK_PARTNER_BOTH_PAUSE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_SERDES_LINK   = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_SERDES_LINK)>>20));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_2500XFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_2500XFD_CAPABLE)>>21));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_2500XHD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_2500XHD_CAPABLE)>>22));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_10GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_10GXFD_CAPABLE)>>23));
    /*
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_12GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_12GXFD_CAPABLE)>>24));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_12_5GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_12_5GXFD_CAPABLE)>>25));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_13GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_13GXFD_CAPABLE)>>26));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_15GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_15GXFD_CAPABLE)>>27));
	STRUCT_PRINT((disp_str,  "\tSTATUS_LINK_PARTNER_16GXFD_CAPABLE = 0x%x \n", (u32_t)(data->link_status & LINK_STATUS_LINK_PARTNER_16GXFD_CAPABLE)>>28));
    */
	STRUCT_PRINT((disp_str,  "port_stx = 0x%x\n", (u32_t)(data->port_stx)));
	STRUCT_PRINT((disp_str,  "stat_nig_timer = 0x%x\n", (u32_t)(data->stat_nig_timer)));
	STRUCT_PRINT((disp_str,  "ext_phy_fw_version = 0x%x\n", (u32_t)(data->ext_phy_fw_version)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDrvPortMb

/*****************************************************************************

FUNCTION:       DecodeDrvFuncMb

DESCRIPTION:    This routine decode the structure/union struct drv_func_mb

IN PARAMETERS:  pointer to struct drv_func_mb

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDrvFuncMb(Tcl_Obj* rc_ptr, const struct drv_func_mb * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "drv_mb_header = 0x%x\n", (u32_t)(data->drv_mb_header)));
	STRUCT_PRINT((disp_str,  "\tMSG_CODE             = 0x%x \n", (u32_t)(data->drv_mb_header & DRV_MSG_CODE_MASK)>>16));
	if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_LOAD_REQ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LOAD_REQ)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_LOAD_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LOAD_DONE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_UNLOAD_REQ_WOL_EN) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_UNLOAD_REQ_WOL_EN)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_UNLOAD_REQ_WOL_DIS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_UNLOAD_REQ_WOL_DIS)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_UNLOAD_REQ_WOL_MCP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_UNLOAD_REQ_WOL_MCP)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_UNLOAD_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_UNLOAD_DONE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DCC_OK) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DCC_OK)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DCC_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DCC_FAILURE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DIAG_ENTER_REQ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DIAG_ENTER_REQ)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DIAG_EXIT_REQ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DIAG_EXIT_REQ)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_VALIDATE_KEY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VALIDATE_KEY)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_GET_CURR_KEY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_GET_CURR_KEY)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_GET_UPGRADE_KEY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_GET_UPGRADE_KEY)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_GET_MANUF_KEY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_GET_MANUF_KEY)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_LOAD_L2B_PRAM) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LOAD_L2B_PRAM)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_VRFY_FIRST_PHY_OPT_MDL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VRFY_FIRST_PHY_OPT_MDL)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == REQ_BC_VER_4_VRFY_FIRST_PHY_OPT_MDL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(BC_VER_4_VRFY_FIRST_PHY_OPT_MDL)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_VRFY_SPECIFIC_PHY_OPT_MDL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VRFY_SPECIFIC_PHY_OPT_MDL)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == REQ_BC_VER_4_VRFY_SPECIFIC_PHY_OPT_MDL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(BC_VER_4_VRFY_SPECIFIC_PHY_OPT_MDL)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DCBX_ADMIN_PMF_MSG) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DCBX_ADMIN_PMF_MSG)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_DCBX_PMF_DRV_OK) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DCBX_PMF_DRV_OK)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == DRV_MSG_CODE_VF_DISABLED_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VF_DISABLED_DONE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == BIOS_MSG_CODE_LIC_CHALLENGE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LIC_CHALLENGE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == BIOS_MSG_CODE_LIC_RESPONSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LIC_RESPONSE)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == BIOS_MSG_CODE_VIRT_MAC_PRIM) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VIRT_MAC_PRIM)\n")); 
	}
	else if ((data->drv_mb_header & DRV_MSG_CODE_MASK) == BIOS_MSG_CODE_VIRT_MAC_ISCSI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VIRT_MAC_ISCSI)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tMSG_SEQ_NUMBER       = 0x%x \n", (u32_t)(data->drv_mb_header & DRV_MSG_SEQ_NUMBER_MASK)>>0));
	STRUCT_PRINT((disp_str,  "drv_mb_param = 0x%x\n", (u32_t)(data->drv_mb_param)));
	STRUCT_PRINT((disp_str,  "fw_mb_header = 0x%x\n", (u32_t)(data->fw_mb_header)));
	STRUCT_PRINT((disp_str,  "\tMSG_CODE             = 0x%x \n", (u32_t)(data->fw_mb_header & FW_MSG_CODE_MASK)>>16));
	if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_COMMON) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_COMMON)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_PORT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_PORT)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_FUNCTION) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_FUNCTION)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == REQ_BC_VER_4_DRV_LOAD_COMMON_CHIP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(BC_VER_4_DRV_LOAD_COMMON_CHIP)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_COMMON_CHIP) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_COMMON_CHIP)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_REFUSED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_REFUSED)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_LOAD_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_LOAD_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_UNLOAD_COMMON) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_UNLOAD_COMMON)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_UNLOAD_PORT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_UNLOAD_PORT)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_UNLOAD_FUNCTION) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_UNLOAD_FUNCTION)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DRV_UNLOAD_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DRV_UNLOAD_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DCC_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DCC_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_LLDP_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LLDP_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DIAG_ENTER_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DIAG_ENTER_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DIAG_REFUSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DIAG_REFUSE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_DIAG_EXIT_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_DIAG_EXIT_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VALIDATE_KEY_SUCCESS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VALIDATE_KEY_SUCCESS)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VALIDATE_KEY_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VALIDATE_KEY_FAILURE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_GET_KEY_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_GET_KEY_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_NO_KEY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_NO_KEY)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_LIC_INFO_NOT_READY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LIC_INFO_NOT_READY)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_L2B_PRAM_LOADED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_L2B_PRAM_LOADED)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_L2B_PRAM_T_LOAD_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_L2B_PRAM_T_LOAD_FAILURE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_L2B_PRAM_C_LOAD_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_L2B_PRAM_C_LOAD_FAILURE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_L2B_PRAM_X_LOAD_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_L2B_PRAM_X_LOAD_FAILURE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_L2B_PRAM_U_LOAD_FAILURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_L2B_PRAM_U_LOAD_FAILURE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VRFY_OPT_MDL_SUCCESS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VRFY_OPT_MDL_SUCCESS)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VRFY_OPT_MDL_INVLD_IMG) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VRFY_OPT_MDL_INVLD_IMG)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VRFY_OPT_MDL_UNAPPROVED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VRFY_OPT_MDL_UNAPPROVED)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VF_DISABLED_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VF_DISABLED_DONE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_LIC_CHALLENGE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LIC_CHALLENGE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_LIC_RESPONSE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_LIC_RESPONSE)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VIRT_MAC_PRIM) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VIRT_MAC_PRIM)\n")); 
	}
	else if ((data->fw_mb_header & FW_MSG_CODE_MASK) == FW_MSG_CODE_VIRT_MAC_ISCSI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MSG_CODE_VIRT_MAC_ISCSI)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tMSG_SEQ_NUMBER       = 0x%x \n", (u32_t)(data->fw_mb_header & FW_MSG_SEQ_NUMBER_MASK)>>0));
	STRUCT_PRINT((disp_str,  "fw_mb_param = 0x%x\n", (u32_t)(data->fw_mb_param)));
	STRUCT_PRINT((disp_str,  "drv_pulse_mb = 0x%x\n", (u32_t)(data->drv_pulse_mb)));
	STRUCT_PRINT((disp_str,  "\tPULSE_SEQ            = 0x%x \n", (u32_t)(data->drv_pulse_mb & DRV_PULSE_SEQ_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tPULSE_SYSTEM_TIME    = 0x%x \n", (u32_t)(data->drv_pulse_mb & DRV_PULSE_SYSTEM_TIME_MASK)>>16));
	STRUCT_PRINT((disp_str,  "\tPULSE_ALWAYS_ALIVE   = 0x%x \n", (u32_t)(data->drv_pulse_mb & DRV_PULSE_ALWAYS_ALIVE)>>15));
	STRUCT_PRINT((disp_str,  "mcp_pulse_mb = 0x%x\n", (u32_t)(data->mcp_pulse_mb)));
	STRUCT_PRINT((disp_str,  "\tPULSE_SEQ            = 0x%x \n", (u32_t)(data->mcp_pulse_mb & MCP_PULSE_SEQ_MASK)>>0));
	STRUCT_PRINT((disp_str,  "\tPULSE_ALWAYS_ALIVE   = 0x%x \n", (u32_t)(data->mcp_pulse_mb & MCP_PULSE_ALWAYS_ALIVE)>>15));
	STRUCT_PRINT((disp_str,  "\tEVENT                = 0x%x \n", (u32_t)(data->mcp_pulse_mb & MCP_EVENT_MASK)>>16));
	if ((data->mcp_pulse_mb & MCP_EVENT_MASK) == MCP_EVENT_OTHER_DRIVER_RESET_REQ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(EVENT_OTHER_DRIVER_RESET_REQ)\n")); 
	}
	STRUCT_PRINT((disp_str,  "iscsi_boot_signature = 0x%x\n", (u32_t)(data->iscsi_boot_signature)));
	STRUCT_PRINT((disp_str,  "iscsi_boot_block_offset = 0x%x\n", (u32_t)(data->iscsi_boot_block_offset)));
	STRUCT_PRINT((disp_str,  "drv_status = 0x%x\n", (u32_t)(data->drv_status)));
	STRUCT_PRINT((disp_str,  "\tSTATUS_PMF           = 0x%x \n", (u32_t)(data->drv_status & DRV_STATUS_PMF)>>0));
	STRUCT_PRINT((disp_str,  "\tSTATUS_VF_DISABLED   = 0x%x \n", (u32_t)(data->drv_status & DRV_STATUS_VF_DISABLED)>>1));
	STRUCT_PRINT((disp_str,  "\tSTATUS_DCC_EVENT     = 0x%x \n", (u32_t)(data->drv_status & DRV_STATUS_DCC_EVENT_MASK)>>8));
	if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_DISABLE_ENABLE_PF) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_DISABLE_ENABLE_PF)\n")); 
	}
	else if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_BANDWIDTH_ALLOCATION) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_BANDWIDTH_ALLOCATION)\n")); 
	}
	else if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_CHANGE_MAC_ADDRESS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_CHANGE_MAC_ADDRESS)\n")); 
	}
	else if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_RESERVED1) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_RESERVED1)\n")); 
	}
	else if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_SET_PROTOCOL) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_SET_PROTOCOL)\n")); 
	}
	else if ((data->drv_status & DRV_STATUS_DCC_EVENT_MASK) == DRV_STATUS_DCC_SET_PRIORITY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCC_SET_PRIORITY)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tSTATUS_DCBX_EVENT    = 0x%x \n", (u32_t)(data->drv_status & DRV_STATUS_DCBX_EVENT_MASK)>>16));
	if ((data->drv_status & DRV_STATUS_DCBX_EVENT_MASK) == DRV_STATUS_DCBX_NEGOTIATION_RESULTS) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(STATUS_DCBX_NEGOTIATION_RESULTS)\n")); 
	}
	STRUCT_PRINT((disp_str,  "virt_mac_upper = 0x%x\n", (u32_t)(data->virt_mac_upper)));
	STRUCT_PRINT((disp_str,  "\tMAC_SIGN             = 0x%x \n", (u32_t)(data->virt_mac_upper & VIRT_MAC_SIGN_MASK)>>16));
	if ((data->virt_mac_upper & VIRT_MAC_SIGN_MASK) == VIRT_MAC_SIGNATURE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MAC_SIGNATURE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "virt_mac_lower = 0x%x\n", (u32_t)(data->virt_mac_lower)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDrvFuncMb

/*****************************************************************************

FUNCTION:       DecodeMgmtfwState

DESCRIPTION:    This routine decode the structure/union struct mgmtfw_state

IN PARAMETERS:  pointer to struct mgmtfw_state

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeMgmtfwState(Tcl_Obj* rc_ptr, const struct mgmtfw_state * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "opaque[0 .. %d] = ", (MGMTFW_STATE_WORD_SIZE) - 1));
	for (index = 0; index < (MGMTFW_STATE_WORD_SIZE); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->opaque)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeMgmtfwState

/*****************************************************************************

FUNCTION:       DecodeSharedMfCfg

DESCRIPTION:    This routine decode the structure/union struct shared_mf_cfg

IN PARAMETERS:  pointer to struct shared_mf_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeSharedMfCfg(Tcl_Obj* rc_ptr, const struct shared_mf_cfg * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "clp_mb = 0x%x\n", (u32_t)(data->clp_mb)));
	if ((data->clp_mb & 0xFFFFFFFF) == SHARED_MF_CLP_SET_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CLP_SET_DEFAULT)\n")); 
	}
	else if ((data->clp_mb & 0xFFFFFFFF) == SHARED_MF_CLP_EXIT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CLP_EXIT)\n")); 
	}
	else if ((data->clp_mb & 0xFFFFFFFF) == SHARED_MF_CLP_EXIT_DONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CLP_EXIT_DONE)\n")); 
	}
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeSharedMfCfg

/*****************************************************************************

FUNCTION:       DecodePortMfCfg

DESCRIPTION:    This routine decode the structure/union struct port_mf_cfg

IN PARAMETERS:  pointer to struct port_mf_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodePortMfCfg(Tcl_Obj* rc_ptr, const struct port_mf_cfg * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "dynamic_cfg = 0x%x\n", (u32_t)(data->dynamic_cfg)));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_E1HOV_TAG     = 0x%x \n", (u32_t)(data->dynamic_cfg & PORT_MF_CFG_E1HOV_TAG_MASK)>>0));
	STRUCT_PRINT((disp_str,  "reserved[0 .. %d] = ", (1) - 1));
	for (index = 0; index < (1); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->reserved)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodePortMfCfg

/*****************************************************************************

FUNCTION:       DecodeFuncMfCfg

DESCRIPTION:    This routine decode the structure/union struct func_mf_cfg

IN PARAMETERS:  pointer to struct func_mf_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeFuncMfCfg(Tcl_Obj* rc_ptr, const struct func_mf_cfg * data)
{
	
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "config = 0x%x\n", (u32_t)(data->config)));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_FUNC_HIDE     = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_FUNC_HIDE)>>0));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_PROTOCOL      = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_PROTOCOL_MASK)>>1));
	if ((data->config & FUNC_MF_CFG_PROTOCOL_MASK) == FUNC_MF_CFG_PROTOCOL_FCOE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_PROTOCOL_FCOE)\n")); 
	}
	else if ((data->config & FUNC_MF_CFG_PROTOCOL_MASK) == FUNC_MF_CFG_PROTOCOL_ETHERNET) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_PROTOCOL_ETHERNET)\n")); 
	}
	else if ((data->config & FUNC_MF_CFG_PROTOCOL_MASK) == FUNC_MF_CFG_PROTOCOL_ETHERNET_WITH_RDMA) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_PROTOCOL_ETHERNET_WITH_RDMA)\n")); 
	}
	else if ((data->config & FUNC_MF_CFG_PROTOCOL_MASK) == FUNC_MF_CFG_PROTOCOL_ISCSI) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_PROTOCOL_ISCSI)\n")); 
	}
	else if ((data->config & FUNC_MF_CFG_PROTOCOL_MASK) == FUNC_MF_CFG_PROTOCOL_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_PROTOCOL_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tMF_CFG_FUNC_DISABLED = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_FUNC_DISABLED)>>3));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_TRANSMIT_PRIORITY = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_TRANSMIT_PRIORITY_MASK)>>8));
	if ((data->config & FUNC_MF_CFG_TRANSMIT_PRIORITY_MASK) == FUNC_MF_CFG_TRANSMIT_PRIORITY_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_TRANSMIT_PRIORITY_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tMF_CFG_MIN_BW        = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_MIN_BW_MASK)>>16));
	if ((data->config & FUNC_MF_CFG_MIN_BW_MASK) == FUNC_MF_CFG_MIN_BW_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_MIN_BW_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tMF_CFG_MAX_BW        = 0x%x \n", (u32_t)(data->config & FUNC_MF_CFG_MAX_BW_MASK)>>24));
	if ((data->config & FUNC_MF_CFG_MAX_BW_MASK) == FUNC_MF_CFG_MAX_BW_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_MAX_BW_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "mac_upper = 0x%x\n", (u32_t)(data->mac_upper)));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_UPPERMAC      = 0x%x \n", (u32_t)(data->mac_upper & FUNC_MF_CFG_UPPERMAC_MASK)>>0));
	if ((data->mac_upper & FUNC_MF_CFG_UPPERMAC_MASK) == FUNC_MF_CFG_UPPERMAC_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_UPPERMAC_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "mac_lower = 0x%x\n", (u32_t)(data->mac_lower)));
	if ((data->mac_lower & 0xFFFFFFFF) == FUNC_MF_CFG_LOWERMAC_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_LOWERMAC_DEFAULT)\n")); 
	}
	STRUCT_PRINT((disp_str,  "e1hov_tag = 0x%x\n", (u32_t)(data->e1hov_tag)));
	STRUCT_PRINT((disp_str,  "\tMF_CFG_E1HOV_TAG     = 0x%x \n", (u32_t)(data->e1hov_tag & FUNC_MF_CFG_E1HOV_TAG_MASK)>>0));
	if ((data->e1hov_tag & FUNC_MF_CFG_E1HOV_TAG_MASK) == FUNC_MF_CFG_E1HOV_TAG_DEFAULT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_E1HOV_TAG_DEFAULT)\n")); 
	}

	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeFuncMfCfg

/*****************************************************************************

FUNCTION:       DecodeFuncExtCfg

DESCRIPTION:    This routine decode the structure/union struct func_ext_cfg

IN PARAMETERS:  pointer to struct func_ext_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeFuncExtCfg(Tcl_Obj* rc_ptr, const struct func_ext_cfg * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "func_cfg = 0x%x\n", (u32_t)(data->func_cfg)));
	STRUCT_PRINT((disp_str,  "\tFUNC_CFG_FLAGS       = 0x%x \n", (u32_t)(data->func_cfg & MACP_FUNC_CFG_FLAGS_MASK)>>0));
	if ((data->func_cfg & MACP_FUNC_CFG_FLAGS_MASK) == MACP_FUNC_CFG_FLAGS_ENABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FUNC_CFG_FLAGS_ENABLED)\n")); 
	}
	else if ((data->func_cfg & MACP_FUNC_CFG_FLAGS_MASK) == MACP_FUNC_CFG_FLAGS_ETHERNET) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FUNC_CFG_FLAGS_ETHERNET)\n")); 
	}
	else if ((data->func_cfg & MACP_FUNC_CFG_FLAGS_MASK) == MACP_FUNC_CFG_FLAGS_ISCSI_OFFLOAD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FUNC_CFG_FLAGS_ISCSI_OFFLOAD)\n")); 
	}
	else if ((data->func_cfg & MACP_FUNC_CFG_FLAGS_MASK) == MACP_FUNC_CFG_FLAGS_FCOE_OFFLOAD) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(FUNC_CFG_FLAGS_FCOE_OFFLOAD)\n")); 
	}
	STRUCT_PRINT((disp_str,  "iscsi_mac_addr_upper = 0x%x\n", (u32_t)(data->iscsi_mac_addr_upper)));
	STRUCT_PRINT((disp_str,  "iscsi_mac_addr_lower = 0x%x\n", (u32_t)(data->iscsi_mac_addr_lower)));
	STRUCT_PRINT((disp_str,  "fcoe_mac_addr_upper = 0x%x\n", (u32_t)(data->fcoe_mac_addr_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_mac_addr_lower = 0x%x\n", (u32_t)(data->fcoe_mac_addr_lower)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_port_name_upper = 0x%x\n", (u32_t)(data->fcoe_wwn_port_name_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_port_name_lower = 0x%x\n", (u32_t)(data->fcoe_wwn_port_name_lower)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_node_name_upper = 0x%x\n", (u32_t)(data->fcoe_wwn_node_name_upper)));
	STRUCT_PRINT((disp_str,  "fcoe_wwn_node_name_lower = 0x%x\n", (u32_t)(data->fcoe_wwn_node_name_lower)));

	STRUCT_PRINT((disp_str,  "preserve_data = 0x%x\n", (u32_t)(data->preserve_data)));
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_L2_MAC) == MF_FUNC_CFG_PRESERVE_L2_MAC) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_L2_MAC)\n")); 
	}
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_ISCSI_MAC) == MF_FUNC_CFG_PRESERVE_ISCSI_MAC ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_ISCSI_MAC )\n")); 
	}
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_FCOE_MAC) == MF_FUNC_CFG_PRESERVE_FCOE_MAC  ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_FCOE_MAC  )\n")); 
	}
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_FCOE_WWN_P) == MF_FUNC_CFG_PRESERVE_FCOE_WWN_P) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_FCOE_WWN_P)\n")); 
	}
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_FCOE_WWN_N) == MF_FUNC_CFG_PRESERVE_FCOE_WWN_N) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_FCOE_WWN_N)\n")); 
	}
	if ((data->preserve_data & MF_FUNC_CFG_PRESERVE_TX_BW) == MF_FUNC_CFG_PRESERVE_TX_BW     ) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_FUNC_CFG_PRESERVE_TX_BW     )\n")); 
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeFuncExtCfg

/*****************************************************************************

FUNCTION:       DecodeMfCfg

DESCRIPTION:    This routine decode the structure/union struct mf_cfg

IN PARAMETERS:  pointer to struct mf_cfg

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeMfCfg(Tcl_Obj* rc_ptr, const struct mf_cfg * data)
{
	u32_t index, index2;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "shared_mf_config->\n"));
	DecodeSharedMfCfg( rc_ptr, &data->shared_mf_config);

	for (index2 = 0; index2 < (NVM_PATH_MAX); index2++) // array of struct
		for (index = 0; index < (PORT_MAX); index++) // array of struct
		{
			STRUCT_PRINT((disp_str,  "port_mf_config[%d][%d]->\n", index2, index));
			DecodePortMfCfg(rc_ptr, &data->port_mf_config[index2][index]);
		}

	for (index = 0; index < (E1H_FUNC_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "func_mf_config[%d]->\n", index));
		DecodeFuncMfCfg(rc_ptr, &data->func_mf_config[index]);

	}

	for (index = 0; index < (E1H_FUNC_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "func_ext_config[%d]->\n", index));
		DecodeFuncExtCfg(rc_ptr, &data->func_ext_config[index]);

	}

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeMfCfg

/*****************************************************************************

FUNCTION:       DecodeShmemRegion

DESCRIPTION:    This routine decode the structure/union struct shmem_region

IN PARAMETERS:  pointer to struct shmem_region

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeShmemRegion(Tcl_Obj* rc_ptr, const struct shmem_region * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "validity_map[0 .. %d] = \n", (PORT_MAX) - 1));
	for (index = 0; index < (PORT_MAX); index++)  // u32 array 
	{
		STRUCT_PRINT((disp_str,  "validity_map[%d]->0x%08x\n", index, ((u32_t *)data->validity_map)[index]));
	    STRUCT_PRINT((disp_str,  "\tMEM_FORMAT_REV       = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_FORMAT_REV_MASK)>>24));
	    if ((data->validity_map[index] & SHR_MEM_FORMAT_REV_MASK) == SHR_MEM_FORMAT_REV_ID) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_FORMAT_REV_ID)\n")); 
	    }
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_PCI_CFG = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_PCI_CFG)>>20));
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_MB      = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_MB)>>21));
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_DEV_INFO = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_DEV_INFO)>>22));
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_RESERVED = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_RESERVED)>>0));
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_LIC_KEY_IN_EFFECT = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_LIC_KEY_IN_EFFECT_MASK)>>3));
	    if ((data->validity_map[index] & SHR_MEM_VALIDITY_LIC_KEY_IN_EFFECT_MASK) == SHR_MEM_VALIDITY_LIC_MANUF_KEY_IN_EFFECT) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_LIC_MANUF_KEY_IN_EFFECT)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_LIC_KEY_IN_EFFECT_MASK) == SHR_MEM_VALIDITY_LIC_UPGRADE_KEY_IN_EFFECT) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_LIC_UPGRADE_KEY_IN_EFFECT)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_LIC_KEY_IN_EFFECT_MASK) == SHR_MEM_VALIDITY_LIC_NO_KEY_IN_EFFECT) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_LIC_NO_KEY_IN_EFFECT)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_LIC_KEY_IN_EFFECT_MASK) == SHR_MEM_VALIDITY_ACTIVE_MFW_UNKNOWN) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_ACTIVE_MFW_UNKNOWN)\n")); 
	    }
	    STRUCT_PRINT((disp_str,  "\tMEM_VALIDITY_ACTIVE_MFW = 0x%x \n", (u32_t)(data->validity_map[index] & SHR_MEM_VALIDITY_ACTIVE_MFW_MASK)>>6));
	    if ((data->validity_map[index] & SHR_MEM_VALIDITY_ACTIVE_MFW_MASK) == SHR_MEM_VALIDITY_ACTIVE_MFW_IPMI) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_ACTIVE_MFW_IPMI)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_ACTIVE_MFW_MASK) == SHR_MEM_VALIDITY_ACTIVE_MFW_UMP) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_ACTIVE_MFW_UMP)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_ACTIVE_MFW_MASK) == SHR_MEM_VALIDITY_ACTIVE_MFW_NCSI) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_ACTIVE_MFW_NCSI)\n")); 
	    }
	    else if ((data->validity_map[index] & SHR_MEM_VALIDITY_ACTIVE_MFW_MASK) == SHR_MEM_VALIDITY_ACTIVE_MFW_NONE) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(MEM_VALIDITY_ACTIVE_MFW_NONE)\n")); 
	    }
	}
	STRUCT_PRINT((disp_str,  "dev_info->\n"));

	DecodeShmDevInfo( rc_ptr, &data->dev_info);

	for (index = 0; index < (PORT_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "drv_lic_key[%d]->\n", index));

		DecodeLicenseKey(rc_ptr, &data->drv_lic_key[index]);

	}

	STRUCT_PRINT((disp_str,  "fw_info_fio_offset = 0x%x\n", (u32_t)(data->fw_info_fio_offset)));
	STRUCT_PRINT((disp_str,  "mgmtfw_state->\n"));
	DecodeMgmtfwState( rc_ptr, &data->mgmtfw_state);

	for (index = 0; index < (PORT_MAX); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "port_mb[%d]->\n", index));
		DecodeDrvPortMb(rc_ptr, &data->port_mb[index]);

	}

	for (index = 0; index < (4); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "func_mb[%d]->\n", index));
		DecodeDrvFuncMb(rc_ptr, &data->func_mb[index]);

	}

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeShmemRegion

/*****************************************************************************

FUNCTION:       DecodeFwFlrAck

DESCRIPTION:    This routine decode the structure/union struct fw_flr_ack

IN PARAMETERS:  pointer to struct fw_flr_ack

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeFwFlrAck(Tcl_Obj* rc_ptr, const struct fw_flr_ack * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "pf_ack = 0x%x\n", (u32_t)(data->pf_ack)));
	STRUCT_PRINT((disp_str,  "vf_ack[0 .. %d] = ", (1) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", data->vf_ack));
	
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "iov_dis_ack = 0x%x\n", (u32_t)(data->iov_dis_ack)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeFwFlrAck

/*****************************************************************************

FUNCTION:       DecodeFwFlrMb

DESCRIPTION:    This routine decode the structure/union struct fw_flr_mb

IN PARAMETERS:  pointer to struct fw_flr_mb

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeFwFlrMb(Tcl_Obj* rc_ptr, const struct fw_flr_mb * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "aggint = 0x%x\n", (u32_t)(data->aggint)));
	STRUCT_PRINT((disp_str,  "opgen_addr = 0x%x\n", (u32_t)(data->opgen_addr)));
	STRUCT_PRINT((disp_str,  "ack->\n"));
	DecodeFwFlrAck( rc_ptr, &data->ack);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeFwFlrMb

/*****************************************************************************

FUNCTION:       DecodeDcbxEtsFeature

DESCRIPTION:    This routine decode the structure/union struct dcbx_ets_feature

IN PARAMETERS:  pointer to struct dcbx_ets_feature

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDcbxEtsFeature(Tcl_Obj* rc_ptr, const struct dcbx_ets_feature * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "enabled = 0x%x\n", (u32_t)(data->enabled)));
	STRUCT_PRINT((disp_str,  "pg_bw_tbl[0 .. %d] = ", (DCBX_MAX_NUM_PG_BW_ENTRIES) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->pg_bw_tbl)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->pg_bw_tbl)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "\t\""));
	for (index = 0; ((DCBX_MAX_NUM_PG_BW_ENTRIES) & 0x3) ==0 &&index < (DCBX_MAX_NUM_PG_BW_ENTRIES)/sizeof(u32_t); index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->pg_bw_tbl)[index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", (char)(temp>>24), (char)(temp>>16), (char)(temp>>8), (char)temp));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));
	STRUCT_PRINT((disp_str,  "pri_pg_tbl[0 .. %d] = ", (DCBX_MAX_NUM_PRI_PG_ENTRIES) - 1));
	SPECIAL_DBG_PRINT((disp_str,  " (combine u8[] to u32_t[])"));
	for (index = 0; index < (sizeof(data->pri_pg_tbl)+sizeof(u32_t)-1)/sizeof(u32_t); index++)  // array (round to word) 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->pri_pg_tbl)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "\t\""));
	for (index = 0; ((DCBX_MAX_NUM_PRI_PG_ENTRIES) & 0x3) ==0 &&index < (DCBX_MAX_NUM_PRI_PG_ENTRIES)/sizeof(u32_t); index++)  // array 
	{
		u32_t temp;
		temp = ((u32_t *)data->pri_pg_tbl)[index];
		SPECIAL_DBG_PRINT((disp_str,  "%c%c%c%c", (char)(temp>>24), (char)(temp>>16), (char)(temp>>8), (char)temp));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\"\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDcbxEtsFeature

/*****************************************************************************

FUNCTION:       DecodeDcbxPfcFeature

DESCRIPTION:    This routine decode the structure/union struct dcbx_pfc_feature

IN PARAMETERS:  pointer to struct dcbx_pfc_feature

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDcbxPfcFeature(Tcl_Obj* rc_ptr, const struct dcbx_pfc_feature * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "pri_en_bitmap = 0x%x\n", (u32_t)(data->pri_en_bitmap)));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_0            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_0)>>0));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_1            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_1)>>1));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_2            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_2)>>2));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_3            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_3)>>3));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_4            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_4)>>4));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_5            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_5)>>5));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_6            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_6)>>6));
	STRUCT_PRINT((disp_str,  "\tPFC_PRI_7            = 0x%x \n", (u32_t)(data->pri_en_bitmap & DCBX_PFC_PRI_7)>>7));
	STRUCT_PRINT((disp_str,  "pfc_caps = 0x%x\n", (u32_t)(data->pfc_caps)));
	STRUCT_PRINT((disp_str,  "reserved = 0x%x\n", (u32_t)(data->reserved)));
	STRUCT_PRINT((disp_str,  "enabled = 0x%x\n", (u32_t)(data->enabled)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDcbxPfcFeature

/*****************************************************************************

FUNCTION:       DecodeDcbxAppPriorityEntry

DESCRIPTION:    This routine decode the structure/union struct dcbx_app_priority_entry

IN PARAMETERS:  pointer to struct dcbx_app_priority_entry

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDcbxAppPriorityEntry(Tcl_Obj* rc_ptr, const struct dcbx_app_priority_entry * data)
{
	
	indent_level += 1;  // increase indentation for each level of structure decoding

	
    SPECIAL_DBG_PRINT((disp_str,  "app_id = 0x%x\n", ((u32_t)data->app_id)));
	
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "pri_bitmap = 0x%x\n", (u32_t)(data->pri_bitmap)));
	STRUCT_PRINT((disp_str,  "appBitfield = 0x%x\n", (u32_t)(data->appBitfield)));
	STRUCT_PRINT((disp_str,  "\tAPP_ENTRY_VALID      = 0x%x \n", (u32_t)(data->appBitfield & DCBX_APP_ENTRY_VALID)>>0));
	STRUCT_PRINT((disp_str,  "\tAPP_ENTRY_SF         = 0x%x \n", (u32_t)(data->appBitfield & DCBX_APP_ENTRY_SF_MASK)>>4));
	if ((data->appBitfield & DCBX_APP_ENTRY_SF_MASK) == DCBX_APP_SF_ETH_TYPE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(APP_SF_ETH_TYPE)\n")); 
	}
	else if ((data->appBitfield & DCBX_APP_ENTRY_SF_MASK) == DCBX_APP_SF_PORT) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(APP_SF_PORT)\n")); 
	}
	SPECIAL_DBG_PRINT((disp_str, "\"\n"));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDcbxAppPriorityEntry

/*****************************************************************************

FUNCTION:       DecodeDcbxAppPriorityFeature

DESCRIPTION:    This routine decode the structure/union struct dcbx_app_priority_feature

IN PARAMETERS:  pointer to struct dcbx_app_priority_feature

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDcbxAppPriorityFeature(Tcl_Obj* rc_ptr, const struct dcbx_app_priority_feature * data)
{
	u32_t index;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "reserved = 0x%x\n", (u32_t)(data->reserved)));
	STRUCT_PRINT((disp_str,  "default_pri = 0x%x\n", (u32_t)(data->default_pri)));
	STRUCT_PRINT((disp_str,  "tc_supported = 0x%x\n", (u32_t)(data->tc_supported)));
	STRUCT_PRINT((disp_str,  "enabled = 0x%x\n", (u32_t)(data->enabled)));
	STRUCT_PRINT((disp_str,  "enabled = 0x%x\n", (u32_t)(data->enabled)));
	STRUCT_PRINT((disp_str,  "tc_supported = 0x%x\n", (u32_t)(data->tc_supported)));
	STRUCT_PRINT((disp_str,  "default_pri = 0x%x\n", (u32_t)(data->default_pri)));
	STRUCT_PRINT((disp_str,  "reserved = 0x%x\n", (u32_t)(data->reserved)));
	for (index = 0; index < (DCBX_MAX_APP_PROTOCOL); index++) // array of struct
	{

		STRUCT_PRINT((disp_str,  "app_pri_tbl[%d]->\n", index));
		DecodeDcbxAppPriorityEntry(rc_ptr, &data->app_pri_tbl[index]);

	}

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDcbxAppPriorityFeature

/*****************************************************************************

FUNCTION:       DecodeDcbxFeatures

DESCRIPTION:    This routine decode the structure/union struct dcbx_features

IN PARAMETERS:  pointer to struct dcbx_features

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeDcbxFeatures(Tcl_Obj* rc_ptr, const struct dcbx_features * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ets->\n"));
	DecodeDcbxEtsFeature( rc_ptr, &data->ets);

	STRUCT_PRINT((disp_str,  "pfc->\n"));
	DecodeDcbxPfcFeature( rc_ptr, &data->pfc);

	STRUCT_PRINT((disp_str,  "app->\n"));
	DecodeDcbxAppPriorityFeature( rc_ptr, &data->app);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeDcbxFeatures

/*****************************************************************************

FUNCTION:       DecodeLldpParams

DESCRIPTION:    This routine decode the structure/union struct lldp_params

IN PARAMETERS:  pointer to struct lldp_params

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeLldpParams(Tcl_Obj* rc_ptr, const struct lldp_params * data)
{
	int i;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "msg_fast_tx_interval = 0x%x\n", (u32_t)(data->msg_fast_tx_interval)));
	STRUCT_PRINT((disp_str,  "msg_tx_hold = 0x%x\n", (u32_t)(data->msg_tx_hold)));
	STRUCT_PRINT((disp_str,  "msg_tx_interval = 0x%x\n", (u32_t)(data->msg_tx_interval)));
	STRUCT_PRINT((disp_str,  "admin_status = 0x%x\n", (u32_t)(data->admin_status)));
	if ((data->admin_status & 0xFFFFFFFF) == LLDP_TX_ONLY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(TX_ONLY)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_RX_ONLY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RX_ONLY)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_TX_RX) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(TX_RX)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(DISABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "reserved1 = 0x%x\n", (u32_t)(data->reserved1)));
	STRUCT_PRINT((disp_str,  "tx_fast = 0x%x\n", (u32_t)(data->tx_fast)));
	STRUCT_PRINT((disp_str,  "tx_crd_max = 0x%x\n", (u32_t)(data->tx_crd_max)));
	STRUCT_PRINT((disp_str,  "tx_crd = 0x%x\n", (u32_t)(data->tx_crd)));
	STRUCT_PRINT((disp_str,  "admin_status = 0x%x\n", (u32_t)(data->admin_status)));
	if ((data->admin_status & 0xFFFFFFFF) == LLDP_TX_ONLY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(TX_ONLY)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_RX_ONLY) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(RX_ONLY)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_TX_RX) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(TX_RX)\n")); 
	}
	else if ((data->admin_status & 0xFFFFFFFF) == LLDP_DISABLED) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(DISABLED)\n")); 
	}
	STRUCT_PRINT((disp_str,  "msg_tx_interval = 0x%x\n", (u32_t)(data->msg_tx_interval)));
	STRUCT_PRINT((disp_str,  "msg_tx_hold = 0x%x\n", (u32_t)(data->msg_tx_hold)));
	STRUCT_PRINT((disp_str,  "msg_fast_tx_interval = 0x%x\n", (u32_t)(data->msg_fast_tx_interval)));
	STRUCT_PRINT((disp_str,  "tx_crd = 0x%x\n", (u32_t)(data->tx_crd)));
	STRUCT_PRINT((disp_str,  "tx_crd_max = 0x%x\n", (u32_t)(data->tx_crd_max)));
	STRUCT_PRINT((disp_str,  "tx_fast = 0x%x\n", (u32_t)(data->tx_fast)));
	STRUCT_PRINT((disp_str,  "reserved1 = 0x%x\n", (u32_t)(data->reserved1)));
	for (i = 0; i < REM_CHASSIS_ID_STAT_LEN; i++)
	{
		STRUCT_PRINT((disp_str,  "peer_chassis_id[%d] = 0x%x\n", i, (u32_t)(data->peer_chassis_id[i])));
		STRUCT_PRINT((disp_str,  "peer_port_id[%d] = 0x%x\n", i, (u32_t)(data->peer_port_id[i])));
	}
	
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeLldpParams

/*****************************************************************************

FUNCTION:       DecodeLldpAdminMib

DESCRIPTION:    This routine decode the structure/union struct lldp_admin_mib

IN PARAMETERS:  pointer to struct lldp_admin_mib

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeLldpAdminMib(Tcl_Obj* rc_ptr, const struct lldp_admin_mib * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "ver_cfg_flags = 0x%x\n", (u32_t)(data->ver_cfg_flags)));
	STRUCT_PRINT((disp_str,  "\tETS_CONFIG_TX_ENABLED = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_ETS_CONFIG_TX_ENABLED)>>0));
	STRUCT_PRINT((disp_str,  "\tPFC_CONFIG_TX_ENABLED = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_PFC_CONFIG_TX_ENABLED)>>1));
	STRUCT_PRINT((disp_str,  "\tAPP_CONFIG_TX_ENABLED = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_APP_CONFIG_TX_ENABLED)>>2));
	STRUCT_PRINT((disp_str,  "\tETS_RECO_TX_ENABLED  = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_ETS_RECO_TX_ENABLED)>>3));
	STRUCT_PRINT((disp_str,  "\tETS_RECO_VALID       = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_ETS_RECO_VALID)>>4));
	STRUCT_PRINT((disp_str,  "\tETS_WILLING          = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_ETS_WILLING)>>5));
	STRUCT_PRINT((disp_str,  "\tPFC_WILLING          = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_PFC_WILLING)>>6));
	STRUCT_PRINT((disp_str,  "\tAPP_WILLING          = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_APP_WILLING)>>7));
	STRUCT_PRINT((disp_str,  "\tVERSION_CEE          = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_VERSION_CEE)>>8));
	STRUCT_PRINT((disp_str,  "\tVERSION_IEEE         = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_VERSION_IEEE)>>9));
	STRUCT_PRINT((disp_str,  "\tDCBX_ENABLED         = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_DCBX_ENABLED)>>10));
	STRUCT_PRINT((disp_str,  "\tCEE_VERSION          = 0x%x \n", (u32_t)(data->ver_cfg_flags & DCBX_CEE_VERSION_MASK)>>12));
	if ((data->ver_cfg_flags & DCBX_CEE_VERSION_MASK) == DCBX_CEE_MAX_VERSION_MASK) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(CEE_MAX_VERSION_MASK)\n")); 
	}
	STRUCT_PRINT((disp_str,  "features->\n"));
	DecodeDcbxFeatures( rc_ptr, &data->features);

	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeLldpAdminMib

/*****************************************************************************

FUNCTION:       DecodeLldpRemoteMib

DESCRIPTION:    This routine decode the structure/union struct lldp_remote_mib

IN PARAMETERS:  pointer to struct lldp_remote_mib

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeLldpRemoteMib(Tcl_Obj* rc_ptr, const struct lldp_remote_mib * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "prefix_seq_num = 0x%x\n", (u32_t)(data->prefix_seq_num)));
	STRUCT_PRINT((disp_str,  "flags = 0x%x\n", (u32_t)(data->flags)));
	STRUCT_PRINT((disp_str,  "\tETS_TLV_RX           = 0x%x \n", (u32_t)(data->flags & DCBX_ETS_TLV_RX)>>0));
	STRUCT_PRINT((disp_str,  "\tPFC_TLV_RX           = 0x%x \n", (u32_t)(data->flags & DCBX_PFC_TLV_RX)>>1));
	STRUCT_PRINT((disp_str,  "\tAPP_TLV_RX           = 0x%x \n", (u32_t)(data->flags & DCBX_APP_TLV_RX)>>2));
	STRUCT_PRINT((disp_str,  "\tETS_RX_ERROR         = 0x%x \n", (u32_t)(data->flags & DCBX_ETS_RX_ERROR)>>4));
	STRUCT_PRINT((disp_str,  "\tPFC_RX_ERROR         = 0x%x \n", (u32_t)(data->flags & DCBX_PFC_RX_ERROR)>>5));
	STRUCT_PRINT((disp_str,  "\tAPP_RX_ERROR         = 0x%x \n", (u32_t)(data->flags & DCBX_APP_RX_ERROR)>>6));
	STRUCT_PRINT((disp_str,  "\tETS_REM_WILLING      = 0x%x \n", (u32_t)(data->flags & DCBX_ETS_REM_WILLING)>>8));
	STRUCT_PRINT((disp_str,  "\tPFC_REM_WILLING      = 0x%x \n", (u32_t)(data->flags & DCBX_PFC_REM_WILLING)>>9));
	STRUCT_PRINT((disp_str,  "\tAPP_REM_WILLING      = 0x%x \n", (u32_t)(data->flags & DCBX_APP_REM_WILLING)>>10));
	STRUCT_PRINT((disp_str,  "\tREMOTE_ETS_RECO_VALID = 0x%x \n", (u32_t)(data->flags & DCBX_REMOTE_ETS_RECO_VALID)>>12));
	STRUCT_PRINT((disp_str,  "features->\n"));
	DecodeDcbxFeatures( rc_ptr, &data->features);

	STRUCT_PRINT((disp_str,  "suffix_seq_num = 0x%x\n", (u32_t)(data->suffix_seq_num)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeLldpRemoteMib

/*****************************************************************************

FUNCTION:       DecodeLldpLocalMib

DESCRIPTION:    This routine decode the structure/union struct lldp_local_mib

IN PARAMETERS:  pointer to struct lldp_local_mib

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeLldpLocalMib(Tcl_Obj* rc_ptr, const struct lldp_local_mib * data)
{
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "prefix_seq_num = 0x%x\n", (u32_t)(data->prefix_seq_num)));
	STRUCT_PRINT((disp_str,  "error = 0x%x\n", (u32_t)(data->error)));
	STRUCT_PRINT((disp_str,  "\tLOCAL_ETS_ERROR      = 0x%x \n", (u32_t)(data->error & DCBX_LOCAL_ETS_ERROR)>>0));
	STRUCT_PRINT((disp_str,  "\tLOCAL_PFC_ERROR      = 0x%x \n", (u32_t)(data->error & DCBX_LOCAL_PFC_ERROR)>>1));
	STRUCT_PRINT((disp_str,  "\tLOCAL_APP_ERROR      = 0x%x \n", (u32_t)(data->error & DCBX_LOCAL_APP_ERROR)>>2));
	STRUCT_PRINT((disp_str,  "\tLOCAL_PFC_MISMATCH   = 0x%x \n", (u32_t)(data->error & DCBX_LOCAL_PFC_MISMATCH)>>4));
	STRUCT_PRINT((disp_str,  "\tLOCAL_APP_MISMATCH   = 0x%x \n", (u32_t)(data->error & DCBX_LOCAL_APP_MISMATCH)>>5));
	STRUCT_PRINT((disp_str,  "features->\n"));
	DecodeDcbxFeatures( rc_ptr, &data->features);

	STRUCT_PRINT((disp_str,  "suffix_seq_num = 0x%x\n", (u32_t)(data->suffix_seq_num)));
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeLldpLocalMib

void DecodeSwims(Tcl_Obj* rc_ptr, const swim_meta_t *swim_meta, const swim_stack_t *swim_stack, u32 crc_computed, u32 crc_in_scratch) {
	int index;
	int j;

	STRUCT_PRINT((disp_str,  "SWIM section\n"));
	STRUCT_PRINT((disp_str,  "\t\t\t\t"));
	STRUCT_PRINT((disp_str,  "\n\tloaded swim:\t\t"));
	SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(swim_meta->cur_loaded_swim)));
	STRUCT_PRINT((disp_str,  "\n\tswim group:\t\t"));
	SPECIAL_DBG_PRINT((disp_str,  " 0x%08x\n", (u32_t)(swim_meta->swim_group)));
	STRUCT_PRINT((disp_str,  "\tcrc in scratchpad:\t"));
	if (crc_computed == crc_in_scratch) {
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x - OK\n", crc_computed));
	} else {
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x - ERROR!! (expected 0x%08x)\n", crc_computed, crc_in_scratch));
	}
	
	STRUCT_PRINT((disp_str,  "\t-----------------------------------"));
	STRUCT_PRINT((disp_str,  "\n\t\t\t\t"));
	for (index = 1; index < SWIM_MAX; index++)  { // u32 array  
		SPECIAL_DBG_PRINT((disp_str,  " Swim %x    ", index));
	}

	STRUCT_PRINT((disp_str,  "\n\timage_size:\t\t"));
	for (index = 1; index < SWIM_MAX; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(swim_meta->info[index].image_size)));

	STRUCT_PRINT((disp_str,  "\n\ttimes_loaded:\t\t"));
	for (index = 1; index < SWIM_MAX; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(swim_meta->info[index].stat_times_loaded)));

	STRUCT_PRINT((disp_str,  "\n\ttimes_load_not_required:"));
	for (index = 1; index < SWIM_MAX; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(swim_meta->info[index].stat_times_load_not_required)));

	STRUCT_PRINT((disp_str,  "\n\ttimes_load_failed:\t"));
	for (index = 1; index < SWIM_MAX; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(swim_meta->info[index].stat_times_load_failed)));

	STRUCT_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "\t-----------------------------------"));
	for (index = 0; index < NUM_THREADS; index++) {
		STRUCT_PRINT((disp_str,  "\n\tthread %d swim stack:\t", index));
		for (j = 0; j < swim_stack[index].cur_img_stack_id; j++) {
			SPECIAL_DBG_PRINT((disp_str,  " %d ", (u32_t)(swim_stack[index].img_stack[j])));
		}
	}
}


void DecodeScheduler(Tcl_Obj* rc_ptr, const struct multi_thread_t * data, const u32 stack_depth[]) {
	u32_t index;
    int rear, front;
	STRUCT_PRINT((disp_str,  "Scheduler section\n"));
	
	STRUCT_PRINT((disp_str,  "\t\t\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  { // u32 array  
		SPECIAL_DBG_PRINT((disp_str,  " Thread %x  ", index));
	}

	STRUCT_PRINT((disp_str,  "\n\ttotal_cpu_time:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.total_cpu_time)));

	STRUCT_PRINT((disp_str,  "\n\ttimes_in_cpu:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.times_in_cpu)));

	STRUCT_PRINT((disp_str,  "\n\tgoing_to_sleep_count:\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.going_to_sleep_count)));

	STRUCT_PRINT((disp_str,  "\n\twaking_up_count:\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.waking_up_count)));

	STRUCT_PRINT((disp_str,  "\n\tswim_fail_cnt:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.swim_failure_cnt)));

	STRUCT_PRINT((disp_str,  "\n\tswim_fail_timeout_cnt:  "));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stat.swim_failure_timeout_cnt)));

	STRUCT_PRINT((disp_str,  "\n\tcurrentSP:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].current_SP)));

	STRUCT_PRINT((disp_str,  "\n\tStack Depth:\t\t"));
	for (index = 0; index < NUM_THREADS; index++) // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(stack_depth[index])));

	STRUCT_PRINT((disp_str,  "\n\tStack Guard Addr:\t"));
	for (index = 0; index < NUM_THREADS; index++) // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].stack_guard_addr)))


	STRUCT_PRINT((disp_str,  "\n\tstart_time:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].start_time)));

	STRUCT_PRINT((disp_str,  "\n\tstate:\t\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " %10s", ((u32_t)(data->thread[index].state) == SLEEPING) ? "SLEEPING" : 
											   (((u32_t)(data->thread[index].state) == RUNNING)  ? "RUNNING" : "IDLE")));

	STRUCT_PRINT((disp_str,  "\n\twake_up_time:\t\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].sleep_time + data->thread[index].sleep_length)));

	STRUCT_PRINT((disp_str,  "\n\tswim_load_fail_time:\t"));
	for (index = 0; index < NUM_THREADS; index++)  // u32 array 
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", (u32_t)(data->thread[index].swim_load_fail_time)));

	STRUCT_PRINT((disp_str,  "\n\tQueue Front/Rear/Size:\t"));
	for (index = 0; index < NUM_THREADS; index++)  { // u32 array  
               rear = (int)(data->thread[index].queue.rear);
		front = (int)(data->thread[index].queue.front);
		SPECIAL_DBG_PRINT((disp_str,  " %x %x   %04x", rear, front,
				   ((rear - front) < 0) ? (MAX_THREAD_QUEUE - front + rear) :
				   (rear - front)));
        }
	STRUCT_PRINT((disp_str,  "\n\tscheduler - times called = 0x%x \n", (u32_t)(data->sched.stat.times_called)));
	STRUCT_PRINT((disp_str,  "\tscheduler - current thread = 0x%x \n", (u32_t)(data->sched.cur_thread)));
}

/*****************************************************************************

FUNCTION:       DecodeRetainAddr

DESCRIPTION:    This routine decode retain_bitmap_addr in SHMEM

IN PARAMETERS:  

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
#include "nvm_map.h"

void DecodeRetainAddr(Tcl_Obj* rc_ptr, u32_t path, const u32_t * data)
{
    u32_t port, nvm_offset;
	indent_level += 1;  // increase indentation for each level of structure decoding

#define NVM_RETAIN_SET_ADDR(addr)	((NVM_RETAIN_BITMAP(NVM_RETAIN_ADDR_TO_ARR_IDX(addr)) |= (NVM_RETAIN_ADDR_TO_DW_BIT(addr))))
#define NVM_RETAIN_CLEAR_ADDR(addr)	((NVM_RETAIN_BITMAP(NVM_RETAIN_ADDR_TO_ARR_IDX(addr)) &= ~(NVM_RETAIN_ADDR_TO_DW_BIT(addr))))
#define NVM_RETAIN_CHECK_ADDR(addr)	((NVM_RETAIN_BITMAP(NVM_RETAIN_ADDR_TO_ARR_IDX(addr)) & (NVM_RETAIN_ADDR_TO_DW_BIT(addr))))
#define NVM_RETAIN_BITMAP(__idx__) (data[__idx__])
    
	STRUCT_PRINT((disp_str,  "nvm_retain_bitmap[PATH%d][0 .. %d]  = \n", path, PORT_MAX - 1));
     
    for (port = 0; port < PORT_MAX; port++)
    {
        u32_t no_retain_count = 0;
    	STRUCT_PRINT((disp_str,  "\tPORT%x: ", port));
        nvm_offset = NVM_OFFSET_PATH(manuf_info.port_hw_config[port].mac_upper, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset) && NVM_RETAIN_CHECK_ADDR(nvm_offset+ sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "L2 mac "));
        }
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "L2 mac retain err (lo) "));
        }   
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset + sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "L2 mac retain err (hi) "));
        }
        else
            no_retain_count += 1;
        
        nvm_offset = NVM_OFFSET_PATH(manuf_info.port_hw_config[port].iscsi_mac_upper, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset) && NVM_RETAIN_CHECK_ADDR(nvm_offset+ sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "ISCSI mac "));
        }
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "ISCSI mac retain err (lo) "));
        }   
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset + sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "ISCSI mac retain err (hi) "));
        }
        else
            no_retain_count += 1;

        nvm_offset = NVM_OFFSET_PATH(manuf_info.port_hw_config[port].fcoe_fip_mac_upper, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset) && NVM_RETAIN_CHECK_ADDR(nvm_offset+ sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "FIP mac "));
        }
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "FIP mac retain err (lo) "));
        }   
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset + sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "FIP mac retain err (hi) "));
        }
        else
            no_retain_count += 1;

        nvm_offset = NVM_OFFSET_PATH(manuf_info.port_hw_config[port].fcoe_wwn_port_name_upper, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset) && NVM_RETAIN_CHECK_ADDR(nvm_offset+ sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWNN mac "));
        }
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWNN mac retain err (lo) "));
        }   
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset + sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWNN mac retain err (hi) "));
        }
        else
            no_retain_count += 1;

        nvm_offset = NVM_OFFSET_PATH(manuf_info.port_hw_config[port].fcoe_wwn_node_name_upper, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset) && NVM_RETAIN_CHECK_ADDR(nvm_offset+ sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWPN mac "));
        }
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWPN mac retain err (lo) "));
        }   
        else if (NVM_RETAIN_CHECK_ADDR(nvm_offset + sizeof(u32_t)))
        {
            SPECIAL_DBG_PRINT((disp_str,  "WWPN mac retain err (hi) "));
        }
        else
            no_retain_count += 1;

        nvm_offset = NVM_OFFSET_PATH(feature_info.port_feature_config[port].link_config, path);
        if (NVM_RETAIN_CHECK_ADDR(nvm_offset))
        {
            SPECIAL_DBG_PRINT((disp_str,  "LinkCfg "));
        }   
        else
            no_retain_count += 1;

        if (no_retain_count >= 6)
        {
            SPECIAL_DBG_PRINT((disp_str,  "Nothing Retained\n"));
        }
        else
        {
            SPECIAL_DBG_PRINT((disp_str,  "\n"));
        }
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeRetainAddr

void DecodeLfa(Tcl_Obj* rc_ptr, u32_t path, u32_t port, const struct shmem_lfa * data)
{
	char reason[100];
	SPECIAL_DBG_PRINT((disp_str,  "Link Flap Avoidance[%x:%x]:\n", path, port));
	STRUCT_PRINT((disp_str,  "req_duplex = 0x%x \n", (u32_t)data->req_duplex & REQ_DUPLEX_PHY0_MASK));
	STRUCT_PRINT((disp_str,  "req_flow_ctrl = 0x%x \n", (u32_t)data->req_flow_ctrl & REQ_FLOW_CTRL_PHY0_MASK));
	STRUCT_PRINT((disp_str,  "req_line_speed = 0x%x \n", (u32_t)data->req_line_speed & REQ_LINE_SPD_PHY0_MASK));
	STRUCT_PRINT((disp_str,  "speed_cap_mask = 0x%x \n", (u32_t)data->speed_cap_mask[0]));
	STRUCT_PRINT((disp_str,  "req_fc_auto_adv = 0x%x \n", (u32_t)data->additional_config & REQ_FC_AUTO_ADV_MASK));
	STRUCT_PRINT((disp_str,  "no flap due to DCC = 0x%x \n", (u32_t)data->additional_config & NO_LFA_DUE_TO_DCC_MASK));

	STRUCT_PRINT((disp_str,  "Don't clear Stat? = 0x%x \n", (u32_t)((data->lfa_sts & SHMEM_LFA_DONT_CLEAR_STAT) == SHMEM_LFA_DONT_CLEAR_STAT)));
	STRUCT_PRINT((disp_str,  "link_flap_avoidance_count = 0x%x \n", (u32_t)((data->lfa_sts & LINK_FLAP_AVOIDANCE_COUNT_MASK) >> LINK_FLAP_AVOIDANCE_COUNT_OFFSET)));
	STRUCT_PRINT((disp_str,  "link_flap_count = 0x%x \n", (u32_t)((data->lfa_sts & LINK_FLAP_COUNT_MASK) >> LINK_FLAP_COUNT_OFFSET)));
	switch ((u32_t)((data->lfa_sts & LFA_LINK_FLAP_REASON_MASK) >> LFA_LINK_FLAP_REASON_OFFSET)) {
	case   0:
		sprintf(reason, "%s", "No Flap - No Reason");
		break;
	case   LFA_LINK_DOWN:
		sprintf(reason, "%s", "Link Down");
		break;
	case   LFA_DUPLEX_MISMATCH:
		sprintf(reason, "%s", "Duplex mismatch");
		break;
	case   LFA_LOOPBACK_ENABLED:
		sprintf(reason, "%s", "Loopback is enabled");
		break;
	case   LFA_MFW_IS_TOO_OLD:
		sprintf(reason, "%s", "MFW is too old");
		break;
	case   LFA_FLOW_CTRL_MISMATCH:
		sprintf(reason, "%s", "Flow Ctrl Mismatch");
		break;
	case   LFA_SPEED_CAP_MISMATCH:
		sprintf(reason, "%s", "Speed capability mismatch");
		break;
	case   LFA_LINK_SPEED_MISMATCH:
		sprintf(reason, "%s", "Link Speed mismatch");
		break;
	case   LFA_DCC_LFA_DISABLED:
		sprintf(reason, "%s", "No LFA due to DCC clp exit");
		break;
	case   LFA_EEE_MISMATCH:
		sprintf(reason, "%s", "EEE mismatch");
		break;
	default:
		sprintf(reason, "%s", "Unknown reason");
		break;
	}

	STRUCT_PRINT((disp_str,  "link flap reason = %s (%d)\n", reason, ((u32_t)((data->lfa_sts & LFA_LINK_FLAP_REASON_MASK) >> LFA_LINK_FLAP_REASON_OFFSET))));
	
}
/*****************************************************************************

FUNCTION:       DecodeShmem2Region

DESCRIPTION:    This routine decode the structure/union struct shmem2_region

IN PARAMETERS:  pointer to struct shmem2_region

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeShmem2Region(Tcl_Obj* rc_ptr, const struct shmem2_region * data)
{
	u32_t index, expected_size;
	indent_level += 1;  // increase indentation for each level of structure decoding

	STRUCT_PRINT((disp_str,  "size = 0x%x\n", (u32_t)(data->size)));
	STRUCT_PRINT((disp_str,  "dcc_support = 0x%x\n", (u32_t)(data->dcc_support)));
	if ((data->dcc_support & 0xFFFFFFFF) == SHMEM_DCC_SUPPORT_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(DCC_SUPPORT_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "\tDCC_SUPPORT_DISABLE_ENABLE_PF_TLV = 0x%x \n", (u32_t)(data->dcc_support & SHMEM_DCC_SUPPORT_DISABLE_ENABLE_PF_TLV)>>0));
	STRUCT_PRINT((disp_str,  "\tDCC_SUPPORT_BANDWIDTH_ALLOCATION_TLV = 0x%x \n", (u32_t)(data->dcc_support & SHMEM_DCC_SUPPORT_BANDWIDTH_ALLOCATION_TLV)>>2));
	STRUCT_PRINT((disp_str,  "\tDCC_SUPPORT_CHANGE_MAC_ADDRESS_TLV = 0x%x \n", (u32_t)(data->dcc_support & SHMEM_DCC_SUPPORT_CHANGE_MAC_ADDRESS_TLV)>>3));
	STRUCT_PRINT((disp_str,  "\tDCC_SUPPORT_SET_PROTOCOL_TLV = 0x%x \n", (u32_t)(data->dcc_support & SHMEM_DCC_SUPPORT_SET_PROTOCOL_TLV)>>6));
	STRUCT_PRINT((disp_str,  "\tDCC_SUPPORT_SET_PRIORITY_TLV = 0x%x \n", (u32_t)(data->dcc_support & SHMEM_DCC_SUPPORT_SET_PRIORITY_TLV)>>7));
	STRUCT_PRINT((disp_str,  "ext_phy_fw_version2[0 .. %d] = ", (PORT_MAX) - 1));
	for (index = 0; index < (PORT_MAX); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->ext_phy_fw_version2)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "mf_cfg_addr = 0x%x\n", (u32_t)(data->mf_cfg_addr)));
	if ((data->mf_cfg_addr & 0xFFFFFFFF) == SHMEM_MF_CFG_ADDR_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(MF_CFG_ADDR_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "flr_mb->\n"));
	DecodeFwFlrMb( rc_ptr, &data->flr_mb);

	STRUCT_PRINT((disp_str,  "dcbx_lldp_params_offset = 0x%x\n", (u32_t)(data->dcbx_lldp_params_offset)));
	if ((data->dcbx_lldp_params_offset & 0xFFFFFFFF) == SHMEM_LLDP_DCBX_PARAMS_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(LLDP_DCBX_PARAMS_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "dcbx_neg_res_offset = 0x%x\n", (u32_t)(data->dcbx_neg_res_offset)));
	if ((data->dcbx_neg_res_offset & 0xFFFFFFFF) == SHMEM_DCBX_NEG_RES_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(DCBX_NEG_RES_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "dcbx_remote_mib_offset = 0x%x\n", (u32_t)(data->dcbx_remote_mib_offset)));
	if ((data->dcbx_remote_mib_offset & 0xFFFFFFFF) == SHMEM_DCBX_REMOTE_MIB_NONE) 
	{
		STRUCT_PRINT((disp_str,  "\t\t(DCBX_REMOTE_MIB_NONE)\n")); 
	}
	STRUCT_PRINT((disp_str,  "other_shmem_base_addr = 0x%x\n", (u32_t)(data->other_shmem_base_addr)));
	STRUCT_PRINT((disp_str,  "other_shmem2_base_addr = 0x%x\n", (u32_t)(data->other_shmem2_base_addr)));
	STRUCT_PRINT((disp_str,  "mcp_vf_disabled[0 .. %d] = ", (E2_VF_MAX / 32) - 1));
	for (index = 0; index < (E2_VF_MAX / 32); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->mcp_vf_disabled)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "drv_ack_vf_disabled[0 .. %d][0 .. %d]  = ", E2_FUNC_MAX - 1, E2_VF_MAX / 32 - 1));
	for (index = 0; index < (E2_FUNC_MAX)*(E2_VF_MAX / 32); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->drv_ack_vf_disabled)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));



	STRUCT_PRINT((disp_str,  "dcbx_lldp_dcbx_stat_offset = 0x%x\n", (u32_t)(data->dcbx_lldp_dcbx_stat_offset)));
	STRUCT_PRINT((disp_str,  "edebug_driver_if[0 .. %d]  = ",1));
	for (index = 0; index < 2; index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->edebug_driver_if)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));


	STRUCT_PRINT((disp_str,  "nvm_retain_bitmap_addr   = 0x%x\n", (u32_t)(data->nvm_retain_bitmap_addr	)));
	
	STRUCT_PRINT((disp_str,  "swim_base_addr = 0x%x\n", (u32_t)(data->swim_base_addr)));
	STRUCT_PRINT((disp_str,  "swim_funcs = 0x%x\n", (u32_t)(data->swim_funcs)));
	STRUCT_PRINT((disp_str,  "swim_main_cb = 0x%x\n", (u32_t)(data->swim_main_cb)));


	STRUCT_PRINT((disp_str,  "drv_flags = 0x%x\n", (u32_t)(data->drv_flags)));
	STRUCT_PRINT((disp_str,  "extended_dev_info_shared_addr = 0x%x\n", (u32_t)(data->extended_dev_info_shared_addr)));
	STRUCT_PRINT((disp_str,  "ncsi_oem_data_addr = 0x%x\n", (u32_t)(data->ncsi_oem_data_addr)));
	STRUCT_PRINT((disp_str,  "sensor_data_addr = 0x%x\n", (u32_t)(data->sensor_data_addr)));
	STRUCT_PRINT((disp_str,  "buffer_block_addr = 0x%x\n", (u32_t)(data->buffer_block_addr)));
	STRUCT_PRINT((disp_str,  "sensor_data_req_update_interval  = 0x%x\n", (u32_t)(data->sensor_data_req_update_interval )));
	STRUCT_PRINT((disp_str,  "temperature_in_half_celsius = 0x%x\n", (u32_t)(data->temperature_in_half_celsius)));
	STRUCT_PRINT((disp_str,  "glob_struct_in_host = 0x%x\n", (u32_t)(data->glob_struct_in_host)));
	STRUCT_PRINT((disp_str,  "dcbx_neg_res_ext_offset = 0x%x \n", (u32_t)(data->dcbx_neg_res_ext_offset)));


	STRUCT_PRINT((disp_str,  "drv_capabilities_flag[0 .. %d]  = ",E2_FUNC_MAX-1));
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); }
		SPECIAL_DBG_PRINT((disp_str,  "\t0x%08x =>\n", ((u32_t *)data->drv_capabilities_flag)[index]));
	    if (((u32_t *)data->drv_capabilities_flag)[index] & DRV_FLAGS_CAPABILITIES_LOADED_SUPPORTED) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(DRV_FLAGS_CAPABILITIES_LOADED_SUPPORTED)\n")); 
	    }
	    if (((u32_t *)data->drv_capabilities_flag)[index] & DRV_FLAGS_CAPABILITIES_LOADED_L2) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(DRV_FLAGS_CAPABILITIES_LOADED_L2)\n")); 
	    }
	    if (((u32_t *)data->drv_capabilities_flag)[index] & DRV_FLAGS_CAPABILITIES_LOADED_FCOE) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(DRV_FLAGS_CAPABILITIES_LOADED_FCOE)\n")); 
	    }
	    if (((u32_t *)data->drv_capabilities_flag)[index] & DRV_FLAGS_CAPABILITIES_LOADED_ISCSI) 
	    {
		    STRUCT_PRINT((disp_str,  "\t\t(DRV_FLAGS_CAPABILITIES_LOADED_ISCSI)\n")); 
	    }
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));
	STRUCT_PRINT((disp_str,  "extended_dev_info_shared_cfg_size = 0x%x \n", (u32_t)(data->extended_dev_info_shared_cfg_size)));

	STRUCT_PRINT((disp_str,  "dcbx_en[0 .. %d]  = ",(PORT_MAX)-1));
	for (index = 0; index < (PORT_MAX); index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); STRUCT_PRINT((disp_str,  "\t"));}
		SPECIAL_DBG_PRINT((disp_str,  " 0x%08x", ((u32_t *)data->dcbx_en)[index]));
	}
	SPECIAL_DBG_PRINT((disp_str,  "\n"));


	STRUCT_PRINT((disp_str,  "multi_thread_data_offset = 0x%x \n", (u32_t)(data->multi_thread_data_offset)));
	STRUCT_PRINT((disp_str,  "drv_info_host_addr_lo = 0x%x \n", (u32_t)(data->drv_info_host_addr_lo)));
	STRUCT_PRINT((disp_str,  "drv_info_host_addr_hi = 0x%x \n", (u32_t)(data->drv_info_host_addr_hi)));

	STRUCT_PRINT((disp_str,  "drv_info_control = 0x%x \n", (u32_t)(data->drv_info_control)));
	STRUCT_PRINT((disp_str,  "\tVER = 0x%x OP_CODE = %x\n", 
        (u32_t)(data->drv_info_control) & DRV_INFO_CONTROL_VER_MASK, ((u32_t)(data->drv_info_control) & DRV_INFO_CONTROL_OP_CODE_MASK ) >> DRV_INFO_CONTROL_OP_CODE_SHIFT  ));


	STRUCT_PRINT((disp_str,  "ibft_host_addr = 0x%x \n", (u32_t)(data->ibft_host_addr)));
	for (index = 0; index < (PORT_MAX); index++)  // u32 array 
	{
		STRUCT_PRINT((disp_str,  "eee_remote_vals.tx_tw 0x%x\n", (u32_t)(data->eee_remote_vals[index].tx_tw)));
		STRUCT_PRINT((disp_str,  "eee_remote_vals.rx_tw 0x%x\n", (u32_t)(data->eee_remote_vals[index].rx_tw)));
	}

	for (index = 0; index < E2_FUNC_MAX; index++) {
		STRUCT_PRINT((disp_str,  "pf_allocation 0x%x\n", (u32_t)(data->pf_allocation[index])));
	}

	for (index = 0; index < PORT_MAX; index++)  // u32 array 
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); }
		SPECIAL_DBG_PRINT((disp_str,  "\teee_status 0x%08x =>\n", ((u32_t *)data->eee_status)[index]));
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_TIMER_MASK)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_TIMER_MASK)\n"));
		}
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_SUPPORTED_MASK)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_SUPPORTED)\n"));
		}
		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_ADV_STATUS_MASK) >> SHMEM_EEE_ADV_STATUS_SHIFT) == SHMEM_EEE_100M_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_100M_ADV)\n"));
		}
		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_ADV_STATUS_MASK) >> SHMEM_EEE_ADV_STATUS_SHIFT) == SHMEM_EEE_1G_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_1G_ADV)\n"));
		}
		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_ADV_STATUS_MASK) >> SHMEM_EEE_ADV_STATUS_SHIFT) == SHMEM_EEE_10G_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_10G_ADV)\n"));
		}

		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_LP_ADV_STATUS_MASK) >> SHMEM_EEE_LP_ADV_STATUS_SHIFT) == SHMEM_EEE_100M_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_100M_LP_ADV)\n"));
		}
		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_LP_ADV_STATUS_MASK) >> SHMEM_EEE_LP_ADV_STATUS_SHIFT) == SHMEM_EEE_1G_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_1G_LP_ADV)\n"));
		}
		if (((((u32_t *)data->eee_status)[index] & SHMEM_EEE_LP_ADV_STATUS_MASK) >> SHMEM_EEE_LP_ADV_STATUS_SHIFT) == SHMEM_EEE_10G_ADV)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_10G_LP_ADV)\n"));
		}
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_REQUESTED_BIT)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_REQUESTED_BIT)\n"));
		}
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_LPI_REQUESTED_BIT)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_LPI_REQUESTED_BIT)\n"));
		}
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_ACTIVE_BIT)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_ACTIVE_BIT)\n"));
		}
		if (((u32_t *)data->eee_status)[index] & SHMEM_EEE_TIME_OUTPUT_BIT)
		{
			STRUCT_PRINT((disp_str,  "\t\t(SHMEM_EEE_TIME_OUTPUT_BIT)\n"));
		}
	}
	
	STRUCT_PRINT((disp_str,  "sizeof_port_stats = 0x%x \n", (u32_t)(data->sizeof_port_stats)));

	for (index = 0; index < PORT_MAX; index++)  // u32 array 
	{
		STRUCT_PRINT((disp_str,  "lfa_host_addr[%x] = 0x%x \n", index, (u32_t)(data->lfa_host_addr[index])));
	}

	STRUCT_PRINT((disp_str,  "EXTPHY1_TEMP = 0x%x \n", (u32_t)(((data->extphy_temps_in_celsius) & EXTPHY1_TEMP_MASK) >> EXTPHY1_TEMP_SHIFT)));
	STRUCT_PRINT((disp_str,  "ON_BOARD_TEMP = 0x%x \n", (u32_t)(((data->extphy_temps_in_celsius) & ON_BOARD_TEMP_MASK) >> ON_BOARD_TEMP_SHIFT)));
	STRUCT_PRINT((disp_str,  "ocdata_info_addr = 0x%x \n",(u32_t)(data->ocdata_info_addr)));
	STRUCT_PRINT((disp_str,  "drv_func_info_addr = 0x%x \n",(u32_t)(data->drv_func_info_addr)));
	STRUCT_PRINT((disp_str,  "drv_func_info_size = 0x%x \n",(u32_t)(data->drv_func_info_size)));
	for (index = 0; index < PORT_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "link_attr_sync[%x] = 0x%x \n",index, (u32_t)(data->link_attr_sync[index])));
	}
	STRUCT_PRINT((disp_str,  "ibft_host_addr_hi = 0x%x \n",(u32_t)(data->ibft_host_addr_hi)));
	STRUCT_PRINT((disp_str,  "fcode_ver = 0x%x \n",(u32_t)(data->fcode_ver)));
	for (index = 0; index < PORT_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "link_change_count[%x] = %d \n",index, (u32_t)(data->link_change_count[index])));
	}

	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		if ((index & 0x3) ==0){ SPECIAL_DBG_PRINT((disp_str,  "\n")); }
		if (data->func_os_drv_ver[index].versions[DRV_PERS_ETHERNET])
			SPECIAL_DBG_PRINT((disp_str,  "\func_os_drv_ver[%x].DRV_PERS_ETH 0x%x\n", index, data->func_os_drv_ver[index].versions[DRV_PERS_ETHERNET]));
		if (data->func_os_drv_ver[index].versions[DRV_PERS_ISCSI])
			SPECIAL_DBG_PRINT((disp_str,  "\func_os_drv_ver[%x].DRV_PERS_ETH 0x%x\n", index, data->func_os_drv_ver[index].versions[DRV_PERS_ISCSI]));
		if (data->func_os_drv_ver[index].versions[DRV_PERS_FCOE])
			SPECIAL_DBG_PRINT((disp_str,  "\func_os_drv_ver[%x].DRV_PERS_ETH 0x%x\n", index, data->func_os_drv_ver[index].versions[DRV_PERS_FCOE]));
	}

	STRUCT_PRINT((disp_str,  "mfw_drv_indication = 0x%x \n",(u32_t)(data->mfw_drv_indication)));
	STRUCT_PRINT((disp_str,  "oem_i2c_data_addr = 0x%x \n",(u32_t)(data->oem_i2c_data_addr)));
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "c2s_pcp_map_upper[%d] = 0x%x \n",index, (u32_t)(data->c2s_pcp_map_upper[index])));
	}
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "c2s_pcp_map_upper[%d] = 0x%x \n",index, (u32_t)(data->c2s_pcp_map_upper[index])));
	}
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "c2s_pcp_map_default[%d] = 0x%x \n",index, (u32_t)(data->c2s_pcp_map_default[index])));
	}

	for (index = 0; index < PORT_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "fc_npiv_nvram_tbl_addr[%d] = 0x%x \n",index, (u32_t)(data->fc_npiv_nvram_tbl_addr[index])));
	}

	STRUCT_PRINT((disp_str,  "curr_cfg = 0x%x \n",(u32_t)(data->curr_cfg)));
	STRUCT_PRINT((disp_str,  "netproc_fw_ver = 0x%x \n",(u32_t)(data->netproc_fw_ver)));
	STRUCT_PRINT((disp_str,  "clp_ver = 0x%x \n",(u32_t)(data->clp_ver)));
	STRUCT_PRINT((disp_str,  "pcie_bus_num = 0x%x \n",(u32_t)(data->pcie_bus_num)));
	STRUCT_PRINT((disp_str,  "sriov_switch_mode = 0x%x \n",(u32_t)(data->sriov_switch_mode)));
	STRUCT_PRINT((disp_str,  "img_inv_table_addr = 0x%x \n",(u32_t)(data->img_inv_table_addr)));
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		STRUCT_PRINT((disp_str,  "mtu_size[%d] = 0x%x \n",index, (u32_t)(data->mtu_size[index])));
	}
	for (index = 0; index < E2_FUNC_MAX; index++)  // u32 array
	{
		if (data->os_driver_state[index] == OS_DRIVER_STATE_NOT_LOADED)
		{
			STRUCT_PRINT((disp_str,  "os_driver_state[%d] NOT_LOADED\n",index));
		}
		if (data->os_driver_state[index] == OS_DRIVER_STATE_LOADING)
		{
			STRUCT_PRINT((disp_str,  "os_driver_state[%d] OS_DRIVER_STATE_LOADING\n",index));
		}
		if (data->os_driver_state[index] == OS_DRIVER_STATE_DISABLED)
		{
			STRUCT_PRINT((disp_str,  "os_driver_state[%d] OS_DRIVER_STATE_DISABLED\n",index));
		}
		if (data->os_driver_state[index] == OS_DRIVER_STATE_ACTIVE)
		{
			STRUCT_PRINT((disp_str,  "os_driver_state[%d] OS_DRIVER_STATE_ACTIVE\n",index));
		}
	}

	{
		SPECIAL_DBG_PRINT((disp_str,  "\tdrv_info:\n"));
		STRUCT_PRINT((disp_str,  "\tepoc 0x%x\n",(u32_t)(data->drv_info.epoc)));
		STRUCT_PRINT((disp_str,  "\tdrv_ver 0x%x\n",(u32_t)(data->drv_info.drv_ver)));
		STRUCT_PRINT((disp_str,  "\tfw_ver 0x%x\n",(u32_t)(data->drv_info.fw_ver)));
		if ((u32_t)(data->drv_info.valid_dump & FIRST_DUMP_VALID))
			STRUCT_PRINT((disp_str,  "\tFIRST_DUMP_VALID\n"));
		if ((u32_t)(data->drv_info.valid_dump & SECOND_DUMP_VALID))
			STRUCT_PRINT((disp_str,  "\tSECOND_DUMP_VALID\n"));
		STRUCT_PRINT((disp_str,  "\flags 0x%x\n", (u32_t)(data->drv_info.flags)));
	}

    expected_size = OFFSETOF(struct shmem2_region, drv_info) + sizeof(data->drv_info);
    // Following display indicate shmem.h and this decode routine is not in sync
    if (data->size < expected_size)
    {
        STRUCT_PRINT((disp_str,  "Disregard last %x entries !!!\n", (u32_t)((expected_size - data->size)/sizeof(u32_t))));
    }
    else
    {
        while (data->size > expected_size)
        {
            STRUCT_PRINT((disp_str,  "shmem2 + offset(%x) = 0x%x\n", expected_size, ((u32_t *)data)[expected_size/sizeof(u32_t)]));
            expected_size += sizeof(u32_t);
        }
    }
	indent_level = indent_level == 0 ? 0: indent_level-1;  // decrease indentation when exiting each level of structure decoding

}// DecodeShmem2Region

/*****************************************************************************

FUNCTION:       DecodeShmem2Region

DESCRIPTION:    This routine decode the temperature value from shmem2_region

IN PARAMETERS:  pointer to struct shmem2_region

OUT PARAMETERS: none

RETURNS:        none

*****************************************************************************/
void DecodeTemperature(Tcl_Obj* rc_ptr, const struct shmem2_region * data)
{
	STRUCT_PRINT((disp_str,  "temperature_in_half_celsius = 0x%x\n", (u32_t)(data->temperature_in_half_celsius)));	
}// DecodeShmem2Region

// ??????? move following declaration to header file
extern void DecodeDrvPortMb(Tcl_Obj* rc_ptr, const struct drv_port_mb * data);
extern void DecodeDrvFuncMb(Tcl_Obj* rc_ptr, const struct drv_func_mb * data);
extern void DecodeMgmtfwState(Tcl_Obj* rc_ptr, const struct mgmtfw_state * data);
extern void DecodeSharedMfCfg(Tcl_Obj* rc_ptr, const struct shared_mf_cfg * data);
extern void DecodePortMfCfg(Tcl_Obj* rc_ptr, const struct port_mf_cfg * data);
extern void DecodeFuncMfCfg(Tcl_Obj* rc_ptr, const struct func_mf_cfg * data);
extern void DecodeFuncExtCfg(Tcl_Obj* rc_ptr, const struct func_ext_cfg * data);
extern void DecodeMfCfg(Tcl_Obj* rc_ptr, const struct mf_cfg * data);
extern void DecodeShmemRegion(Tcl_Obj* rc_ptr, const struct shmem_region * data);
extern void DecodeFwFlrAck(Tcl_Obj* rc_ptr, const struct fw_flr_ack * data);
extern void DecodeFwFlrMb(Tcl_Obj* rc_ptr, const struct fw_flr_mb * data);
extern void DecodeDcbxEtsFeature(Tcl_Obj* rc_ptr, const struct dcbx_ets_feature * data);
extern void DecodeDcbxPfcFeature(Tcl_Obj* rc_ptr, const struct dcbx_pfc_feature * data);
extern void DecodeDcbxAppPriorityEntry(Tcl_Obj* rc_ptr, const struct dcbx_app_priority_entry * data);
extern void DecodeDcbxAppPriorityFeature(Tcl_Obj* rc_ptr, const struct dcbx_app_priority_feature * data);
extern void DecodeDcbxFeatures(Tcl_Obj* rc_ptr, const struct dcbx_features * data);
extern void DecodeLldpParams(Tcl_Obj* rc_ptr, const struct lldp_params * data);
extern void DecodeLldpAdminMib(Tcl_Obj* rc_ptr, const struct lldp_admin_mib * data);
extern void DecodeLldpRemoteMib(Tcl_Obj* rc_ptr, const struct lldp_remote_mib * data);
extern void DecodeLldpLocalMib(Tcl_Obj* rc_ptr, const struct lldp_local_mib * data);
extern void DecodeShmem2Region(Tcl_Obj* rc_ptr, const struct shmem2_region * data);
extern void DecodeRetainAddr(Tcl_Obj* rc_ptr, u32_t path, const u32_t * data);
extern void DecodeLfa(Tcl_Obj* rc_ptr, u32_t path, u32_t port, const struct shmem_lfa * data);
