/*************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved.
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 ************************************************************************/


/*
 *  Crc calculation stuff.  See crctab.c
 */

extern unsigned short crctab[256] ;

#define updcrc(cp, crc) ( crctab[((crc >> 8) & 255)] ^ (crc << 8) ^ cp)

extern unsigned long cr3tab[] ;

#define UPDC32(b, c) (cr3tab[((int)c ^ b) & 0xff] ^ ((c >> 8) & 0x00FFFFFF))

#define UPD32CRC32(data32, crc) \
                              (UPDC32((u8_t)(((data32)>>0) & 0xff), \
                              (UPDC32((u8_t)(((data32)>>8) & 0xff), \
                              (UPDC32((u8_t)(((data32)>>16) & 0xff),\
                              (UPDC32((u8_t)(((data32)>>24) & 0xff), (crc) \
                              ))))))))
