/****************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of QLogic Corporation. 
 *
 * Name:        hmacsha1.h
 *
 * Description: Compute a secure hash using HMAC-SHA1.
 *  
 * 
 ****************************************************************************/


#ifndef _hmacsha1_h_
#define _hmacsha1_h_

void
hmac_sha1 ( 
    u8_t*    k,     /* secret key */
    u32_t    lk,    /* length of the key in bytes */
    u8_t*    d,     /* data */
    u32_t    ld,    /* length of data in bytes */
    u8_t*    out,   /* output buffer, at least "t" bytes */
    u32_t    t      /* output buffer size */
);

#endif /* _hmacsha1_h_ */
