/****************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of QLogic Corporation. 
 *
 * Name:        print.h  
 *
 * Description: contains system utility declarations.
 *
 *
 ****************************************************************************/
#ifndef _PRINTS_H_
#define _PRINTS_H_

/* bits defined for verbose mode */
#define V_CONSOLE  0x1
#define V_ERR	   0x2
#define V_IO       0x4
#define V_DEBUG    0x8
#define V_PRINTER  0x10
#define V_WARNING  0x20
#define V_SER_PORT 0x40
#define V_BUFFERED 0x80

/* UART buffer */
#define UBUF_BITS          15
#define UBUF_SIZE          (1<<UBUF_BITS)
#define UBUF_MASK          (UBUF_SIZE - 1)
#define UB_ECHO            (1<<0)
#define UB_CRLF            (1<<1)
typedef struct
{
    volatile u32_t head;            /* head, slot to be written */
    volatile u32_t tail;            /* tail, slot to be read */
    volatile u8_t  uberr;           /* a 8-bit error counter */
    volatile u8_t  ubflags;         /* flags */
    volatile u8_t  ubuf[UBUF_SIZE]; /* ring buffer of characters */
    u8_t           ubmagic[4];      /* magic cookie */
} port_buffer_t;

#define UbPlus(a)                 (((a)+1)&UBUF_MASK)
#define UbEmpty(pbuf)             ((pbuf)->head == (pbuf)->tail)
#define UbFull(pbuf)              (UbPlus((pbuf)->head) == (pbuf)->tail)
#define UbRoom(pbuf)              (((pbuf)->tail - (pbuf)->head - 1)&UBUF_MASK)
#define UbUsed(pbuf)              (((pbuf)->head - (pbuf)->tail)&UBUF_MASK)

#endif /* _PRINTS_H_ */
