#include "man_types.h"
#include "dev_if.h"
#include "dbg_man.h"
#include "hw_access.h"
#include "os_types.h"

/*
 *********************************************************************
 Get the latest assert index offset address
 Returns:
 DIAG_STATUS_SUCCESS or DIAG_STATUS_FAILURE
 *********************************************************************
 */
dbg_status_t dbg_assert_get_last_assert_index_offset(
	char*		instance,			/* x (for xsem) or u (for usem) or t (for tsem) or c (for csem)*/
	u32_t*		index_offset_p		/* latest assert index return value */
    )
{
    if ( ! XDBG_CUR_DEV_IS_VALID ) {
        return DBG_STATUS_FAILURE;
    } else {
        dbg_status_t status;
        dev_if_t * cur_dev = XDBG_CUR_DEV_IF;

        /* Read the latest assert index offset address */
        status = dbg_dev_assert_get_last_assert_index_offset(cur_dev, instance, index_offset_p);

        return status;
    }
}
