#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef FREEBSD
#include <malloc.h>
#endif
#include "bcmtype.h"
#include "edebug_types.h"
#include "dbg_os_utils.h"
#include "os_utils.h"
#include "mem_track.h"
#include "dbg_hmem_def.h"
#include "man_types.h"
#include "dev_info.h"
#include "license.h"
#include "shmem.h"
#include "dbg_shmem.h"

u32_t shmem2_has (u32_t addr)
{
	u32_t shmem_size;	

	/* read size of shmem2 */
	shmem2_read(OFFSETOF(struct shmem2_region, size), &shmem_size);

	/* if size larger than field offset, return FALSE */
	if (shmem_size < addr) {
		return 0;
	}
	
	return 1;
}

dbg_status_t shmem2_write (u32_t addr, u32_t val)
{	
	if (shmem2_has(addr)) {
		 dbg_reg_write(XDBG_CUR_DEV->pci_info.shmem_base2 + addr, val);
	}   
        else {
                printf("shmem2 addr does not include field in addr 0x%x\n", addr);
		return DBG_STATUS_FAILURE;
        }

	return DBG_STATUS_SUCCESS;
}

dbg_status_t shmem2_read(u32_t addr, u32_t *val)
{
	/* check if shmem2 has that addr, unless it is the first offset which has size of shmem inside it (to avoid infinite loop) */	
	if (addr) {
		if (!(shmem2_has(addr))) {
			return DBG_STATUS_FAILURE;
		}
	}

	return dbg_reg_read(XDBG_CUR_DEV->pci_info.shmem_base2 + addr, val);
}

dbg_status_t mf_cfg_read(u32_t addr, u32_t *val)
{
	return dbg_reg_read(XDBG_CUR_DEV->pci_info.mf_cfg_base + addr, val);
}
