#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef FREEBSD
#include <malloc.h>
#endif
#include "bcmtype.h"
#include "edebug_types.h"
#include "dbg_os_utils.h"
#include "os_utils.h"
#include "man_types.h"
#include "dev_info.h"
#include "license.h"
#include "shmem.h"
#include "dbg_shmem.h"
#include "dbg_man.h"

dbg_status_t 
dbg_stats_disable(   
    )
{
    dbg_status_t rc;
    u32_t val_to_write;
    
    val_to_write = EDEBUG_DRIVER_IF_OP_CODE_DISABLE_STAT;
    WRITE_TO_DRIVER_LOW(val_to_write);  
    WRITE_TO_DRIVER_HIGH(0);    
    
    return DBG_STATUS_SUCCESS;    
}

dbg_status_t 
dbg_stats_enable(   
    )
{
    dbg_status_t rc;
    u32_t val_to_write;
    
    val_to_write = EDEBUG_DRIVER_IF_OP_CODE_DISABLE_STAT;
    WRITE_TO_DRIVER_LOW(0);  
    WRITE_TO_DRIVER_HIGH(0);    
    
    return DBG_STATUS_SUCCESS;    
}

dbg_status_t 
dbg_stats_show(   
    )
{
    if (! XDBG_CUR_DEV_IS_VALID ) {
        return DBG_STATUS_FAILURE;
    } else {
        dev_if_t * cur_dev = dbg_pci_devices[PF_IDX_BY_HDL(xdbg_cur_dev)].drv_dev_if_p;

        /* if device is hidden, perform indirect reading instead */
        if ( XDBG_CUR_DEV_IS_HIDDEN ) {
            return DBG_STATUS_FAILURE;
        }
        else {
            return dbg_dev_stats_show(cur_dev);
        }
    }
 
}




