#ifndef __DBG_SHMEM_H__
#define __DBG_SHMEM_H__

#include "dbg_shmem.h"

/* Definitions for edebug <-> bnx2x interface */
#define EDEBUG_DRIVER_IF_ACK		 	0
#define EDEBUG_DRIVER_IF_OP_CODE_GET_PHYS_ADDR 	1
#define EDEBUG_DRIVER_IF_OP_CODE_GET_BUS_ADDR 	2
#define EDEBUG_DRIVER_IF_OP_CODE_FREE_PHYS_MEM 	3

#define WRITE_TO_DRIVER_LOW(_val) \
	  shmem2_write(OFFSETOF(struct shmem2_region, edebug_driver_if[1]), (_val))

#define WRITE_TO_DRIVER_HIGH(_val) \
	  shmem2_write(OFFSETOF(struct shmem2_region, edebug_driver_if[0]), (_val))

#define READ_FROM_DRIVER_LOW(_val) \
	  shmem2_read(OFFSETOF(struct shmem2_region, edebug_driver_if[1]), (_val))

#define READ_FROM_DRIVER_HIGH(_val) \
	  shmem2_read(OFFSETOF(struct shmem2_region, edebug_driver_if[0]), (_val))

u32_t shmem2_has (u32_t addr);
dbg_status_t shmem2_write (u32_t addr, u32_t val);
dbg_status_t shmem2_read(u32_t addr, u32_t *val);

#endif /* __DBG_SHMEM_H__ */
