#include <stdlib.h>
#include <string.h>
#include "man_types.h"
#include "bcmtype.h"
#include "edebug_types.h"
#include "dbg_os_utils.h"

void dbg_os_swap_bytes(
					u32_t  *buf,
					u32_t  buf_size
					)
{
	u32_t i;

	for (i=0;i<buf_size/4;i++){
		buf[i] = htonl(buf[i]);
	}

	return;
}

dbg_status_t dbg_os_free_pcontig(
     IN    dbg_virt_addr_t     virt_addr
     )
{
    return os_if_free_pcontig(virt_addr);
}

dbg_status_t dbg_os_unmap_iomem (
        dbg_virt_addr_t virt_addr,
	u32_t            nbytes
        )
{
    return os_if_unmap_iomem(virt_addr, nbytes);
}

dbg_status_t dbg_os_map_iomem (
     IN    u32_t           nbytes,           /* the size of memory in bytes */
     IN    dbg_phys_addr_t     phy_addr,         /* physical address */
     OUT   dbg_virt_addr_t   * virt_addr_p       /* pointer to a virtual address pointer */
     )
{
    return os_if_map_iomem(nbytes,phy_addr, virt_addr_p);
}

void *dbg_os_alloc_virt(
	u32_t size
	)
{ 
	return malloc(size);
}

void dbg_os_free_virt(
	int_ptr_t virt_addr	  
	)
{
	free((void *)virt_addr);
}

void *dbg_os_memset(
	IN   void  * buf,
	IN   u8_t    ch,
	IN   u32_t   buf_size
	)
{
	return memset(buf, ch, buf_size);
}

void *dbg_os_memcpy(
	IN   void   	* dest,
	IN   const void * src,
	IN   u32_t  	  bnum
	)
{
	return memcpy(dest, src, bnum);
}


