#include "man_types.h"
#include "edebug_types.h"
#include "bcmtype.h"
#include "dbg_os_uart.h"
#include "dbg_os_utils.h"
#include "uart.h"

ua_status_t
dbg_os_uart_init(
void
    )
{
        return os_if_uart_init();
}

ua_status_t
dbg_os_uart_open(
    ua_handle_t* h,
    u8_t port,          /* 1 (COM1), 2 (COM2), 3, 4 */
    u32_t baud,         /* 9600, 19200, 38400, 57600, 115200 */
    char* setting,      /* "8N1", "7E1", "8O1" */
    u8_t mode           /* UAM_TEXT, UAM_BINARY */
    )
{
        return os_if_uart_open(h,port,baud,setting,mode);
}

ua_status_t
dbg_os_uart_close(
    ua_handle_t h
    )
{
        return os_if_uart_close(h);
}

ua_status_t
dbg_os_uart_write(
    ua_handle_t h,
    u8_t* buf,
    u16_t len
    )
{
        return os_if_uart_write(h,buf,len);
}

ua_status_t
dbg_os_uart_read(
    ua_handle_t h,
    u8_t* buf,
    u16_t len,
    u16_t* outlen
    )
{
        return os_if_uart_read(h,buf,len,outlen);
}

ua_status_t
dbg_os_uart_flush(
    ua_handle_t h,
    u16_t to_sec
    )
{
        return os_if_uart_flush(h,to_sec);
}

