#ifndef __DBG_MEM_TRACK_H__
#define __DBG_MEM_TRACK_H__

#ifndef __LINUX
#include <stdlib.h>
#endif
// #include "/home/barak/workspaces/main1/drivers/common/include/listq.h"
#include "listq.h"
#include "bcmtype.h"
#include "os_types.h"

/* Memory allocation types */
typedef u16_t  mem_type_t;
#define MEM_NONE                       0   /* None */
#define MEM_VIRT                       1   /* Virtual */
#define MEM_PHYS                       2   /* Physical */
#define MEM_MAPPED                     3   /* Mapping physical into user (virtual) address space */

#define START_SIG_VAL        0x4D535441  /* "MSTA" */
#define END_SIG_VAL          0x4D454E44  /* "MEND" */
#define SIG_SZ               4
#define MEM_TRACK_START_SIG(e)         *((u32_t*)(((u8_t*)(e)) - SIG_SZ))
#define MEM_TRACK_END_SIG(e, size)           *((u32_t*)(((u8_t*)(e)) + size))

#define MEM_TRACK_TCL_ALLOC_LEVEL      "Tcl"
#define MEM_TRACK_DRIVER_ALLOC_LEVEL   "driver"
#define MEM_TRACK_DBG_ALLOC_LEVEL     "edebug"

typedef struct _mem_track_entry_t {
    d_list_entry_t link;
    void * virt_addr;
    size_t  size;
    struct { 
        u8_t * level;  /* Allocation level: Tcl, driver, manager, etc. */
        u8_t * func;   /* Function name */
        u32_t  line;   /* line number */
    } alloc_info;
} mem_track_entry_t;

typedef struct {
    mem_track_entry_t * track_entry;
    u32_t size;
    dbg_phys_addr_t phys_addr;  /* Actual physical address */
    dbg_phys_addr_t bus_addr;   /* PCI bus mapping */
    u8_t type;
    u8_t pad[3];   /* padding */
    void * start_addr; /* Needed to guaranty there is a DWORD before 
                          aligned data buffer (phys. buf case) */
    u32_t start_sig;
} mem_entry_t;

#endif /* __DBG_MEM_TRACK_H__ */
