#ifndef __EDEBUG_OS_TYPES_H__
#define __EDEBUG_OS_TYPES_H__

#include "bcmtype.h"
#include "edebug_types.h"

typedef u32_t (* cb_t)(void*);

#if defined(PPC64) || defined(LLP64) || defined(IA64) || defined(UEFI64) || defined(X86_64) || defined(_WINDOWS) || defined(SPARCV9)
typedef u64_t dbg_virt_addr_t;
typedef u64_t dbg_phys_addr_t;
#else
typedef u32_t dbg_virt_addr_t;
typedef u32_t dbg_phys_addr_t;
#endif

#define MAC_ADDR_LEN 18

#define IS_EVEREST(_x) ((_x.vendor_id == BROADCOM_VID) &&               \
                        ((_x.device_id == CHIP_NUM_5710) ||           \
                         (_x.device_id == CHIP_NUM_5711) ||           \
                         (_x.device_id == CHIP_NUM_5711E) ||          \
                         (_x.device_id == CHIP_NUM_5712) ||			\
                         (_x.device_id == CHIP_NUM_5712E) ||			\
                         (_x.device_id == CHIP_NUM_5713) ||			\
                         (_x.device_id == CHIP_NUM_5713E) ||			\
                         (_x.device_id == CHIP_NUM_57800) ||			\
                         (_x.device_id == CHIP_NUM_57810) ||			\
                         (_x.device_id == CHIP_NUM_57840_OBSOLETE) ||		\
                         (_x.device_id == CHIP_NUM_57840_MF_OBSOLETE) ||	\
                         (_x.device_id == CHIP_NUM_57840_4_10) ||		\
                         (_x.device_id == CHIP_NUM_57840_2_20) ||		\
                         (_x.device_id == CHIP_NUM_57800_MF) ||			\
                         (_x.device_id == CHIP_NUM_57810_MF) ||			\
                         (_x.device_id == CHIP_NUM_57840_MF) ||			\
                         (_x.device_id == CHIP_NUM_57811) || \
                         (_x.device_id == CHIP_NUM_57811_MF) || \
                         (_x.device_id == CHIP_NUM_57811_VF) || \
                         (_x.device_id ==DEVICE_ID_STILL_UNKNOWN)))

#define IS_EVEREST_ID(_x)										\
                        ((_x == CHIP_NUM_5710) ||				\
                         (_x == CHIP_NUM_5711) ||				\
                         (_x == CHIP_NUM_5711E) ||			\
                         (_x == CHIP_NUM_5712) ||				\
                         (_x == CHIP_NUM_5712E) ||				\
                         (_x == CHIP_NUM_5713) ||				\
                         (_x == CHIP_NUM_5713E) ||				\
                         (_x == CHIP_NUM_57800) ||				\
                         (_x == CHIP_NUM_57810) ||				\
                         (_x == CHIP_NUM_57800_MF) ||				\
                         (_x == CHIP_NUM_57810_MF) ||				\
                         (_x == CHIP_NUM_57840_MF) ||				\
                         (_x == CHIP_NUM_57840) || \
                         (_x == CHIP_NUM_57811) || \
                         (_x == CHIP_NUM_57811_MF) || \
                         (_x == CHIP_NUM_57811_VF))


#define ETH_D0 0
#define ETH_D1 1
#define ETH_D2 2
#define ETH_D3 3

typedef struct
{
        u32_t vendor_id;
        u32_t device_id;
        u32_t irq;
        u64_t region0_base_addr;
        u32_t region0_size;
        u64_t region2_base_addr;
        u32_t region2_size;
        u32_t shmem_base;
        u32_t shmem_base2;
        u32_t mf_cfg_base;
        u32_t pci_domain;
        u32_t pci_bus;
        u32_t pci_device;
        u32_t pci_func;
        char pcie_lane_width[8];
        char pcie_lane_speed[16];
        u32_t total_vfs;
        u32_t first_vf_offset;
        u32_t vf_stride;
        char mac_addr[MAC_ADDR_LEN+1];
        char pxe_speed[20];
        u32_t pxe_enable;
        char pxe_agent;
        u32_t wol_enable;
        u32_t mfw_enable;
        u32_t port_id;
        char asic_rev[8];
        char revision[8];
        char serial_number[20];
        char eth_name[256];
        u32_t eth_state;
        char driver_name[40];
        char driver_ver[40];
        char bc_ver[40];
        char fw_ver[40];
        u32_t path_num;
        u32_t device_num_in_path;
        u32_t device_num_in_port;
        u32_t device_num;
        u32_t svid;
} pci_info_t;

#endif
