
/****************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of QLogic Corporation. 
 *
 * Name:        uart.h
 *
 * Description: UART driver interface
 *  
 ****************************************************************************/
#ifndef _DBG_UART_H_
#define _DBG_UART_H_

#include "bcmtype.h"
#include "dbg_os_uart.h"
#include "disputil.h"



/*
 * functions prototype
 */
ua_status_t
os_if_uart_init(
    void
    );

ua_status_t
os_if_uart_open(
    ua_handle_t* h,
    u8_t port,          /* 1 (COM1), 2 (COM2), 3, 4 */
    u32_t baud,         /* 9600, 19200, 38400, 57600, 115200 */
    char* setting,      /* "8N1", "7E1", "8O1" */
    u8_t mode           /* UAM_TEXT, UAM_BINARY */
    );

ua_status_t
os_if_uart_close(
    ua_handle_t h
    );

ua_status_t
os_if_uart_write(
    ua_handle_t h,
    u8_t* buf,
    u16_t len
    );

ua_status_t
os_if_uart_read(
    ua_handle_t h,
    u8_t* buf,
    u16_t len,
    u16_t* outlen
    );

/**
 * Flushes up to max_buf_size of the read buffer.
 */ 
void os_if_uart_flush_rb(
    IN    ua_handle_t   h,
    IN    u32_t         max_buf_size
    );

ua_status_t
os_if_uart_flush(
    ua_handle_t h,
    u16_t to_sec
    );

#endif /* _DBG_UART_H_ */
