
/****************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of QLogic Corporation. 
 *
 * Name:        disputil.h
 * 
 * 
 ****************************************************************************/
#ifndef _DBG_DISPUTIL_H_
#define _DBG_DISPUTIL_H_

#include "bits.h"
#include "bcmtype.h"

#define DISP_BYTE_SWAP BIT_0
#define DISP_WORD_SWAP BIT_1

#define MAX_PRINTF_BUFFER       16384
#define MAX_AUXPRINTF_BUFFER    2048


#define BYTES_PER_8BIT_SEGMENT   4
#define BYTES_PER_8BIT_LINE     16
#define SEGMENTS_PER_8BIT_LINE   4
#define BYTES_PER_32BIT_LINE    32
#define CHARS_PER_LINE          80

void
disp_32bit_array(
    u32_t     *array,
    int_ptr_t start_addr,
    u32_t     count,
    u8_t      swap
    );

void
disp_8bit_array(
    u8_t      *array,
    int_ptr_t  start_addr,
    u32_t      count
    );

#endif /* _DBG_DISPUTIL_H_ */
