#ifndef __EDEBUG_TYPES_H__
#define __EDEBUG_TYPES_H__

#include "bcmtype.h"
#include "os_types.h"

#ifdef _WINDOWS
#include <WinSock.h>
#endif

#define MAX_PATH_NUM NVM_PATH_MAX

#define U64_LO(x)			(u32)(((u64)(x)) & 0xffffffff)
#define U64_HI(x)			(u32)(((u64)(x)) >> 32)
#define HILO_U64(hi, lo)		((((u64)(hi)) << 32) + (lo))

#ifndef NULL
#define NULL 0
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

typedef u32_t dbg_status_t;
#define DBG_STATUS_SUCCESS             0
#define DBG_STATUS_FAILURE            -1     /* General failure */
#define DBG_STATUS_RESOURCE           -2     /* Memory failure  */
#define DBG_STATUS_ACCESS             -3     /* Access failure  */
#define DBG_STATUS_INVALID_PARAMETER  -4     /* Invalid parameters  */
#define DBG_STATUS_PENDING            -5     /* Pending for l2pkt loopback to complete */
#define DBG_STATUS_NVM_INVAL_DIR      -6     /* Invalid directory index */
#define DBG_STATUS_NVM_BAD_VALUE      -7     /* Bogus value */
#define DBG_STATUS_TIMEOUT            -8     /* Timeout */
#define DBG_STATUS_CON_CLOSED         -9     /* Connection closed */
#define DBG_STATUS_ABORTED            -10    /* Packet aborted */
#define DBG_STATUS_UPLOAD_IN_PROGRESS -11    /* Upload in progress */

#endif
