#ifndef _DBG_UTIL_H_
#define _DBG_UTIL_H_

#include "dbu_reg_Driver.h"

#ifndef TRUE
  #define TRUE  1
  #define FALSE 0
#endif

#ifndef MIN
   #define MIN(x,y) ((x)<(y)?(x):(y))
#endif

/*
ARRSIZE:
used to calcualte item count of an array
this macro is used to prevent compile warning for unreferenced parametes
*/
#ifndef ARRSIZE
#define ARRSIZE(a)                   (sizeof(a)/sizeof((a)[0]))
#endif // ARRSIZE



#define BYTE_SWAP(w)    ( (((w) & 0xff000000) >> 24) |   \
                          (((w) & 0x00ff0000) >> 8)  |   \
                          (((w) & 0x0000ff00) << 8)  |   \
                          (((w) & 0x000000ff) << 24) )

#define BYTE_SWAP16(w)  ( (((w) & 0xff00) >> 8) |   \
                          (((w) & 0x00ff) << 8)     )

#ifdef PPC64
 #define BMAPI_BENDIAN_SWAP_S(w)   ((((w) & 0xff00) >> 8) | (((w) & 0x00ff) << 8))
 #define BMAPI_BENDIAN_SWAP(w) BYTE_SWAP(w)
 #define BMAPI_LENDIAN_SWAP_S(x) (x)
#else
 #define BMAPI_BENDIAN_SWAP_S(w) (w)
 #define BMAPI_BENDIAN_SWAP(w) (w)
 #define BMAPI_LENDIAN_SWAP_S(x) (u16_t)((((x) >> 8) & 0xff) | (((x) << 8) & 0xff00))
#endif

#define MOREOF(a,b) ((a)>(b)?(a):(b))
#define LESSOF(a,b) ((a)<(b)?(a):(b))

#define DWORD_ADDR_MASK32               (u32_t)0xfffffffc     
#define DWORD_ADDR_MASK64               (u64_t)0xfffffffffffffffc     
#define WORD_ADDR_MASK32                (u32_t)0xfffffffe 
#define WORD_ADDR_MASK64                (u64_t)0xfffffffffffffffe
#define DWORD_ADDR_MASK_PTR             (~((int_ptr_t)0x3))

/* Round a 32bit value up to 4 aligned value */
#define ALIGN_UP4_32(addr)              (((addr) + 3) & DWORD_ADDR_MASK32)
/* Round a 64bit value up to 4 aligned value */
#define ALIGN_UP4_64(addr)              (((addr) + 3) & DWORD_ADDR_MASK64)
/* Round a pointer up to 4 aligned value */
#define ALIGN_UP4_PTR(addr)              (((int_ptr_t)(addr) + 3) & DWORD_ADDR_MASK_PTR)
/* Round a 32bit value down to 4 aligned value */
#define ALIGN_DOWN4_32(addr)             ((addr) & DWORD_ADDR_MASK32)
/* Round a 64bit value down to 4 aligned value */
#define ALIGN_DOWN4_64(addr)             ((addr) & DWORD_ADDR_MASK64)
/* Round a pointer down to 4 aligned value */
#define ALIGN_DOWN4_PTR(addr)             ((addr) & DWORD_ADDR_MASK_PTR)


#define LONG_ADDR(low_addr, high_addr)  \
   ((( (u64_t)(high_addr) << 32 )  & 0xffffffff00000000LL) | ((u64_t)(low_addr) & 0xffffffffLL))


#define PTR_SUB(_a, _b)     ((u8_t *) (_a) - (u8_t *) (_b))
#ifndef OFFSETOF
#ifdef __SunOS
#include <stddef.h>
#define OFFSETOF(_s, _m) offsetof(_s, _m)
#else
#define OFFSETOF(_s, _m)    ((u32_t) PTR_SUB(&((_s *) 0)->_m, (u8_t *) 0))
#endif
#endif

#define BYTE_0(val)		 (val & 0x000000ff)
#define BYTE_1(val)		((val & 0x0000ff00) >> 8)
#define BYTE_2(val)     ((val & 0x00ff0000) >> 16)
#define BYTE_3(val)     ((val & 0xff000000) >> 24)

#define WORD_LSB(val)     (val & 0x0000ffff)
#define WORD_MSB(val)    ((val & 0xffff0000) >> 16)

#endif /* _DBG_UTIL_H_ */
