#ifndef __TCL_AL_H__
#define __TCL_AL_H__

#include "edebug_types.h"
#include "tcl.h"

#include "tcl_util.h"

#define MAX_USAGE_LEN	(1024*6)
#define SPECIAL_LOG_FILE "/root/tmp/special_log_file.txt"

dbg_status_t tcl_al_dbg_init(Tcl_Interp* in_interp, edebug_eng_mode_t eng_mode);

int Tcl_AppInit(Tcl_Interp *interp);

void tcl_al_reinit_non_pci_mode(Tcl_Interp *interp, int com_num, int baud_rate);

void tcl_al_dbg_cleanup(
    IN   ClientData clientData  /* A data this handler was registered with */
    );

u32_t tcl_al_get_no_pci_mode();

/*
 * The help callback function per command node
 */
typedef int (*help_callback_t)(
    char* buf,   
    u32_t* len
    );

/* our commands */
#define HEX_CMD			"hex"
#define STATS_CMD       "stats"
#define HMEM_CMD        "hmem"
#define DEVICE_CMD      "device"
#define REG_CMD         "reg"
#define PCICFG_CMD      "pcicfg"
#define ASSERT_CMD      "assert"
#define ADD_HELP_CMD    "add_help"
#define VERSION_CMD		"version"
#define MCP_CMD	        "mcp"
#define SERPORT_CMD     "serialport"
#define HELP_CMD	    "help"
#define ADD_HELP_CMD	"add_help"
#define NVM_CMD         "nvm"
#define NVM_LOAD        "nvmcfgT::nvm_load"
#define NVM_STORE		"nvmcfgT::nvm_store"
#define NVM_FREE_STRUCTS "nvmcfgT::nvm_free_structs"
#define NVM_GET_BITS    "nvmcfgT::nvm_get_bits"
#define NVM_SET_BITS    "nvmcfgT::nvm_set_bits"
#define NVM_CFG			"nvmcfgT::nvm_cfg"
#define NVM_CHK			"nvmcfgT::nvm_chk"
#define NVM_SHOW_OFFSET "nvmcfgT::nvm_show_offset"
#define SHMEM_SHOW_OFFSET "nvmcfgT::shmem_show_offset"
#define GETC			"getc"
#define ELINK_CMD 		"elink"
#define VPD_CMD         "vpd"
#define LOG_CMD         "log"
#endif


