
/****************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without 
 * the prior written consent of QLogic Corporation. 
 *
 * Name:        firmware.h
 *
 * Description: Load/Save firmware functions.
 * 
 ****************************************************************************/

#ifndef _DBG_TCL_FIRMWARE_H_
#define _DBG_TCL_FIRMWARE_H_

#include "bcmtype.h"



#ifdef __cplusplus
extern "C" 
{
#endif



/******************************************************************************/
/* firmware data structure. */
/******************************************************************************/

typedef struct firmware
{
    u32_t     ver_major;
    u32_t     ver_minor;
    u32_t     ver_fix;
    u32_t     start_addr;
    u32_t     text_addr;
    u32_t     text_len;
    u32_t*    text;
    u32_t     text_index;
    u32_t     rodata_addr;
    u32_t     rodata_len;
    u32_t*    rodata;
    u32_t     rodata_index;
    u32_t     data_addr;
    u32_t     data_len;
    u32_t*    data;
    u32_t     data_index;
    u32_t     sbss_addr;
    u32_t     sbss_len;
    u32_t*    sbss;
    u32_t     sbss_index;
    u32_t     bss_addr;
    u32_t     bss_len;
    u32_t*    bss;
    u32_t     bss_index;
    u32_t     sdata_addr;
    u32_t     sdata_len;
    u32_t*    sdata;
    u32_t     sdata_index;
} firmware_t;


#ifdef __cplusplus
};
#endif



#endif  // _DBG_TCL_FIRMWARE_H_
