/*************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved.
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 *
 *  Name: fmac.h
 *
 *  Description: Handling of MAC addresses from a file for manuf 
 ****************************************************************************/
#ifndef DBG_TCL_FMODELS__
#define DBG_TCL_FMODELS__


#include "bcmtype.h"

#define REVISION     		"revision"
#define WARNING_MESSAGE     "message"

#ifndef F_OK
#define F_OK 00
#endif
#ifndef X_OK
#define X_OK 01
#endif
#ifndef W_OK
#define W_OK 02
#endif
#ifndef R_OK
#define R_OK 04
#endif

// Support maximum number of modules per vendor (32)
#define MAX_VENDOR_MODULES		32
#define MAX_PORT_NUM			16
#define DEFAULT_MESSAGE			"This is the default message"

#define PRINT_MSG printf
#define dg_os_free_virt free
#define dg_os_alloc_virt malloc

/*
 * read_fmac: 
 * input: specify the name of the file that contains the allowed modules and part numbers.
 * return: NULL on error; otherwise, a handle used for other operations.
 */
void *tcl_al_read_fmodules(
    char *filename,
	u32_t *byte_read
    );

int tcl_al_write_fmodules(
	char *filename, 
	u8_t *buf
	);

#endif /* DBG_TCL_FMODELS__*/
