/*************************************************************************
 * Copyright(c) 2011-2014 Broadcom Corporation, all rights reserved.
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved.
 * Contains proprietary and confidential information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 *
 *  Name: fmac.h
 *
 *  Description: Handling of MAC addresses from a file for manuf 
 ****************************************************************************/

#include "bcmtype.h"

#define MAX_VPD_R_SIZE 512
#define VPD_ID_TAG_MAX_LEN   13
#define VPD_TAG_NAME_MAX_LEN 2
#define VPD_TAG_DATA_MAX_LEN 250
#define VPD_PRODUCT_NAME_MAX_LEN 80
#define VPD_TYPE_MAX_LEN    13
#define MAX_VPD_TAG         20


typedef struct _vpd_tag_info_t
{
    char tag_name[VPD_TAG_NAME_MAX_LEN+1];
    u8_t tag_len;
    char tag_data[VPD_TAG_DATA_MAX_LEN+1];
} vpd_tag_info_t;

typedef struct _vpd_table_t
{
    char    product_name[VPD_PRODUCT_NAME_MAX_LEN+1];
    u16_t   product_name_len;
    u32_t   no_tags;
    u16_t   vpd_len;
    vpd_tag_info_t vpd_tags[MAX_VPD_TAG];

} vpd_table_t;

/*
 * read_fmac: 
 * input: specify the name of the file that contains the allowed modules and part numbers.
 * return: NULL on error; otherwise, a handle used for other operations.
 */
void *tcl_al_read_vpd_text_file(
    char *filename, 
    u32_t *byte_read
    );


int tcl_al_write_vpd_text_file(
    char *filename, 
    u8_t *buf,
    u32_t size
    );

int tcl_al_get_vpd_r_size(
    char *line, 
    u32_t *size
    );
