#ifndef __DBG_DEVICE_IF_H__
#define __DBG_DEVICE_IF_H__

#include <stdio.h>
#include <sys/ioccom.h>

struct os_params
{
    u64_t reg_bar_address;
    u32_t reg_bar_size;
    int br_idx;
    char eth_name[20];
    int geeprom_length;
    int ioctl_fd;
};

/* everything below redifined from bxe.h */

/* IOCTL sub-commands for edebug and firmware upgrade */
#define BXE_IOC_RD_NVRAM        1
#define BXE_IOC_WR_NVRAM        2
#define BXE_IOC_STATS_SHOW_NUM  3
#define BXE_IOC_STATS_SHOW_STR  4
#define BXE_IOC_STATS_SHOW_CNT  5

struct bxe_nvram_data
{
    u32_t op; /* ioctl sub-command */
    u32_t offset;
    u32_t len;
    u32_t value[1]; /* variable */
};

union bxe_stats_show_data
{
    u32_t op; /* ioctl sub-command */

    struct
    {
        u32_t num; /* return number of stats */
        u32_t len; /* length of each string item */
    } desc;

    /* variable length... */
    char str[1]; /* holds names of desc.num stats, each desc.len in length */

    /* variable length... */
    u64_t stats[1]; /* holds all stats */
};

#endif

