
/****************************************************************************
 * Copyright(c) 2011-2012 Broadcom Corporation, all rights reserved
 * Copyright(c) 2014-2015 QLogic Corporation, all rights reserved
 * Proprietary and Confidential Information.
 *
 * This source file is the property of QLogic Corporation, and
 * may not be copied or distributed in any isomorphic form without
 * the prior written consent of QLogic Corporation.
 *
 * Name:        uart_var.h
 *
 * Description: UART driver structures and constants definition.
 *
 ****************************************************************************/

#ifndef _DBG_UART_VAR_H_
#define _DBG_UART_VAR_H_

#include "bcmtype.h"

/* per port structure to hold protocol info */
typedef struct
{
    u8_t  mode; /* UAM_BINARY, UAM_TEXT */
    u8_t  data_nbits;
    char  parity;
    u8_t  stop_nbits;
    u32_t baud;
} port_proto_t;

/* master per port structure */
typedef struct
{
    int          uart_fd;
    int          speed;
    int          initialized;
    port_proto_t proto;
    u8_t         mode;
} port_t;

#endif /* _DBG_UART_VAR_H_ */
