#include <unistd.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <time.h>
#include "man_types.h"
#include "edebug_types.h"
#include "bcmtype.h"

/* FW declaration */
void os_if_usleep(
     IN    u32_t           cnt
     );


void os_if_msleep(
     IN    u32_t           cnt
     )
{
	os_if_usleep(cnt*1000);
}

void os_if_usleep(
     IN    u32_t           cnt
     )
{
        if (cnt) {
		unsigned int sec  = cnt / 1000000;
		unsigned long usec = cnt % 1000000;
		struct timespec req = {
		       .tv_sec  = sec,        /* seconds */
		       .tv_nsec = usec * 1000 /* nanoseconds */
		   }, rem;

		while (nanosleep(&req, &rem)) {
			req = rem;
		}
	}
}
