#include <stdio.h>
#include "edebug_types.h"
#include "bcmtype.h"
#include "os_utils.h"

int last_msg_len = 0;

void os_if_change_color(
    IN    u8_t color,        /* Color to set */
    IN    u8_t fore_or_back  /* Forground or background */
    )
{
        fprintf(stdout, "\x1b\[%u%um", fore_or_back, color);
        fflush(stdout);
}

void os_if_restore_color(void)
{
    fprintf(stdout, "\x1b\[0m");
	fflush(stdout);
}

char os_if_getch(void)
{
	int ch = -1;

	while (ch == -1) {
		ch = getchar();
	}

	return ch;
}

void os_if_save_cursor(void)
{
	last_msg_len = 0;    
}

void os_if_restore_cursor(void)
{
	int i;
	for (i = 0; i < last_msg_len; i++)
	{
		fprintf(stdout, "\b");	
	}
    fflush(stdout);
}

void os_if_print(char *buf, u16_t len)
{
	last_msg_len = len;
	fprintf(stdout, "%s", buf);
    fflush(stdout);
}

FILE* os_if_log_fopen(const char *file_name)
{
	return fopen(file_name, "a");
}
